-- phpMyAdmin SQL Dump
-- version 3.2.0.1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: May 04, 2010 at 08:36 AM
-- Server version: 5.1.37
-- PHP Version: 5.3.0

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `medresalabs`
--

-- --------------------------------------------------------

--
-- Table structure for table `advertisement`
--

CREATE TABLE IF NOT EXISTS `advertisement` (
  `adv_id` bigint(20) NOT NULL,
  `adv_title` varchar(255) NOT NULL,
  `adv_attachment` text NOT NULL,
  `adv_content` longtext NOT NULL,
  `adv_host` bigint(20) NOT NULL,
  `adv_url` text NOT NULL,
  `adv_date_start` datetime NOT NULL,
  `adv_date_end` datetime NOT NULL,
  `adv_position` varchar(255) NOT NULL,
  `adv_click_count` bigint(20) NOT NULL,
  PRIMARY KEY (`adv_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `answer`
--

CREATE TABLE IF NOT EXISTS `answer` (
  `users_id` bigint(20) NOT NULL,
  `questions_id` bigint(20) NOT NULL,
  `answer` varchar(500) NOT NULL,
  `module_id` bigint(20) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `comment`
--

CREATE TABLE IF NOT EXISTS `comment` (
  `comment_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `content_id` bigint(20) NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `comment_sender` int(11) NOT NULL,
  `comment_date` datetime NOT NULL,
  `comment_text` text NOT NULL,
  PRIMARY KEY (`comment_id`),
  KEY `multimed_comment_fk1` (`content_id`),
  KEY `term_id` (`term_id`),
  KEY `comment_sender` (`comment_sender`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 PACK_KEYS=0;

-- --------------------------------------------------------

--
-- Table structure for table `consultation`
--

CREATE TABLE IF NOT EXISTS `consultation` (
  `qa_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `expert_id` bigint(20) NOT NULL,
  `users_id` bigint(20) NOT NULL,
  `subject` text NOT NULL,
  `question` text NOT NULL,
  `is_answer` tinyint(4) NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `is_private` tinyint(1) NOT NULL DEFAULT '0',
  `is_read` tinyint(1) NOT NULL DEFAULT '0',
  `date_question_published` datetime NOT NULL,
  `date_answer_published` datetime NOT NULL,
  PRIMARY KEY (`qa_id`),
  KEY `expert_id` (`expert_id`),
  KEY `users_id` (`users_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `consultation_reply`
--

CREATE TABLE IF NOT EXISTS `consultation_reply` (
  `reply_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `qa_id` bigint(20) NOT NULL,
  `reply_sender` bigint(20) NOT NULL,
  `reply_text` longtext NOT NULL,
  `reply_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`reply_id`),
  KEY `consultation_id` (`qa_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `discussion`
--

CREATE TABLE IF NOT EXISTS `discussion` (
  `discussion_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `discussion_subject` varchar(255) NOT NULL,
  `discussion_topic` longtext NOT NULL,
  `discussion_host` bigint(20) NOT NULL,
  `discussion_creator` bigint(20) NOT NULL,
  `is_group` tinyint(1) NOT NULL DEFAULT '0',
  `discussion_start` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`discussion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `discussion_reply`
--

CREATE TABLE IF NOT EXISTS `discussion_reply` (
  `reply_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `discussion_id` bigint(20) NOT NULL,
  `reply_sender` bigint(20) NOT NULL,
  `reply_text` longtext NOT NULL,
  `reply_date` datetime NOT NULL,
  `parent` bigint(20) NOT NULL,
  `promote` bigint(20) NOT NULL,
  PRIMARY KEY (`reply_id`),
  KEY `discussion_id` (`discussion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `experts_request`
--

CREATE TABLE IF NOT EXISTS `experts_request` (
  `users_id` bigint(20) NOT NULL,
  `proposal` text NOT NULL,
  `status` enum('approved','proposal','recommended') NOT NULL DEFAULT 'proposal',
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`users_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `feednews`
--

CREATE TABLE IF NOT EXISTS `feednews` (
  `feed_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NOT NULL,
  `date` datetime NOT NULL,
  `activity` text NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `content_id` bigint(20) NOT NULL,
  PRIMARY KEY (`feed_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `files`
--

CREATE TABLE IF NOT EXISTS `files` (
  `files_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `files_name` varchar(255) NOT NULL,
  `files_title` varchar(255) NOT NULL,
  `files_link` varchar(255) NOT NULL,
  `files_thumb` varchar(225) NOT NULL,
  `files_desc` text NOT NULL,
  `files_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `files_type` varchar(255) NOT NULL,
  `files_download` int(11) NOT NULL DEFAULT '0',
  `is_share` varchar(2) NOT NULL,
  PRIMARY KEY (`files_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `friendship`
--

CREATE TABLE IF NOT EXISTS `friendship` (
  `friends_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `users_id_request` int(11) NOT NULL,
  `users_id_approve` int(11) NOT NULL,
  `request_date` datetime NOT NULL,
  `approve_date` datetime NOT NULL,
  `status` enum('friend','pending','follow') NOT NULL,
  PRIMARY KEY (`friends_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `groups`
--

CREATE TABLE IF NOT EXISTS `groups` (
  `groups_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `groups_name` varchar(255) NOT NULL,
  `groups_slug` varchar(255) NOT NULL,
  `groups_creator` bigint(20) NOT NULL,
  `groups_date_created` datetime NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `groups_profilepic` varchar(255) NOT NULL,
  `groups_description` text NOT NULL,
  `groups_status` enum('open','closed') NOT NULL,
  `member_count` bigint(20) NOT NULL,
  PRIMARY KEY (`groups_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `groups_members`
--

CREATE TABLE IF NOT EXISTS `groups_members` (
  `groups_id` bigint(20) NOT NULL,
  `users_id` bigint(20) NOT NULL,
  `users_status` enum('admin','member','pending','invite') NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `groups_share`
--

CREATE TABLE IF NOT EXISTS `groups_share` (
  `gshare_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `groups_id` bigint(20) NOT NULL,
  `content_id` bigint(20) NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `users_id` bigint(20) NOT NULL,
  PRIMARY KEY (`gshare_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `like`
--

CREATE TABLE IF NOT EXISTS `like` (
  `term_id` bigint(20) NOT NULL,
  `content_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `is_like` tinyint(1) NOT NULL DEFAULT '1',
  `info` text NOT NULL,
  PRIMARY KEY (`term_id`,`content_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `messages`
--

CREATE TABLE IF NOT EXISTS `messages` (
  `messages_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `messages_subject_id` bigint(20) NOT NULL,
  `messages_sender` bigint(20) NOT NULL,
  `messages_text` longtext NOT NULL,
  `messages_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `is_parent` tinyint(1) NOT NULL,
  PRIMARY KEY (`messages_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `messages_receiver`
--

CREATE TABLE IF NOT EXISTS `messages_receiver` (
  `messages_subject_id` bigint(20) NOT NULL,
  `messages_receiver` bigint(20) NOT NULL,
  `is_read` tinyint(1) NOT NULL,
  `is_delete` tinyint(1) NOT NULL,
  PRIMARY KEY (`messages_subject_id`,`messages_receiver`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `messages_subject`
--

CREATE TABLE IF NOT EXISTS `messages_subject` (
  `messages_subject_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `messages_subject` varchar(255) NOT NULL,
  PRIMARY KEY (`messages_subject_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `news`
--

CREATE TABLE IF NOT EXISTS `news` (
  `news_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `news_title` varchar(255) NOT NULL,
  `news_permalink` varchar(255) NOT NULL,
  `news_excerpt` text,
  `news_body` longtext NOT NULL,
  `news_author` bigint(20) NOT NULL,
  `news_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `news_status` enum('publish','draft') NOT NULL DEFAULT 'publish',
  `news_hits` bigint(20) NOT NULL DEFAULT '0',
  `comment_count` bigint(20) DEFAULT '0',
  PRIMARY KEY (`news_id`),
  KEY `notes_author` (`news_author`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `notes`
--

CREATE TABLE IF NOT EXISTS `notes` (
  `notes_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `notes_title` varchar(255) NOT NULL,
  `notes_permalink` varchar(255) NOT NULL,
  `notes_excerpt` text,
  `notes_body` longtext NOT NULL,
  `notes_author` bigint(20) NOT NULL,
  `notes_date` datetime NOT NULL,
  `notes_status` enum('publish','draft') NOT NULL DEFAULT 'publish',
  `notes_hits` bigint(20) NOT NULL DEFAULT '0',
  `comment_count` bigint(20) DEFAULT '0',
  PRIMARY KEY (`notes_id`),
  KEY `notes_author` (`notes_author`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `page`
--

CREATE TABLE IF NOT EXISTS `page` (
  `page_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `page_title` varchar(255) NOT NULL,
  `page_slug` varchar(255) NOT NULL,
  `page_content` longtext NOT NULL,
  `last_edit` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `parent_page` bigint(20) NOT NULL,
  PRIMARY KEY (`page_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `points`
--

CREATE TABLE IF NOT EXISTS `points` (
  `points_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `point_key` varchar(30) NOT NULL,
  `point_value` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `questions`
--

CREATE TABLE IF NOT EXISTS `questions` (
  `questions_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `questions` varchar(100) NOT NULL,
  `questions_type` varchar(50) NOT NULL,
  `questions_template_id` bigint(20) NOT NULL DEFAULT '0',
  `questions_param` varchar(100) NOT NULL,
  `questions_answer` varchar(100) NOT NULL,
  `module_id` bigint(20) NOT NULL,
  PRIMARY KEY (`questions_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `questions_template`
--

CREATE TABLE IF NOT EXISTS `questions_template` (
  `questions_template_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `questions_template_name` varchar(100) NOT NULL,
  `questions_template_type` varchar(50) NOT NULL,
  `question` varchar(500) NOT NULL,
  `questions_template_param` varchar(500) NOT NULL,
  `item_number` int(11) NOT NULL,
  PRIMARY KEY (`questions_template_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `quiz`
--

CREATE TABLE IF NOT EXISTS `quiz` (
  `quiz_id` int(11) NOT NULL AUTO_INCREMENT,
  `categories_cat_id` int(11) NOT NULL,
  `users_id` int(11) NOT NULL,
  `quiz_title` varchar(255) NOT NULL,
  `quiz_slug` varchar(255) NOT NULL,
  `quiz_type` varchar(3) NOT NULL,
  `quiz_date_created` datetime NOT NULL,
  `quiz_intro` text NOT NULL,
  `quiz_follower` int(11) NOT NULL,
  `published` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`quiz_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `quiz_answers`
--

CREATE TABLE IF NOT EXISTS `quiz_answers` (
  `quiz_answer_id` int(11) NOT NULL AUTO_INCREMENT,
  `quiz_question_id` int(11) NOT NULL,
  `answer` text NOT NULL,
  `answer_order` int(11) NOT NULL,
  `is_key` enum('0','1') NOT NULL,
  PRIMARY KEY (`quiz_answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `quiz_question`
--

CREATE TABLE IF NOT EXISTS `quiz_question` (
  `quiz_question_id` int(11) NOT NULL AUTO_INCREMENT,
  `quiz_id` int(11) NOT NULL,
  `question` text NOT NULL,
  `question_order` int(11) NOT NULL,
  PRIMARY KEY (`quiz_question_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `quiz_user`
--

CREATE TABLE IF NOT EXISTS `quiz_user` (
  `quiz_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `answers` int(11) NOT NULL,
  `score` float NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `report`
--

CREATE TABLE IF NOT EXISTS `report` (
  `report_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `term_id` int(11) NOT NULL,
  `content_id` bigint(20) NOT NULL,
  `users_id` bigint(20) NOT NULL,
  `report_type_id` int(11) NOT NULL,
  `report_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`report_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `report_type`
--

CREATE TABLE IF NOT EXISTS `report_type` (
  `report_type_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `report_type` varchar(100) NOT NULL,
  PRIMARY KEY (`report_type_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `resources`
--

CREATE TABLE IF NOT EXISTS `resources` (
  `resources_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) NOT NULL,
  `files_id` bigint(20) NOT NULL,
  `resources_description` longtext NOT NULL,
  PRIMARY KEY (`resources_id`),
  KEY `term_id` (`term_id`),
  KEY `files_id` (`files_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `running_tools`
--

CREATE TABLE IF NOT EXISTS `running_tools` (
  `running_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `tools_id` bigint(20) NOT NULL,
  `users_id` bigint(20) NOT NULL,
  `running_module` bigint(20) DEFAULT NULL,
  `status` char(2) NOT NULL DEFAULT '1',
  PRIMARY KEY (`running_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `special_action`
--

CREATE TABLE IF NOT EXISTS `special_action` (
  `sp_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `sp_host` bigint(20) NOT NULL,
  `sp_name` varchar(255) NOT NULL,
  `sp_description` longtext NOT NULL,
  `sp_tagline` varchar(255) NOT NULL,
  `start_date` datetime NOT NULL,
  `end_date` datetime NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `sp_location` varchar(255) NOT NULL,
  `is_group` tinyint(1) NOT NULL,
  PRIMARY KEY (`sp_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `special_action_follower`
--

CREATE TABLE IF NOT EXISTS `special_action_follower` (
  `sp_id` bigint(20) NOT NULL,
  `follower_id` bigint(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `term`
--

CREATE TABLE IF NOT EXISTS `term` (
  `term_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'primary keys',
  `term_name` varchar(255) NOT NULL COMMENT 'nama terminologi, yaitu nama kategori, nama menu, dll',
  `term_slug` varchar(255) NOT NULL COMMENT 'permalink',
  `term_taxonomy` enum('menu','tag','categories','news_categories','groups_categories','resources_categories','tools_categories','expert-categories') NOT NULL COMMENT 'tipe term, apakah kategori, menu, atau tag',
  `term_parent` bigint(20) NOT NULL DEFAULT '0' COMMENT 'parent kategori, parent menu, dll',
  `term_order` int(11) NOT NULL DEFAULT '0' COMMENT 'urutan tampil dalam satu tipe yang sama, 0 lebih dulu dari 2',
  PRIMARY KEY (`term_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `term_relationship`
--

CREATE TABLE IF NOT EXISTS `term_relationship` (
  `object_id` bigint(20) NOT NULL COMMENT 'share, notes',
  `content_id` bigint(20) NOT NULL COMMENT 'id-nya di table share, notes',
  `term_id` bigint(20) NOT NULL,
  PRIMARY KEY (`object_id`,`content_id`,`term_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `tools`
--

CREATE TABLE IF NOT EXISTS `tools` (
  `tools_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `tools_name` varchar(255) NOT NULL,
  `tools_permalink` varchar(255) NOT NULL,
  `tools_description` text NOT NULL,
  `status` int(11) NOT NULL,
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `participant` int(11) NOT NULL,
  PRIMARY KEY (`tools_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `tools_module`
--

CREATE TABLE IF NOT EXISTS `tools_module` (
  `module_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `module_name` varchar(255) NOT NULL,
  `module_permalink` varchar(255) NOT NULL,
  `module_description` text NOT NULL,
  `module_instruction` text NOT NULL,
  `module_sequence` int(11) NOT NULL,
  `module_requirement` char(2) NOT NULL,
  `tools_id` bigint(20) NOT NULL,
  `role_requirement` enum('member','participant') NOT NULL,
  `is_plugin` varchar(255) NOT NULL,
  PRIMARY KEY (`module_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `users_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `ip_address` char(16) NOT NULL,
  `username` varchar(255) DEFAULT '',
  `full_name` varchar(255) NOT NULL,
  `password` varchar(40) NOT NULL,
  `email` varchar(40) NOT NULL,
  `activation_code` varchar(40) NOT NULL DEFAULT '0',
  `forgotten_password_code` varchar(40) NOT NULL DEFAULT '0',
  `date_register` datetime NOT NULL,
  PRIMARY KEY (`users_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `users_meta`
--

CREATE TABLE IF NOT EXISTS `users_meta` (
  `users_id` int(11) NOT NULL,
  `users_sex` enum('female','male') NOT NULL,
  `users_birthday` date NOT NULL,
  `users_country` varchar(255) NOT NULL DEFAULT 'Indonesia',
  `users_timezone` varchar(255) NOT NULL DEFAULT 'UP7',
  `users_description` text,
  `users_interest` text NOT NULL,
  `users_role` varchar(40) NOT NULL DEFAULT 'member',
  `expert_term` bigint(20) DEFAULT NULL COMMENT '=term_id',
  `expert_title` varchar(255) NOT NULL,
  `expert_follower` bigint(20) NOT NULL,
  `users_last_login` datetime DEFAULT NULL,
  `users_picture` varchar(255) NOT NULL DEFAULT 'upload/profile/default.jpg',
  `users_location` text,
  `users_website` longtext,
  `users_edu` longtext,
  `users_company` longtext NOT NULL,
  `users_contribution` longtext,
  `users_award` longtext,
  `users_organization` longtext,
  `suksesmulia_training` longtext,
  `suksesmulia_books` text NOT NULL,
  `friends` bigint(20) NOT NULL,
  `facebook` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`users_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `user_company`
--

CREATE TABLE IF NOT EXISTS `user_company` (
  `company_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `users_id` bigint(20) NOT NULL,
  `company_name` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `start_month` tinyint(2) NOT NULL,
  `start_year` year(4) NOT NULL,
  `end_month` tinyint(2) NOT NULL,
  `end_year` year(4) NOT NULL,
  `is_featured` enum('1','0') NOT NULL,
  PRIMARY KEY (`company_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `viral`
--

CREATE TABLE IF NOT EXISTS `viral` (
  `viral_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `viral_name` varchar(50) NOT NULL,
  `location` varchar(200) NOT NULL,
  PRIMARY KEY (`viral_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `wall`
--

CREATE TABLE IF NOT EXISTS `wall` (
  `wall_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `wall_sender` bigint(20) NOT NULL,
  `wall_receiver` bigint(20) NOT NULL,
  `wall_text` longtext NOT NULL,
  `wall_date` datetime NOT NULL,
  `term_id` bigint(20) NOT NULL,
  `viral_id` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`wall_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;

INSERT INTO `term` (`term_id`, `term_name`, `term_slug`, `term_taxonomy`, `term_parent`, `term_order`) VALUES
(1, 'notes', 'notes', 'menu', 0, 0),
(2, 'friend', 'friend', 'menu', 0, 0),
(3, 'groups', 'groups', 'menu', 0, 0),
(4, 'share', 'share', 'menu', 0, 0),
(5, 'resources', 'resources', 'menu', 0, 0),
(6, 'experts', 'experts', 'menu', 0, 0),
(7, 'special action', 'special-action', 'menu', 0, 0),
(8, 'consultation', 'consultation', 'menu', 0, 0),
(9, 'life skill tools', 'life-skill-tools', 'menu', 0, 0),
(10, 'wall', 'wall', 'menu', 0, 0),
(11, 'comment', 'comment', 'menu', 0, 0),
(12, 'discussion', 'discussion', 'menu', 0, 0),
(13, 'status', 'status', 'menu', 0, 0),
(14, 'profile', 'profile', 'menu', 0, 0),
(15, 'dashboard', 'dashboard', 'menu', 0, 0),
(16, 'home', 'home', 'menu', 0, 0);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
