<?php
class News extends Controller {

	
	function news()
	{
		parent::Controller();
		$this->load->model("news_model");
	}
	                         
	function index()
	{
		 $this->browse();
	}
  
	function browse($author="all",$cat="all",$num=5,$page=0)
	{
		if (is_editor()){
			$data['title'] = 'News';
			$data['page'] = 'news';
			if($cat!="all"){
				$term = get_term_by_slug($cat);
				if(!empty($term)){
				$cat = $term->term_id;
				$category_sort = $term->term_name;
				}else{
				  $cat = "all";
				  $category_sort = "All Categories";
				}        
			}else{
				$cat = "all";
				$category_sort = "All Categories";
			}
			$data["news"] = $this->news_model->get_recent_news($author,$cat,"news_date",$num,$page);
			$config['uri_segment'] = 7;
			$config['full_tag_open'] = '';
			$config['full_tag_close'] = '';
			$config['base_url'] = base_url()."cms/news/browse/".$author."/".$cat."/".$num."/";
			$config['total_rows'] = $this->news_model->total_recent_news($author,$cat);
			$data['total_news'] =  $config['total_rows'];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view('admin/news',$data);
		}else{
		  redirect("cms");
		}
  }
  
  function get_list()
  {
      $pages = $this->page_model->get_pages();
      $data_list = array();
      $i = 0;
      foreach ($pages as $page):
        $i = $i+1;
        $action = '<a href='.base_url().'page/view/about class="preview">Preview</a> <a href="" class="previous">Edit</a> <a href="" class="block">Delete</a>';
        $data = array("id"=>$i,
                "title"=>$page->page_title,
                "slug"=>$page->page_slug,
                "last-edit"=>$page->last_edit,
                "action"=>$action
                );
        $data_list[] = $data;
        $childs = $this->page_model->get_pages($page->page_id); 
        foreach($childs as $child):
           $action = '<a href="" class="previous">Preview</a> <a href="" class="previous">Edit</a> <a href="" class="block">Delete</a>';
           $data_child = array("id"=>"",
                "title"=>$child->page_title,
                "slug"=>$child->page_slug,
                "last-edit"=>$child->last_edit,
                "action"=>$action
                );
            $data_list[] = $data_child;
        endforeach;
      endforeach;
			echo json_encode($data_list);
  }

  function submit()
	{
		$this->form_validation->set_rules('news_title', 'Page Title', 'required');
		$this->form_validation->set_rules('news_content', 'Page Content', 'required');
	  $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	    
	    if ($this->form_validation->run() == false)
	    { 
			 $this->browse();
	    }else{
			 $title = $this->input->post('news_title');
			 $slug = url_title($title);
			 $content = $this->input->post('news_content');
			 $category = $this->input->post('news_category');
			 $excerpt =  $this->input->post('news_excerpt');
			 $author = $this->session->userdata("users_id");
			 $content_id = $this->news_model->submit($title,$slug,$author,$content,$excerpt);
			 if($content_id!=0){
				$this->category_model->term_relationship_submit(getTermID("news"),$content_id,$category);
			 }
			 header('Location: '.getenv('HTTP_REFERER'));
		  }

	}
  
  function search($key=null,$num=5,$page=0){
      if ($this->redux_auth->logged_in()){
      $data["page"] = "news";
		  $data["title"] = "Search Result | Pages";
		  $config['uri_segment'] = 6;
		   if($key==null){
        $key = $this->input->post("key");
        if($key==false){
          $key = "";
        }
      }
		  $data['key'] = $key;
		  $config['base_url'] = base_url()."cms/news/search/".$key."/".$num."/";
		  $data["news"] = $this->news_model->search($key,$num,$page);
		  $config['total_rows'] = $this->news_model->total_search($key);
		  $data['total_news'] =  $config['total_rows'];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
		  $this->load->view("admin/news_search",$data);
		  }else{
      redirect("cms");
      }
  }
  
  function preview($news_id)
  {
	$news = $this->news_model->get_news($news_id);
	if(empty($news)){
		redirect('page404');
	}else{
		$data['title'] = $news->news_title;
		$data['permalink'] = $news->news_permalink;
		$data['id'] = $news->news_id;
		$data['excerpt'] = $news->news_excerpt;
		$data['content']= $news->news_body;
		$data['last_edit'] = $news->news_date;
		$this->load->view('admin/news_preview',$data);
	}
  }
  
  function edit($news_id)
  {
	$this->form_validation->set_rules('news_title', 'News Title', 'required');
	$this->form_validation->set_rules('news_excerpt', 'News Excerpt', 'required');
	$this->form_validation->set_rules('news_body', 'News Content', 'required');
	$this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	$data["page"] = "news";
	$object_id = getTermID("news");
	if ($this->form_validation->run() == false)
	{ 
		$data["title"] = "Edit News";
		$data["news"] = $this->news_model->get_news($news_id);
		$terms = $this->category_model->get_category_list_by_content($object_id, $news_id);
		$arr_term = array();
		foreach($terms as $term):
			$arr_term["term_id"] = $term->term_id;
			$arr_term["term_name"] = $term->term_name;
		endforeach;
		$data["term"] = $arr_term;
		$this->load->view("admin/news_edit",$data);
	}else{
		$title = $this->input->post('news_title');
		$slug = url_title($title);
		$content = $this->input->post('news_body');
		$category = $this->input->post('news_category');
		$excerpt =  $this->input->post('news_excerpt');
		$author = $this->session->userdata("users_id");
		
		$edit_content_id = $this->news_model->edit($news_id,$slug,$title,$content,$excerpt);
		$edit_category = $this->category_model->edit_term_relationship($object_id,$news_id,$category);
		header('Location: '.getenv('HTTP_REFERER'));
	}
  }
  
  
  function delete()
  {
	if (is_editor()){
		$news_id = $this->input->post("content_id");
		$delete_news = $this->news_model->delete($news_id);
		$object_id = getTermID("news");
		if($delete_news){
			$this->category_model->delete_term_relationship($object_id,$news_id);
		}
	}else{
		redirect("cms");
	}
  }	
	

}
?>