<?php
class Pages extends Controller {

	
	function index()
	{
     $this->browse();
  }
  
  function browse($num=5,$page=0){
    if (is_editor()){
			$data['title'] = 'Pages';
			$data['page'] = 'content';
			$data['pages'] = $this->page_model->get_pages("0",$num,$page);
			$data["parents"] = $this->page_model->get_pages("0");
			$config['uri_segment'] = 5;
			$config['full_tag_open'] = '';
			$config['full_tag_close'] = '';
			$config['base_url'] = base_url()."cms/pages/browse/".$num."/";
			$config['total_rows'] = $this->page_model->total_page("0");
			$data['total_rows'] =  $this->page_model->total_page();
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view('admin/pages',$data);
		}else{
		  redirect("cms");
		}
  }
  
  function get_list()
  {
      $pages = $this->page_model->get_pages();
      $data_list = array();
      $i = 0;
      foreach ($pages as $page):
        $i = $i+1;
        $action = '<a href='.base_url().'page/view/about class="preview">Preview</a> <a href="" class="previous">Edit</a> <a href="" class="block">Delete</a>';
        $data = array("id"=>$i,
                "title"=>$page->page_title,
                "slug"=>$page->page_slug,
                "last-edit"=>$page->last_edit,
                "action"=>$action
                );
        $data_list[] = $data;
        $childs = $this->page_model->get_pages($page->page_id); 
        foreach($childs as $child):
           $action = '<a href="" class="previous">Preview</a> <a href="" class="previous">Edit</a> <a href="" class="block">Delete</a>';
           $data_child = array("id"=>"",
                "title"=>$child->page_title,
                "slug"=>$child->page_slug,
                "last-edit"=>$child->last_edit,
                "action"=>$action
                );
            $data_list[] = $data_child;
        endforeach;
      endforeach;
			echo json_encode($data_list);
  }

  function submit()
	{
		$this->form_validation->set_rules('page_title', 'Page Title', 'required');
		$this->form_validation->set_rules('page_content', 'Page Content', 'required');
	  $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	    
	    if ($this->form_validation->run() == false)
	    { 
			 $this->browse();
	    }else{
			 $title = $this->input->post('page_title');
			 $input_slug = $this->input->post('page_slug');
			 $slug = ($input_slug=="")?url_title($title):$input_slug;
			 $content = $this->input->post('page_content');
			 $parent = $this->input->post('page_parent');
			 $content_id = $this->page_model->submit($title,$slug,$content,$parent);	
			 header('Location: '.getenv('HTTP_REFERER'));
		  }

	}
  
  function search($key=null,$num=5,$page=0){
      if ($this->redux_auth->logged_in()){
      $data["page"] = "pages";
		  $data["title"] = "Search Result | Pages";
		  $config['uri_segment'] = 6;
		   if($key==null){
        $key = $this->input->post("key");
        if($key==false){
          $key = "";
        }
      }
		  $data['key'] = $key;
		  $config['base_url'] = base_url()."cms/pages/search/".$key."/".$num."/";
		  $data["pages"] = $this->page_model->search($key,$num,$page);
		  $config['total_rows'] = $this->page_model->total_search($key);
		  $data['total_rows'] =  $config['total_rows'];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
		  $this->load->view("admin/pages_search",$data);
		  }else{
      redirect("cms");
      }
  }
  
  function preview($page_id)
  {
    $pages = $this->page_model->get_page_by_id($page_id);
		if(empty($pages)){
        redirect('page404');
    }else{
      	$data['title'] = $pages->page_title;
		    $data['page'] = $pages->page_slug;
		    $data['id'] = $pages->page_id;
        $data['content']= $pages->page_content;
        $data['last_edit'] = $pages->last_edit;
        $this->load->view('admin/pages_preview',$data);
    }
  }
  
  function edit($page_id)
  {
      $this->form_validation->set_rules('page_title', 'Page Title', 'required');
		  $this->form_validation->set_rules('page_content', 'Page Content', 'required');
	    $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	    
	    if ($this->form_validation->run() == false)
	    { 
			 $data["title"] = "Edit Page";
       $data["page"] = $this->page_model->get_page_by_ID($page_id);
       $data["parents"] = $this->page_model->get_pages("0");
			 $this->load->view("admin/pages_edit",$data);
	    }else{
			 $title = $this->input->post('page_title');
			 $input_slug = $this->input->post('page_slug');
			 $slug = ($input_slug=="")?url_title($title):$input_slug;
			 $content = $this->input->post('page_content');
			 $parent = $this->input->post('page_parent');
			 $content_id = $this->page_model->edit($page_id,$slug,$title,$content,$parent);
       	
			 header('Location: '.getenv('HTTP_REFERER'));
		  }
  }
  
  
  function delete()
  {
	if (is_editor()){
		$page_id = $this->input->post("content_id");
		$page = $this->page_model->get_page_by_id($page_id);
		if($page->parent_page==0){
			$delete_page = $this->page_model->delete($page_id);
			if($delete_page){
			$childs = $this->page_model->get_pages($page_id);
			foreach($childs as $child):
				$update_parent = $this->page_model->update_parent($page_id); 
			endforeach;
			}
		}else{
			$delete_page = $this->page_model->delete($page_id);
		}
        }else{
		redirect("cms");
	}
  }	
	

}
?>