<?php
class Discussion extends Controller {
	function index(){
		if ($this->redux_auth->logged_in()){
				redirect("page404");
			}else{
				redirect("auth/login");
			}
	}
	
	function browse($is_group=null,$submenu="featured",$num=5,$page=0){
		if($this->redux_auth->logged_in()){
			$data["title"] = $submenu." discussion";
			$data["page"] = $is_group;
			$data["submenu"] = $submenu;
			$data["is_group"] = $is_group;
			$is_groups = ($is_group=="groups")?1:0;
			$config['uri_segment'] = 5;
			if(($is_group!="experts")&&($is_group!="groups")){
        redirect("page404");
      }
			$config['base_url'] = base_url()."discussion/browse/".$is_group."/".$submenu."/".$num."/";
			if ($submenu == "my"){
				
        $users_id= $this->session->userdata("users_id");
        $data["discussion"]=$this->discussions_model->get_list($users_id,$is_groups,"discussion_start desc",$num,$page);
				$config['total_rows'] = $this->discussions_model->total($users_id,$is_groups);
				$this->pagination->initialize($config);
				$data["pagination"] =  $this->pagination->create_links();
			}elseif ($submenu == "featured"){
				$data["discussion"]=$this->discussions_model->get_list(null,$is_groups,"discussion_start desc",$num,$page);
				$config['total_rows'] = $this->discussions_model->total(null,$is_groups);
				$this->pagination->initialize($config);
				$data["pagination"] =  $this->pagination->create_links();
			}elseif($submenu == "popular"){
				$data["discussion"]=$this->discussions_model->get_list(null,$is_groups,"total_reply desc",$num,$page);
				$config['total_rows'] = $this->discussions_model->total(null,$is_groups);
				$this->pagination->initialize($config);
				$data["pagination"] =  $this->pagination->create_links();
			}else{
        redirect("page404");
      }
			$this->load->view("discussion/index",$data);
		}else{
			redirect("auth/login");
		}
	}	
  function submit(){

	 if($this->redux_auth->logged_in()){
			 $this->form_validation->set_rules('discussion_subject', 'Subject', 'required');
		   $this->form_validation->set_rules('discussion_topic', 'Topic', 'required');
	     $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	     if ($this->form_validation->run() == false){
          $is_group = $this->input->post('is_group');
          $host = $this->input->post('discussion_host');
          /*$data['profile'] = $this->redux_auth->profile();*/
    			$data['title'] = 'Discussion';
    			$data['page'] = ($is_group==1)?"groups":"experts";
    			$data['is_group'] = $is_group;
    			$data['discussion_host'] = $host;
    			$this->load->view('discussion/create',$data);
      }else{
          $discussion_subject = $this->input->post('discussion_subject');
      		$discussion_topic = $this->input->post('discussion_topic');
      		$discussion_host = $this->input->post('discussion_host');
      		$discussion_creator = $this->input->post('discussion_creator');
      		$is_group = $this->input->post('is_group');
      		
      		$insert_id = $this->discussion_model->createDiscussion($discussion_subject,$discussion_topic,$discussion_host,$discussion_creator,$is_group);

          if($insert_id){
           $term = ($is_group==1)?"groups":"experts";
           redirect("discussion/view/".$term."/".$insert_id);
          }else{
            header('Location: '.getenv('HTTP_REFERER'));
          }
      }
    }else{
        redirect("auth/login");
    }
		
	}
	
	function submitReply()
	{
		$discussion_id=$this->input->post('discussion_id');
		$reply_sender=$this->input->post('reply_sender');
		$reply_text=$this->input->post('reply_text');
		$parent=$this->input->post('parent');
		if (trim($parent==""))
			$parent=0;
		$submit = $this->discussion_model->submitReply($discussion_id,$reply_sender,$reply_text,$parent);
		header('Location: '.getenv('HTTP_REFERER'));
	}
	
	function create($is_groups="experts",$host=null){
		if ($this->redux_auth->logged_in()){
			//$data['profile'] = $this->redux_auth->profile();
			
			if($is_groups=="experts"){
        if($host==null){
          $host_id= $this->session->userdata("users_id");
        }else if((is_can($host))&&(get_role($host)=="experts")){
          $host_id = $host;
        }else{
          redirect("page404");
          exit;
        }
      }elseif($is_groups=="groups"){
         if($host==null){
          redirect("page404");
          exit;
        }else if(is_can_groups($this->session->userdata("users_id"),$host)){
          $host_id = $host;
        }else{
          redirect("page404");
          exit;
        }
      }else{
          redirect("page404");
          exit;
      }
			$data['title'] = 'Discussion';
			$data['page'] = 'discussion';
			$data['is_group'] = ($is_groups=="groups")?1:0;
			$data['discussion_host'] = $host_id;
			$this->load->view('discussion/create',$data);
			
		}else{
      redirect("auth/login");
    }
	}
	
	function view($is_groups,$discussion_id,$subject="",$cat="current",$reply_page=0){
		if($this->redux_auth->logged_in()){
			
			$data["page"] = $is_groups;
			$data["discussion_id"] = $discussion_id;
			$data["subject"] = $subject;
			$data["cat"] = $cat;
			if(($is_groups!="experts")&&($is_groups!="groups")){
        redirect("page404");
      }
      $data["is_groups"] = $is_groups;
			$data["term_id"]=getTermID('discussion');
			$data["total_reply"]=$this->discussions_model->total_reply($discussion_id);
			$data["total_all_reply"]=$this->discussions_model->total_all_reply($discussion_id);
			$data["total_like"]=$this->like_model->countLike(getTermID("discussion"),$discussion_id);
      $data["discussion_id"]=$discussion_id;
			$data["discussion"]= $this->discussions_model->get_detail($discussion_id);
			$data["title"] = $data["discussion"]->discussion_subject." | Discussions";
			/*comment pagination */
      $config['uri_segment'] = 7;
		  $config['base_url'] = base_url()."discussion/view/".$is_groups."/".$discussion_id."/".$subject."/".$cat."/";
		  $data["replies"] = array();
		  if ($cat=="newer")
		  	$data["replies"] = $this->discussions_model->get_reply_newer($discussion_id,5,$reply_page);
		  else if ($cat=="mostpromoted")
		 	$data["replies"] = $this->discussions_model->get_reply_most($discussion_id,5,$reply_page);
		  else
		  	$data["replies"] = $this->discussions_model->get_reply($discussion_id,5,$reply_page);
		  $config["total_rows"]=$data["total_reply"];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view("discussion/single",$data);
		}else{		
			redirect("auth/login");
		}
	}
	
  /*function view($discussion_id,$discussion_subject="",$page_reply=1){
		if ($this->redux_auth->logged_in()){
			$data['profile'] = $this->redux_auth->profile();
			$data['title'] = 'Discussion';
			$data['page'] = 'discussion';
			$data['discussion_id'] = $discussion_id;
			$data['table_users']=getUserTable();
			$data['detail']=$this->discussion_model->getDetail($discussion_id);
			$data['reply']=$this->getReply($discussion_id,$page_reply);
			$this->load->view('discussion/single',$data);
			
		}else{
      redirect("auth/login");
    }
	} */
	
	function getReply($discussion_id,$page)
	{
		$data['profile'] = $this->redux_auth->profile();
		$table_users=getUserTable();
		$reply=$this->discussion_model->getReply($discussion_id,$page);
		$output="<div  class=\"tab-article span-16 last\">";
		foreach ($reply as $item)
		{
$url = base_url()."profile/user/".$item[1];			
$output.="<div  class=\"tab-article thread-reply span-16 last\">";
			$output.="	<h2><a href=\"".$url."\">".$item[6]."</a></h2>
					<img src='".base_url().image_thumb($item[3],52,52)."' class='med' />
					<a class=\"promote first\"  href=\"".base_url()."/discussion/promote/$item[4]\">Promote</a>
					<a class=\"reply-thread second\"  href=\"javascript:Effect.Combo('reply_".$item[4]."', {});\">Reply</a>
					<a class=\"demote third\" href=\"".base_url()."/discussion/demote/$item[4]\">Demote</a>					
					<ul class=\"article-meta\">
						<li>".nicetime($item[2])."</li>
						<li>".$item[5]." Promoted this answer</li>
					</ul>
					<p>".$item[0]."</p>
				</div>";
			$reply_children=$this->discussion_model->getReplyChildren($discussion_id,$item[4]);
			if (count($reply_children)>0)
			{
				foreach ($reply_children as $item_children): 
						$output.="<div  class=\"tab-article reply-reply span-15 prepend-1 last\">";
						$output.="	<h2><a href=\"#\">".$table_users[$item_children[1]]."</a></h2>
						<img src='".$item_children[3]."' class='med' />					
						<ul class=\"article-meta\">
							<li>".nicetime($item_children[2])."</li>
						</ul>
						<p>".$item_children[0]."</p>
					</div>";
				endforeach; 
			}	
				$output.="
					<div  id=\"reply_".$item[4]."\" style=\"display: none;\" class=\"tab-article reply-form shelf span-16 last\">
					<h2>Reply</h2>
					<form method=\"post\" action=\"".base_url()."discussion/submitReply\">
						<input type=\"hidden\" name=\"reply_sender\" value=\"".$data['profile']->users_id."\" />
						<input type=\"hidden\" name=\"discussion_id\" value=\"".$discussion_id."\" />
						<input type=\"hidden\" name=\"parent\" value=\"".$item[4]."\" />
						<textarea cols=\"10\" rows=\"3\" name=\"reply_text\" class=\"span-15\"></textarea>
						<input type=\"submit\" value=\"Post\" class=\"button\"/>
					</form>
					</div>
				
				
				";
		}
		$output.="</div>";
		
		$total_resources=$this->discussion_model->getTotal($discussion_id);
		$total_page=$total_resources/5;
		if ($total_resources%5>0)
			$total_page++;
		
		$after=2;
		$before=2;
		
		$before_page="";
		$count=1;
		for ($i=$page-1;$i>0;$i--)
		{
			$before_page.="<a href=\"".base_url()."discussion/view/$discussion_id/$i\"  class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		$after_page="";
		$count=1;
		for ($i=$page+1;$i<$total_page;$i++)
		{
			$after_page.="<a href=\"".base_url()."discussion/view/$discussion_id/$i\"  class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		$output.="<div  class=\"tab-article-paging\">";
		$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
		$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
		$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
		$output.="</div>";
		return $output;
		 
	}
	
	function promote($reply_id)
	{
		if($this->redux_auth->logged_in()){
			
			$this->like_model->add(getTermID("discussion"),$reply_id,$this->session->userdata("users_id"),2,'');
			$total_promote=$this->discussions_model->get_total_promote($reply_id);
			$this->discussions_model->updatePromote($reply_id,$total_promote);
			//echo $total_promote;
			header('Location: '.getenv('HTTP_REFERER'));
		} else{		
				redirect("auth/login");
		}
	}
	
	function demote($reply_id)
	{
		if($this->redux_auth->logged_in()){
			//$data['profile'] = $this->redux_auth->profile();
			$this->like_model->delete(getTermID("discussion"),$reply_id,$this->session->userdata("users_id"),2);
			$total_promote=$this->discussion_model->geTotalPromote($reply_id);
			$this->discussion_model->updatePromote($reply_id,$total_promote);
			header('Location: '.getenv('HTTP_REFERER'));
		} else{		
				redirect("auth/login");
		}
	}
	
	function submitLike($files_id)
	{
		if($this->redux_auth->logged_in()){
			$data['profile'] = $this->redux_auth->profile();
			$this->like_model->add(12,$files_id,$data['profile']->users_id,1,'');
			header('Location: '.getenv('HTTP_REFERER'));
		} else{		
				redirect("auth/login");
		}
	}
	
	function submitReport($files_id)
	{
		if($this->redux_auth->logged_in()){
			$data['profile'] = $this->redux_auth->profile();
			$this->like_model->delete(12,$files_id,$data['profile']->users_id,1);
			header('Location: '.getenv('HTTP_REFERER'));
		} else{		
				redirect("auth/login");
		}
	}
	
	
	function getMyDiscussion($users_id,$mydiscussion=1,$mostactive=1,$latest=1)
	{
			$page=$mydiscussion;
			$total_resources=$this->discussion_model->countMyDiscussion($users_id);
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$table_users=getUserTable();
			$table_groups=getGroupTable();
			$result=$this->discussion_model->getMyDiscussion($users_id,$page);
			foreach ($result as $item):
			$total_reply=$this->discussion_model->getTotal($item->discussion_id);
			$page_reply=$total_reply/5;
			if ($total_reply%5>0)
				$page_reply++;
			$expl=explode(".",$page_reply);
			$page_reply=$expl[0];
			/*$output.="<div  class=\"tab-article span-16 last\">
					<h2><a href=\"".base_url()."share/single/".$item->files_id."\" >".$item->files_title."</a></h2>
					<img src=\"".$item->files_thumb."\"  class=\"med\"/>
					<a href=\"".base_url()."share/single/".$item->files_id."\"  class=\"more-link first\" >Read More</a>
					<ul class=\"article-meta\">
						<li>Author : <a class=\"entity\"  href=\"#\">".$table_users[$item->user_id]."</a></li>
						<li>Posted :".$item->files_date."</li>
					</ul>
					<p>".$item->files_desc."</p>
				</div>";*/
			$isgroup=$item->is_group;
			if ($isgroup==1)
			{
				$output.='<div class="tab-article discussion span-16 last" id="">
						<h2><a class="" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">'.$item->discussion_subject.'</h2>
						<a class="more-link first" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">Read More</a>
						<a class="reply second" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'/'.$page_reply.'">Last Reply</a>
						<ul class="article-meta">
							<li>Group : '.$table_groups[$item->discussion_host ].'</li>
							<li>Started : '.$item->discussion_start.'</li>
							<li>'.$total_reply.' Reply</li>
						</ul>
						<p>'.$item->discussion_topic.'</p>
					</div>';
			}else
			{
				$output.='<div class="tab-article discussion span-16 last" id="">
						<h2><a class="" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">'.$item->discussion_subject.'</h2>
						<a class="more-link first" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">Read More</a>
						<a class="reply second" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'/'.$page_reply.'">Last Reply</a>
						<ul class="article-meta">
							<li>Expert : '.$table_users[$item->discussion_host ].'</li>
							<li>Started : '.$item->discussion_start.'</li>
							<li>'.$total_reply.' Reply</li>
						</ul>
						<p>'.$item->discussion_topic.'</p>
					</div>';
			}
			endforeach;
			$after=2;
		$before=2;
		
		$before_page="";
		$count=1;
		for ($i=$page-1;$i>0;$i--)
		{
			$before_page.="<a href=\"".base_url()."discussion/index/$i/$mostactive/$latest"."\"  class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		$after_page="";
		$count=1;
		for ($i=$page+1;$i<$total_page;$i++)
		{
			$after_page.="<a href=\"".base_url()."discussion/index/$i/$mostactive/$latest"."\"    class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		
		$output.="<div  class=\"tab-article-paging\">";
		$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
		$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
		$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
		$output.="</div>"; 
			
		return $output;
	}
	
	function getPopular($users_id,$mydiscussion=1,$mostactive=1,$latest=1)
	{
			$page=$mostactive;
			$total_resources=$this->discussion_model->countPopular();
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$table_users=getUserTable();
			$result=$this->discussion_model->getPopular($page);
			foreach ($result as $item):
			$total_reply=$this->discussion_model->getTotal($item->discussion_id);
			$page_reply=$total_reply/5;
			if ($total_reply%5>0)
				$page_reply++;
			$expl=explode(".",$page_reply);
			$page_reply=$expl[0];
			/*$output.="<div  class=\"tab-article span-16 last\">
					<h2><a href=\"".base_url()."share/single/".$item->files_id."\" >".$item->files_title."</a></h2>
					<img src=\"".$item->files_thumb."\"  class=\"med\"/>
					<a href=\"".base_url()."share/single/".$item->files_id."\"  class=\"more-link first\" >Read More</a>
					<ul class=\"article-meta\">
						<li>Author : <a class=\"entity\"  href=\"#\">".$table_users[$item->user_id]."</a></li>
						<li>Posted :".$item->files_date."</li>
					</ul>
					<p>".$item->files_desc."</p>
				</div>";*/
			$output.='<div class="tab-article discussion span-16 last" id="">
					<h2><a class="" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">'.$item->discussion_subject.'</h2>
					<a class="more-link first" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">Read More</a>
					<a class="reply second" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'/'.$page_reply.'">Last Reply</a>
					<ul class="article-meta">
						<li>Group : <a href="#" id="" class="entity">Jakarta Biker</a></li>
						<li>Started : '.$item->discussion_start.'</li>
						<li>'.$total_reply.' Reply</li>
					</ul>
					<p>'.$item->discussion_topic.'</p>
				</div>';
			endforeach; 
			
		$after=2;
		$before=2;
		
		$before_page="";
		$count=1;
		for ($i=$page-1;$i>0;$i--)
		{
			$before_page.="<a href=\"".base_url()."discussion/index/$mydiscussion/$i/$latest"."\"  class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		$after_page="";
		$count=1;
		for ($i=$page+1;$i<$total_page;$i++)
		{
			$after_page.="<a href=\"".base_url()."discussion/index/$mydiscussion/$i/$latest"."\"    class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		
		$output.="<div  class=\"tab-article-paging\">";
		$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
		$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
		$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
		$output.="</div>"; 
			
		return $output;

	}
	
	
	function getAll($users_id,$mydiscussion=1,$mostactive=1,$latest=1)
	{
			$page=$latest;
			$total_resources=$this->discussion_model->countAll();
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$table_users=getUserTable();
			$result=$this->discussion_model->getAll($page);
			foreach ($result as $item):
			$total_reply=$this->discussion_model->getTotal($item->discussion_id);
			$page_reply=$total_reply/5;
			if ($total_reply%5>0)
				$page_reply++;
			$expl=explode(".",$page_reply);
			$page_reply=$expl[0];
			/*$output.="<div  class=\"tab-article span-16 last\">
					<h2><a href=\"".base_url()."share/single/".$item->files_id."\" >".$item->files_title."</a></h2>
					<img src=\"".$item->files_thumb."\"  class=\"med\"/>
					<a href=\"".base_url()."share/single/".$item->files_id."\"  class=\"more-link first\" >Read More</a>
					<ul class=\"article-meta\">
						<li>Author : <a class=\"entity\"  href=\"#\">".$table_users[$item->user_id]."</a></li>
						<li>Posted :".$item->files_date."</li>
					</ul>
					<p>".$item->files_desc."</p>
				</div>";*/
			$output.='<div class="tab-article discussion span-16 last" id="">
					<h2><a class="" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">'.$item->discussion_subject.'</h2>
					<a class="more-link first" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'">Read More</a>
					<a class="reply second" id="" href="'.base_url().'discussion/view/'.$item->discussion_id.'/'.$page_reply.'">Last Reply</a>
					<ul class="article-meta">
						<li>Group : <a href="#" id="" class="entity">Jakarta Biker</a></li>
						<li>Started : '.$item->discussion_start.'</li>
						<li>'.$total_reply.' Reply</li>
					</ul>
					<p>'.$item->discussion_topic.'</p>
				</div>';
			endforeach; 
			$after=2;
		$before=2;
		
		$before_page="";
		$count=1;
		for ($i=$page-1;$i>0;$i--)
		{
			$before_page.="<a href=\"".base_url()."discussion/index/$mydiscussion/$mostactive/$i"."\"  class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		$after_page="";
		$count=1;
		for ($i=$page+1;$i<$total_page;$i++)
		{
			$after_page.="<a href=\"".base_url()."discussion/index/$mydiscussion/$mostactive/$i"."\"    class=\"previous\" >".$i."</a>";
			if ($count==2)
				break;
			else
				$count++;
		}
		
		$output.="<div  class=\"tab-article-paging\">";
		$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
		$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
		$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
		$output.="</div>"; 
			
		return $output;
			
	}
	
	function group()
	{
		
	}
	


}

?>