<?php
class Experts extends Controller {
	function index(){
		$this->browse();
	}
	
	function browse($submenu="my",$num=5,$page=0){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Experts";
			$data["page"] = "experts";
			$data["submenu"] = $submenu;
			$config['uri_segment'] = 5;
			if ($submenu == "my"){
				$data["experts"] = $this->experts_model->view_experts($this->session->userdata("users_id"),$num,$page);
				$config['base_url'] = base_url()."experts/browse/my/".$num."/";
				$config['total_rows'] = $this->experts_model->total_experts($this->session->userdata("users_id"));
				$this->pagination->initialize($config);
				$data["my_pagination"] =  $this->pagination->create_links();
			}elseif ($submenu == "featured"){
				$data["featured"] = $this->experts_model->view_all_experts("users.users_id",$num,$page);
				$config['base_url'] = base_url()."experts/browse/featured/".$num."/";
				$config['total_rows'] = $this->experts_model->total_all_experts();
				//echo $config['total_rows'];
				$this->pagination->initialize($config);
				$data["featured_pagination"] =  $this->pagination->create_links();
			}elseif($submenu == "popular"){
				$data["popular"] = $this->experts_model->view_all_experts("expert_follower",$num,$page);
				$config['base_url'] = base_url()."experts/browse/popular/".$num."/";
				$config['total_rows'] = $this->experts_model->total_all_experts();
				$this->pagination->initialize($config);
				$data["popular_pagination"] =  $this->pagination->create_links();
			}else{
        redirect("page404");
      }
			$this->load->view("experts/index",$data);
		}else{
			redirect("auth/login");
		}
	}
	
	function view($id,$title){
		if($this->redux_auth->logged_in()){
			$data["title"] = $title;
			$data["page"] = "experts";
			$data["id"]=$id;
			//$data["expert"] = $this->experts_model->view_single($id);
			$this->load->view("experts/single",$data);
		}else{		
			redirect("auth/login");
		}
	}
	
	function follow($expert_id){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Follow Experts";
			$data["page"] = "experts";
			$request = $this->experts_model->follow_expert($expert_id,$this->session->userdata("users_id"));
			if($request!=0){
				$data["request"] =  $request;
				//header('Location: '.getenv('HTTP_REFERER'));
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}else{
			redirect("auth/login");
		}
		//$this->load->view("friends/request",$data);
	}
	
	function unfollow($expert_id){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Unfollow Experts";
			$data["page"] = "experts";
			$request = $this->experts_model->unfollow($this->session->userdata("users_id"),$expert_id);
			if($request){
				$data["request"] =  $request;
				//header('Location: '.getenv('HTTP_REFERER'));
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}else{
			redirect("auth/login");
		}
		//$this->load->view("friends/request",$data);
	}
	
	function join(){
		$data["title"] = "Join Experts";
		$data["page"] = "experts";
		$this->load->view("experts/join_form");
	}
	function add(){
		//proses form 
	}
	
	/**
	 * register
	 *
	 * @return void
	 * @author Mathew
	 **/
	function register()
	{
      $this->form_validation->set_rules('fname', 'First Name', 'required');
		  $this->form_validation->set_rules('lname', 'Last Name', 'required');
	    $this->form_validation->set_rules('email', 'Email Address', 'required|valid_email');
	    $this->form_validation->set_rules('password', 'Password', 'required');
	    $this->form_validation->set_rules('proposal', 'The Proposal', 'required');
	    $this->form_validation->set_rules('math_question', 'Math Question', 'callback_math_question');
	    $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	    
	    if ($this->form_validation->run() == false)
	    {
	         $data['title'] = 'Register';
			     $data['page'] = 'register';
			     $questionOne = $this->math_question->questionOne();
           $questionTwo = $this->math_question->questionTwo();
           $this->session->set_flashdata('questionOne', $questionOne);
           $this->session->set_flashdata('questionTwo', $questionTwo);
           $data['q1'] = $questionOne;
           $data['q2'] = $questionTwo;
           $data['math_question'] = "What is {$questionOne} + {$questionTwo}?";
			     $this->load->view('experts/register', $data);
	    }
	    else
	    {
	        $first_name = $this->input->post('fname');
			    $last_name = $this->input->post('lname');
	        $email    = $this->input->post('email');
	        $password = $this->input->post('password');
	        $proposal = $this->input->post('proposal');
	        $full_name = $first_name." ".$last_name;
			
	        $register = $this->redux_auth->register($full_name, $password, $email);
	        
	        if ($register)
	        {
              
              $this->experts_model->register($register,$proposal,"proposal");
              $data['page'] = 'home';
				      $data['title'] = 'Login';
				      $data['message'] = '<p class="success">Your registration was success. Our Team will learn your expert proposal and inform you when it done.For a while, you can login on below form</p>';
				      $this->load->view('user/login_page',$data);
	        }
	        else
	        {
	            $this->session->set_flashdata('message', '<p class="error">Something went wrong, please try again or contact the helpdesk.</p>');
	            //echo $register;//$data['title'] = 'Register';
			        //$data['page'] = 'register';
			        
			        //$this->load->view('user/register_page', $data);
              redirect('experts/register');
	        }
	    }
	}
	
	function math_question()
  {
  	$user_answer = $this->input->post('math_question');
  	$questionOne = $this->input->post('q1');
  	$questionTwo = $this->input->post('q2');
   
  	$correct_answer = $questionOne + $questionTwo;
   
  	if($user_answer != $correct_answer)
  	{
      $this->form_validation->set_message('math_question', 'Your answer to the math question was incorrect');
  		return FALSE;
  	} else {
  		return TRUE;
  	}
  }
	
}
?>