<?php
class Friends extends Controller {
	function index(){
		parent::Controller();

		$this->browse();
	}
	function browse($submenu="featured",$num=5,$page=0){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Friends";
			$data["page"] = "friends";
			$data["submenu"] = $submenu;
			
			$config['uri_segment'] = 5;
			if ($submenu == "my"){
				$data["friends"] = $this->friend_model->view_friend($this->session->userdata("users_id"),$num,$page);
				$config['base_url'] = base_url()."friends/browse/my/".$num."/";
				$config['total_rows'] = $this->friend_model->total_friends($this->session->userdata("users_id"));
				$this->pagination->initialize($config);
				$data["my_pagination"] =  $this->pagination->create_links();
			}elseif ($submenu == "featured"){
				$data["featured"] = $this->friend_model->view_member("users.users_id",$num,$page);
				$config['base_url'] = base_url()."friends/browse/featured/".$num."/";
				$config['total_rows'] = $this->friend_model->total_member();
				//echo $config['total_rows'];
				$this->pagination->initialize($config);
				$data["featured_pagination"] =  $this->pagination->create_links();
			}elseif($submenu == "popular"){
				$data["popular"] = $this->friend_model->view_member("friends",$num,$page);
				$config['base_url'] = base_url()."friends/browse/popular/".$num."/";
				$config['total_rows'] = $this->friend_model->total_member();
				$this->pagination->initialize($config);
				$data["popular_pagination"] =  $this->pagination->create_links();
			}
			$this->load->view("friends/index",$data);
		}else{
			redirect("auth/login");
		}
	}
	
	function request($friend_id){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Request Friend";
			$data["page"] = "friends";
			$request = $this->friend_model->request_friend($friend_id,$this->session->userdata("users_id"));
			if($request!=0){
				$data["request"] =  $request;
				//header('Location: '.getenv('HTTP_REFERER'));
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}else{
			redirect("auth/login");
		}
		//$this->load->view("friends/request",$data);
	}
	
	function approve($friend_id){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Approve Friend";
			$data["page"] = "friends";
			$approve = $this->friend_model->approve_friend($this->session->userdata("users_id"),$friend_id);
			if($approve){
				$data["approve"] =  "approve";
				//header('Location: '.getenv('HTTP_REFERER'));
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}else{
			redirect("auth/login");
		}
		//$this->load->view("friends/request",$data);
	}
	
	function notification($num=5,$page=0){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Friend Request Notification";
			$data["page"] = "notifications";
			$data["submenu"] = "friends_request";
			//if($submenu=="friends_request"){
				$data["friends_request"] = $this->friend_model->pending_list($this->session->userdata("users_id"),$num,$page);
			//}
			$this->load->view("notifications/index",$data);
		}else{
			redirect("auth/login");
		}
	}
	
	function deny($friend_id){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Deny Friend Request";
			$data["page"] = "friends";
			$deny = $this->friend_model->deny($friend_id,$this->session->userdata("users_id"));
			if($deny){
				$data["approve"] =  "deny";
				//header('Location: '.getenv('HTTP_REFERER'));
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}else{
			redirect("auth/login");
		}
	}
	
	function remove($me,$friend_id){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Remove Friend";
			$data["page"] = "friends";
			$remove = $this->friend_model->remove($me,$friend_id);
			if($remove){
				$data["remove"] =  "remove";
				//header('Location: '.getenv('HTTP_REFERER'));
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}else{
			redirect("auth/login");
		}
	}
	
	  function search($key=null,$num=5,$page=0){
      if ($this->redux_auth->logged_in()){
      $data["page"] = "friends";
		  $data["title"] = "Friends";
		  $config['uri_segment'] = 5;
		   if($key==null){
        $key = $this->input->post("key");
        if($key==false){
          $key = "";
        }
      }
		  $data['key'] = $key;
		  $config['base_url'] = base_url()."friends/search/".$key."/".$num."/";
		  $data["members"] = $this->friend_model->search($key,$num,$page);
		  $config['total_rows'] = $this->friend_model->total_search($key);
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
		  $this->load->view("friends/search_result",$data);
		  }else{
      redirect("auth/login");
      }
  }
	
	
}
?>