<?php
class Home extends Controller {

	
	function index($year=0,$month=0)
	{
		//$this->categories("all");

		if ($this->redux_auth->logged_in()){
			$data['title'] = 'Dashboard';
			$data['page'] = 'dashboard';
			$data['profile'] = $this->redux_auth->profile();
			$users_id=$data['profile']->users_id;
			$data['feeds'] = $this->feeds_model->getFeeds($users_id,8,0);
			$data['total_feeds'] = $this->feeds_model->totalFeeds($users_id);
			$data['notes'] = $this->notes_model->getNetworkNotes($users_id,1);
			$data['friend_request'] = $this->friend_model->total_pending_list($users_id);
			$data['group_invitation'] = $this->groups_model->total_my_invitation($users_id);
			$data['sp_invitation'] = 0;
			$data['consultation_reply'] = 0;
			if ($month==0)
				$month=date("m");
			$data['month']=$month;
			if ($year==0)
				$year=date("Y");
			$data['year']=$year;
			
			$friends_network = $this->redux_auth->friends_network();
			$groups_network = $this->redux_auth->groups_network();
			$experts_network = $this->redux_auth->experts_network();
			$no_groups_network = array_merge((array)$users_id,$experts_network);
			$data['special_action']=$this->special_action_model->get_network_special_action($groups_network,$no_groups_network,3,0);
			$data['datacalendar']=$this->makeCalendar($users_id,$year,$month);
			$data['discussion']=$this->getDiscussion($users_id,1);
			$data['network_consultation'] = $this->consultation_model->get_network_consultation($users_id,0,1);
			$data["experts"] = $this->experts_model->view_experts($this->session->userdata("users_id"),3);
			$data["total_groups_request"]=$this->groups_model->getTotalGroupsRequest($this->session->userdata("users_id"));
			
			$this->load->view('dashboard/index',$data);
		}else if($this->facebook_connect->user_id){
			$data = array(
				'user'		=> $this->facebook_connect->user,
				'user_id'	=> $this->facebook_connect->user_id
			);
			$data['title'] = 'Dashboard';
			$data['page'] = 'dashboard';
			$this->load->view('dashboard/index',$data);
		}else{
			$data['title'] = '';
			$data['page'] = 'home';
			$questionOne = $this->math_question->questionOne();
			$questionTwo = $this->math_question->questionTwo();
			$this->session->set_flashdata('questionOne', $questionOne);
			$this->session->set_flashdata('questionTwo', $questionTwo);
			$data['q1'] = $questionOne;
			$data['q2'] = $questionTwo;
			$data['math_question'] = "What is {$questionOne} + {$questionTwo}?";
			$this->load->model("news_model");
			$data['news'] = $this->news_model->get_recent_news(null,"all","news_date",1,0);
			$data['special_actions']=$this->groups_model->get_latest_special_action(null,3,0);
			$data['notes']=$this->notes_model->getRecentNotes(null,"all","notes_date",true,3,0);
			$this->load->view('index',$data);
		}
	}
	
	/*function categories($cat_slug="all")
	{
		if ($this->redux_auth->logged_in()){
			$data['profile'] = $this->redux_auth->profile();
			$this->friend_model->my_friend($data['profile']->users_id);
			$data['friend'] = $this->friend_model->set;
			$data['sum_friend'] = $this->friend_model->total;
			$data['new_friend'] = $this->friend_model->request;
			$this->messages_model->my_messages($data['profile']->users_id);
			$this->messages_model->my_invitation($data['profile']->users_id);
			$data['new_message'] = $this->messages_model->newest;
			$data['new_group_invi'] = $this->messages_model->newest_group_invi;
			$data['new_mediscuss_invi'] = $this->messages_model->newest_mediscuss_invi;
			
			$data['template']='welcome';
		}else{
			$data['template'] = 'login_left';
		}
		
		$data['page'] = "home";

		$data['cat_slug'] = $cat_slug;
		
		
		$data['multimed_recent'] = $this->multimed_model->view_list(3, "pm_date desc", $cat_slug);
		$data['multimed_popular'] = $this->multimed_model->view_list(3, "pm_hits desc", $cat_slug);
		$data['wikimed_recent'] = $this->wikimed_model->view_list(3, $order="date_revision desc", $cat_slug);
		$data['wikimed_popular'] = $this->wikimed_model->view_list(3, $order="wm_hits desc", $cat_slug);
		$data['category'] = $this->category_model->get_list();
		$data['title'] = $this->config->item('home_title');
		$this->load->view('index');
	}*/
	
	function makeCalendar($users_id,$year=0,$month=0)
	{
		if ($month==0)
			$month=date("m");
		
		if ($year==0)
			$year=date("Y");
		
		$prefs = array (
               'show_next_prev'  => TRUE,
               'next_prev_url'   => base_url().'home/index/'
             );


		$this->load->library('calendar', $prefs);


		$data = array();
		
		$result=$this->groups_model->getAllSpecialAction($users_id,$month,$year);
		foreach ($result as $item):
			$data[$item->day]=base_url()."home/viewspecialaction/".$item->year."/".$item->month."/".$item->day;
		endforeach;
		
		return $data;
		
		//echo $this->calendar->generate($year, $month, $data);
		//echo $this->calendar->generate($this->uri->segment(3), $this->uri->segment(4));
	}
	
	function getSpecialAction($users_id,$page)
	{
			$total_resources=$this->groups_model->countSpecialAction($users_id);
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$table_groups=getGroupTable();
			
			$result=$this->groups_model->getSpecialAction($users_id,$page);
			foreach ($result as $item):
			//echo $item->a.sp_name;
			if ($item->sp_id !="")
			{
			$output.="<div  class=\"tab-article share span-11 last\">
					<h2><a href=\"".base_url()."groups/eventview/$item->sp_host/".str_replace(' ','-',$table_groups[$item->sp_host])."/".str_replace(' ','-',$item->sp_name)."/$item->sp_id\" >".$item->sp_name ."</a></h2>
					<a href=\"".base_url()."groups/eventview/$item->sp_host/".str_replace(' ','-',$table_groups[$item->sp_host])."/".str_replace(' ','-',$item->sp_name)."/$item->sp_id\"  class=\"more-link first\" >Read More</a>
					<ul class=\"article-meta\">
						<li>Groups :".$table_groups[$item->sp_host]."</li>
						<li>Posted :".$item->start_date."</li>
						<li>".$item->total_folowers." Group Member joined</li>
					</ul>
					<p>".$item->sp_description."</p>
				</div>";
			}
			endforeach; 
			return $output;
	}
	
	function getDiscussion($users_id,$page=1)
	{
			
			$total_resources=$this->discussion_model->countMyDiscussion($users_id);
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$table_users=getUserTable();
			$result=$this->discussion_model->getMyDiscussion($users_id,$page);

			
			foreach ($result as $item):
			$total_reply=$this->discussion_model->getTotal($item->discussion_id);
			$page_reply=$total_reply/5;
			if ($total_reply%5>0)
				$page_reply++;
			$expl=explode(".",$page_reply);
			$page_reply=$expl[0];
			$table_groups=getGroupTable();
			$page_reply=$total_reply/5;
			$output.="<div  class=\"tab-article share span-11 last\">
					<h2><a href=\"".base_url()."discussion/view/".$item->discussion_id."\" >".$item->discussion_subject  ."</a></h2>
					<a class=\"more-link first\"  href=\"".base_url()."discussion/view/".$item->discussion_id."\">Read More</a>
					<a class=\"reply second\"  href=\"".base_url()."discussion/view/".$item->discussion_id."/".$page_reply."\">Last Reply</a>
					<ul class=\"article-meta\">
						<li>Groups :</li>
						<li>Posted :".$item->discussion_start ."</li>
						<li>".$total_reply." Reply</li>
					</ul>
					<p>".$item->discussion_topic ."</p>
				</div>";
			endforeach; 
			return $output;
	}
	
	function getMyConsultation($users_id,$myconsultation)
	{
			$page=$myconsultation;
			$total_resources=$this->consultation_model->countMyConsultation($users_id);
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$table_users=getUserTable();
			$result=$this->consultation_model->getMyConsultation($users_id,$page);
			foreach ($result as $item):
			$output.="<div  class=\"tab-article share span-11 last\">
					
					<img src=\"".image_thumb($this->user->getPictureThumb($item->users_id), 150, 150)."\"  class=\"med\"/>
					<a href=\"".base_url()."consultation/single/".$item->qa_id."\"  class=\"more-link first\" >Read More</a>
					<ul class=\"article-meta\">
						<li>Author : <a class=\"entity\"  href=\"#\">".$table_users[$item->users_id]."</a></li>
						<li>Posted :".$item->date_question_published."</li>
					</ul>
					<p>".$item->question."</p>
				</div>";
			endforeach; 
			return $output;
	}
	
	function viewSpecialAction($year,$month,$day)
	{
		if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "profile";

					
					
					//$data['glist_uid'] 	= $this->groups_model->view_list_uid($data['profile']->users_id);
					//$this->newsletter_model->add("TEST","TEST",$senddate,0);
				$data["title"] = $this->config->item('home_title')." | "."My Profile"; 
				$data["sp"]=$this->getSpecialActionbyDate($year,$month,$day,$data['profile']->users_id);
				$this->load->view("user/view_sp",$data);
			}else{
				$data['template'] = 'login_left';
			}
	}
	
	function getSpecialActionbyDate($year,$month,$day,$users_id)
	{
			
			$output="";
			$table_groups=getGroupTable();
			
			$result=$this->groups_model->getMySpecialActionByDate($year,$month,$day,$users_id);
			foreach ($result as $item):
			//echo $item->sp_name;
			if ($item->sp_id !="")
			{
			$output.="<div  class=\"tab-article share span-11 last\">
					<h2><a href=\"".base_url()."groups/eventview/$item->sp_host/".str_replace(' ','-',$table_groups[$item->sp_host])."/".str_replace(' ','-',$item->sp_name)."/$item->sp_id\" >".$item->sp_name ."</a></h2>
					<a href=\"".base_url()."groups/eventview/$item->sp_host/".str_replace(' ','-',$table_groups[$item->sp_host])."/".str_replace(' ','-',$item->sp_name)."/$item->sp_id\"  class=\"more-link first\" >Read More</a>
					<ul class=\"article-meta\">
						<li>Groups :".$table_groups[$item->sp_host]."</li>
						<li>Posted :".$item->start_date."</li>
						<li>".$item->total_folowers." Group Member joined</li>
					</ul>
					<p>".$item->sp_description."</p>
				</div>";
			}
			endforeach; 
			return $output;
	}
	
	function submitstatus()
	{
		$status = $this->input->post('status_text');
		$receiver = $this->input->post('receiver');
		$user_id = $this->input->post('user_id');
		$date = $this->input->post('status_date');
		$is_group=$this->input->post('is_group');
		
		if (trim($is_group)=="")
			$this->status_model->setStatus($status,$user_id,$date,$receiver);
		else
			$this->status_model->setStatus($status,$user_id,$date,$receiver,$is_group);
		//$this->feeds_model->add($receiver,$status);
		if ($receiver==$user_id){
			makeFeed($user_id,'#',$status,2);
		}else{
			if(trim($is_group)==""){
      makeFeed($user_id,'#',$status,3);
      }
    }
		//header('Location: '.base_url().'/profile');
		//redirect('profile');
		//redirect('');
		if (trim($is_group)=="")
			header('Location: '.base_url().'/profile');
		else
			header('Location: '.getenv('HTTP_REFERER'));
	}
	
	public function preview($term,$id,$meta=null){
	 if($term=="special-action"){

    $sp = $this->groups_model->get_special_action_single($id,$meta);
    if(!empty($sp)){
      $data["title"] = $sp->sp_name." | Special Action Preview";
      $data["page"] = "home";
      $data["special_action"] = $sp;
      $this->load->view("special-action/preview",$data);
    }else{
      redirect("page404");
    }
    
   }else if($term=="notes"){
     
     $notes = $this->notes_model->getDetailNote($id);
     if(!empty($notes)){
     $data["title"] = $notes->notes_title." | Notes Preview";
     $data["page"] = "home";
     $data["note"] = $notes;
     $this->load->view("notes/preview",$data);
     }else{
        redirect("page404");
     }
   }
  
  }

	
}
?>