<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class category_model extends Model {

    public function category_model()
    {
        // Call the Model constructor
        parent::Model();
    }
    
    public function get_category_list($taxonomy)
    {
	$query = $this->db->get_where('term', array('term_taxonomy' => $taxonomy));
        return ($query->num_rows > 0)? $query->result() : array();
	
    }
    
    public function get_category_list_by_content($object_id, $content_id)
    {
	$this->db->select("term.*");
	$this->db->from("term_relationship");
	$this->db->join("term","term.term_id=term_relationship.term_id");
	$this->db->where("object_id",$object_id);
	$this->db->where("content_id",$content_id);
	$query = $this->db->get();
	return ($query->num_rows > 0)? $query->result() : array();
    }
    public function get_list()
    {
        $query = $this->db->get_where('term', array('term_taxonomy' => 'groups_categories'));
        return ($query->num_rows > 0)? $query->result() : array();
    }
	
	public function get_id($cat_slug)
	{
			$this->db->select('cat_id');
			$this->db->from('categories');
			$this->db->where('cat_slug',$cat_slug);
			$j = $this->db->get();
			return $j->row()->cat_id;
	}
	
	public function get_parent($child)
	{
		$this->db->select('cat_parent');
		$this->db->from('categories');
		$this->db->where('cat_name',$child);
		$i = $this->db->get();
		$parent = $i->row()->cat_parent;
		if($parent==0){
			return false;
		}else{
			$this->db->select('cat_name');
			$this->db->select('cat_slug');
			$this->db->from('categories');
			$this->db->where('cat_id',$parent);
			$j = $this->db->get();
			return $j->row();
		}
	}
	
	public function dropdown_list()
	{
		$option = "";
		$this->db->select('cat_id');
		$this->db->select('cat_name');
		$this->db->where('cat_parent',0);
		$query = $this->db->get('categories');
		
		foreach($query->result() as $cat){
			$option .= "<option value='".$cat->cat_id."'>".$cat->cat_name."</option>";
			$this->db->select('cat_id');
			$this->db->select('cat_name');
			$this->db->where('cat_parent',$cat->cat_id);
			$query2 = $this->db->get('categories');
			foreach($query2->result() as $cat):
				$option .= "<option value='".$cat->cat_id."'>&nbsp;&nbsp;&nbsp;&nbsp;".$cat->cat_name."</option>";
			endforeach;
		}
		return $option;
	}
	
	public function select_list()
	{
		//$option = array(array());
		$this->db->select('term_id');
		$this->db->select('term_name');
		$this->db->where('term_taxonomy','groups_categories');
		$query = $this->db->get('term');
		$i=0;
		foreach($query->result() as $cat){
			$option[$i]['term_id']	=	$cat->term_id;
			$option[$i]['term_name']=	$cat->term_name;
			$i++;
		}
		return $option;
	}
	
	public function dropdown_list_selected()
	{
		
		$option = "";
		$this->db->select('cat_id');
		$this->db->select('cat_name');
		$this->db->where('cat_parent',0);
		$query = $this->db->get('categories');
		
		foreach($query->result() as $cat){
			$option	.= "<option value='".$cat->cat_id."'".set_select('category', '".$cat->cat_id."')." >".$cat->cat_name."</option>";
			$this->db->select('cat_id');
			$this->db->select('cat_name');
			$this->db->where('cat_parent',$cat->cat_id);
			$query2 = $this->db->get('categories');
			foreach($query2->result() as $cat):
				$option .= "<option value='".$cat->cat_id."'".set_select('category', '$cat->cat_id')." >"."&nbsp;&nbsp;&nbsp;&nbsp;".$cat->cat_name."</option>";
			endforeach;
		}
		return $option;
	}
	
	public function term_relationship_submit($object_id,$content_id,$term_id){
	    $data = array('object_id'=>$object_id,
			'content_id'=>$content_id,
			'term_id'=>$term_id
			);
	    $this->db->insert('term_relationship', $data);

	    if($this->db->affected_rows() > 0){
		
		return "true";
	    }else{
		return "false";
	    }
	    
	}
	
	public function edit_term_relationship($object_id,$content_id,$category){
	    $data = array('term_id'=>$category
					  );
		$this->db->where("content_id",$content_id);
		$this->db->where("object_id",$object_id);
		$this->db->update("term_relationship", $data);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			
			return true;
		}else{
			return false;
		}
	}
	
	public function delete_term_relationship($object_id,$news_id){
	    $this->db->delete('tern_relationship', array('news_id' => $news_id,'object_id'=>$object_id));
	}
	
}
?>