<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class comment_model extends Model {
    public function comment_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');
    }
	
	public function view_list($related_id,$object)
	{
		
		$points = $this->tables['points'];
		$comment = $this->tables['comment'];
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$this->db->select($user.".username");
		$this->db->select($usermeta.".users_picture ");
		$this->db->select($comment.".comment_date,".
						  $comment.".comment_text,".
						  $comment.".comment_sender");
		$this->db->select($points.".points_level");
		$this->db->from($comment);
		
		$this->db->join($user,$comment.".comment_sender=".$user.".users_id",'left');
		$this->db->join($usermeta,$user.".users_id=".$usermeta.".users_id",'left');
		$this->db->join($points,$user.".users_id=".$points.".users_id",'left');
		
		$this->db->where($comment.".comment_object",$object);
		$this->db->where($comment.".related_id",$related_id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function add($comment,$sender,$object,$related_id,$date)
	{
		$data = array('comment_text'=>$comment,
					  'comment_sender'=>$sender,
					  'comment_object'=>$object,
					  'related_id'=>$related_id,
					  'comment_date'=>$date
					  );
		$this->db->insert($this->tables['comment'], $data);
		return ($this->db->affected_rows() > 0) ? true : false;
	}
	
	public function addComment($content_id,$term_id,$comment_sender,$comment_text,$date)
	{
		$data = array('content_id'=>$content_id,
					  'term_id'=>$term_id,
					  'comment_sender'=>$comment_sender,
					  'comment_text'=>$comment_text,
					  'comment_date'=>$date
					  );
		$this->db->insert($this->tables['comment'], $data);
		if($this->db->affected_rows() > 0){
      return true; 
    }else{
      return false;
    }
		//return ($this->db->affected_rows() > 0) ? true : false;
	}
	
	public function getTermID($term_name)
	{
		$this->db->select("term_id");
        $this->db->from("term");
        $this->db->where("term_name",$term_name);
		$i = $this->db->get();
		$output=0;
		if ($i->num_rows()>0)
		{
			foreach ($i->result() as $result)
			{
				$output=$result->term_id;
			} 
		}
		return $output;
	}
	
	public function getComments($term_id,$content_id,$num=5,$page=0)
	{
		
		$points = $this->tables['points'];
		$comment = $this->tables['comment'];
		$user = $this->tables['users'];
		$usermeta = 'users_meta';
		$this->db->select($user.".users_id");
		$this->db->select($user.".username");
		$this->db->select($user.".full_name");
		$this->db->select($usermeta.".users_picture ");
		$this->db->select($comment.".comment_date,".
						  $comment.".comment_text,".
						  $comment.".comment_id,".
						  $comment.".comment_sender");
		$this->db->from("comment");
		
		$this->db->join($user,$comment.".comment_sender=".$user.".users_id",'left');
		$this->db->join($usermeta,$user.".users_id=".$usermeta.".users_id",'left');
		$this->db->where($comment.".content_id",$content_id);
		$this->db->where($comment.".term_id",$term_id);
		$this->db->limit($num,$page);
		$this->db->orderby($comment.".comment_id", "desc");
		
		//$this->db->select("comment_text");
		//$this->db->from("comment");
		//$this->db->where("content_id",$content_id);
		//$this->db->where("term_id",$term_id);
		//$this->db->orderby("comment_id", "desc");
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function countComment($term_id,$content_id)
	{
		$this->db->from("comment");
		$this->db->where("content_id",$content_id);
		$this->db->where("term_id",$term_id);
		$output=$this->db->count_all_results();

		return $output;
	}
	
	public function update_comment_count($term_id,$content_id){
      $total_comment = $this->countComment($term_id,$content_id);
      $total_comment = $total_comment;
      $data = array(
               'comment_count' => $total_comment
            );
		  $this->db->where('notes_id', $content_id);
		  $this->db->update('notes', $data);
		  return ($this->db->affected_rows() > 0)? true : false;
  }
	
	public function deleteComment($content_id,$term_id){
		$this->db->delete('comment',array('content_id' => $content_id,'term_id' =>$term_id ));
	}
	
	public function delete($comment_id){
		$this->db->delete('comment',array('comment_id' => $comment_id));
		return ($this->db->affected_rows()>0)?true:false;
	}
	
	public function get_comment($comment_id){
    $this->db->from('comment');
    $this->db->where("comment_id",$comment_id);
    $i = $this->db->get();
    return ($i->num_rows()>0)?$i->row():array();
  }

}
?>