<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class consultation_model extends Model {
    public function consultation_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');
    }
	
	public function ask($expert_id,$user_id,$subject,$question,$term_id,$is_private,$date_question_published)
	{
		$data = array('users_id'=>$user_id,
		        'subject'=>$subject,
					  'expert_id'=>$expert_id,
					  'question'=>$question,
					  'term_id'=>$term_id,
					  'is_private'=>$is_private,
					  'date_question_published'=>$date_question_published
					  );
		$this->db->insert('consultation', $data);
		return ($this->db->affected_rows() > 0) ? $this->db->insert_id() : false;
	}
	
	public function answer($qa_id,$answer,$users_id)
	{
		$data = array(
               'reply_text' => $answer,
			         'qa_id' => $qa_id,
			         'reply_sender' => $users_id
            );

		$this->db->insert('consultation_reply ', $data); 
		return ($this->db->affected_rows() > 0) ? $this->db->insert_id() : false;

	}
	
	public function getExpert($user_id)
	{
		$output="<select name=\"expert_id\">";
		$CI =& get_instance();
    $my_expert = $CI->experts_model->view_experts($user_id);
		//$files_id=0;
		foreach ($my_expert as $row)
		{
			$output.="<option value=\"".$row->users_id."\">".$row->full_name."</option>";		
		}
		$output.="</select>";
		return $output;
	}
	
public function getQuestion($qa_id)
	{
		//$output="";
		//$this->db->query("select * from consultation where qa_id=".$qa_id);
		$this->db->select("consultation.*");
		$this->db->select("u1.full_name expert");
		$this->db->select("u2.full_name asker");
		$this->db->from("consultation");
		$this->db->join("users u1","consultation.expert_id=u1.users_id");
		$this->db->join("users u2","consultation.users_id=u2.users_id");
		$this->db->where("qa_id",$qa_id);
    $i = $this->db->get();
		return ($i->num_rows > 0)? $i->row() : array();
		//return $output;
	}
	
	public function getReply($qa_id,$page=0,$num=5)
	{
		/*$start=(($page-1)*$num);
		$end=$page*$num; */
		$this->db->select("consultation_reply.*");
		$this->db->select("users.full_name");
		$this->db->select("users_meta.users_picture");
		$this->db->select("users_meta.users_timezone");
		$this->db->from("consultation_reply ");
		$this->db->join("users","users.users_id=consultation_reply.reply_sender");
		$this->db->join("users_meta","users.users_id=users_meta.users_id");
		$this->db->where("qa_id",$qa_id);
		$this->db->orderby('reply_date', "desc");
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function countReply($qa_id)
	{
		$this->db->from("consultation_reply ");
		$this->db->where("qa_id",$qa_id);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getMyConsultation($users_id,$page,$num=5)
	{
		$start=(($page-1)*$num);
		$end=$page*$num;
		$this->db->from("consultation");
		$this->db->where("users_id",$users_id);
		$this->db->orderby('date_question_published', "desc");
		$this->db->limit($end,$start);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function get_list_consultation($users_id=null,$filter="all",$order="date_question_published desc",$page=0,$num=5)
	{
		$this->db->from("consultation");

		if($users_id!=null){
   		$this->db->where("users_id",$users_id);
		  $this->db->or_where("expert_id",$users_id);
    }
    if($filter!="all"){
      $this->db->where("term_id",$filter);
    }
		$this->db->orderby($order);
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function total_list_consultation($users_id=null,$filter="all")
	{
		$this->db->from("consultation");
    if($users_id!=null){
   		$this->db->where("users_id",$users_id);
		  $this->db->or_where("expert_id",$users_id);
    }
    if($filter!="all"){
      $this->db->where("term_id",$filter);
    }
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->num_rows() : 0;
	}
	
	public function get_network_consultation($users_id,$page,$num=5)
	{
		$friends = array();

		$this->db->select("users_id_request");
		$this->db->where("users_id_approve",$users_id);
		$this->db->where("status","friend");
		$query = $this->db->get("friendship");
		foreach ($query->result_array() as $row)
		{
			$friends[]=$row["users_id_request"];
		}
		$this->db->select("users_id_approve");
		$this->db->where("users_id_request",$users_id);
		$this->db->where("status","friend");
		$query = $this->db->get("friendship");
		foreach ($query->result_array() as $row)
		{
			$friends[]=$row["users_id_approve"];
		}
		
    $experts = array();

		$this->db->select("users_id_approve");
		$this->db->where("users_id_request",$users_id);
		$this->db->where("status","follow");
		$query = $this->db->get("friendship");
		foreach ($query->result_array() as $row)
		{
			$experts[]=$row["users_id_approve"];
		}
		
    $this->db->from("consultation");
    //$this->db->where("users_id",$users_id);
		$where = "users_id = ".$users_id;
    $where1 = "";
    $where2 = "";
		if ($friends !=array()){
		  //$this->db->or_where_in("users_id",$friends);
		  $friends_list = implode(",",$friends);
      $where1 = " OR users_id IN (".$friends_list.")";
		}
		if ($experts !=array()){
		  //$this->db->or_where_in("expert_id",$experts);
		  //$this->db->or_where_in("user_id",$experts);
		  $experts_list = implode(",",$experts);
		  $where2= " OR users_id IN (".$experts_list.") OR expert_id IN (".$experts_list.")";
		}
    $this->db->where("(".$where.$where1.$where2.")");
    $this->db->where("is_private",0);
		$this->db->orderby('date_question_published', "desc");
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function total_network_consultation($users_id)
	{
		$friends = array();

		$this->db->select("");
		$this->db->where("users_id_approve",$users_id);
		$this->db->where("status","friend");
		$query = $this->db->get("friendship");
		foreach ($query->result_array() as $row)
		{
			$friends[]=$row["users_id_request"];
		}
		$this->db->select("users_id_approve");
		$this->db->where("users_id_request",$users_id);
		$this->db->where("status","friend");
		$this->db->or_where("status","follow");
		$query = $this->db->get("friendship");
		foreach ($query->result_array() as $row)
		{
			$friends[]=$row["users_id_approve"];
		}
		
    $experts = array();

		$this->db->select("");
		$this->db->where("users_id_request",$users_id);
		$this->db->where("status","follow");
		$query = $this->db->get("friendship");
		foreach ($query->result_array() as $row)
		{
			$experts[]=$row["users_id_approve"];
		}
    $this->db->from("consultation");
		$this->db->where("users_id",$users_id);
		if ($friends !=array()){
		  $this->db->or_where_in("users_id",$friends);
		  
		}
		if ($experts !=array()){
		  $this->db->or_where_in("expert_id",$experts);
		  $this->db->or_where_in("users_id",$experts);
		}

		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->num_rows : 0;
	}
	
	public function countMyConsultation($users_id)
	{

		$this->db->from("consultation");
		$this->db->where("users_id",$users_id);
		$this->db->orderby('date_question_published', "desc");
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getMyFeatured($users_id,$page,$num=5)
	{
		$start=($page-1)*$num;
		$query=$this->db->query("SELECT * FROM consultation WHERE  users_id!=$users_id and is_private=0 Limit $start,$num");
		return $query->result();
	}
	
	public function countMyFeatured($users_id)
	{
		$query=$this->db->query("SELECT * FROM consultation WHERE  users_id!=$users_id and is_private=0 ");
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function get_answer($answer_id){
	 $query = $this->db->query("select * from consultation join consultation_reply on consultation.qa_id=consultation_reply.qa_id join users on users.users_id=consultation_reply.reply_sender where reply_id=".$answer_id);
	 return ($query->num_rows() > 0) ? $query->row() : false;
  }
  
  public function notification_question($expert_id){
     $query = $this->db->query("select qa_id from consultation where expert_id=".$expert_id." and is_answer=0");
     return ($query->num_rows() > 0) ? $query->num_rows() : 0;
  }
  
  public function update_is_answer($qa_id){
     $data = array('is_answer'=>1);
     $this->db->where("qa_id",$qa_id);
     $query = $this->db->update("consultation",$data);
     if($this->db->affected_rows() > 0){
			 return true;
		 }else{
			 return false;
		 }
  }
  
  public function update_is_read($qa_id){
     $data = array('is_read'=>1);
     $this->db->where("qa_id",$qa_id);
     $query = $this->db->update("consultation",$data);
     if($this->db->affected_rows() > 0){
			 return true;
		 }else{
			 return false;
		 }
  }
  
  public function pending_question($expert_id,$num,$page){
      $query = $this->db->query("select * from consultation where expert_id=".$expert_id." and is_answer=0 limit ".$page." ,".$num);
  		if($query->num_rows > 0){
  			//$this->num = $i->num_rows;
  			return $query->result();
  		}else{
  			//$this->num = 0;
  			return array();
  		}
  }
    	
}
?>