<?php
class Message_model extends Model {

    function Message_model()
    {
        // Call the Model constructor
        parent::Model();
    }
    
  function add($ms_id,$ms_sender,$ms_text,$ms_title)
	{
		$date=date('Y-m-d H:i:s');
		$data = array('ms_id'=>$ms_id,
					  'ms_sender'=>$ms_sender,
					  'ms_text'=>$ms_text,
					  'ms_title'=>$ms_title,
					  'ms_date'=>$date
					  );
		$this->db->insert('message', $data);
	}
	
	function all($user_id,$page=0,$num=5)
	{
		$this->db->from("message");
        $this->db->where("ms_id",$user_id);
        $this->db->where("parent",0);
		$this->db->orderby('ms_date', "desc");
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTotalAll($user_id)
	{
		$this->db->from("message");
        $this->db->where("ms_id",$user_id);
        $this->db->where("parent",0);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	function unread($user_id,$page=0,$num=5)
	{
		$this->db->from("message");
        $this->db->where("ms_id",$user_id);
        $this->db->where("is_read","0");
        $this->db->where("parent",0);
		$this->db->orderby('ms_date', "desc");
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTotalUnread($user_id)
	{
	
		$this->db->from("message");
        $this->db->where("ms_id",$user_id);
        $this->db->where("is_read","0");
        $this->db->where("parent",0);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	function sent($user_id,$page=0,$num=5)
	{
		$this->db->from("message");
    $this->db->where("ms_sender",$user_id);
    $this->db->where("parent",0);
		$this->db->orderby('ms_date', "desc");
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTotalSent($user_id)
	{
	
		$this->db->from("message");
        $this->db->where("ms_sender",$user_id);
        $this->db->where("parent",0);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getDetail($message_id)
	{
		$this->db->from("message");
        $this->db->where("message_id",$message_id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->row() : array();
	}
	
	function addReply($ms_sender,$ms_text,$parent)
	{
		$date=date('Y-m-d H:i:s');
		$data = array(
					  'ms_sender'=>$ms_sender,
					  'ms_text'=>$ms_text,
					  'ms_date'=>$date,
					  'parent'=>$parent,
					  );
		$this->db->insert('message', $data);
		
		$data = array(
               'is_read' => 0
            );

		$this->db->where('message_id', $parent);
		$this->db->update('message', $data); 

	}
	
	function isRead($message_id)
	{
		$data = array(
               'is_read' => 1
            );

		$this->db->where('message_id', $message_id);
		$this->db->update('message', $data); 

	}
	
	function isUnRead($message_id)
	{
		$data = array(
               'is_read' => 0
            );

		$this->db->where('message_id', $message_id);
		$this->db->update('message', $data); 

	}
	
	function getReply($message_id,$page,$num=5)
	{
		$start=(($page-1)*$num);
		$end=$page*$num; 
		$this->db->from("message");
        $this->db->where("parent",$message_id);
		$this->db->orderby('ms_date', "desc");
		$this->db->limit($end,$start);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTotalReply($message_id)
	{
	
		$this->db->from("message");
        $this->db->where("parent",$message_id);
		$output=$this->db->count_all_results();
		return $output;
	}
}
?>