<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class multimed_model extends Model {
    public function multimed_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');
    }
    
    public function recent($cat="all")
    {
		$multimed = $this->tables['multimed'];
		$file = $this->tables['files'];
		$mfile = $this->tables['multimed_file'];
		$user = $this->tables['users'];
		$this->db->select($multimed.".pm_title,".
						  $multimed.".pm_author,".
						  $multimed.".pm_slug,".
						  $multimed.".pm_id");
		$this->db->select($file.".files_thumb_mini");
		$this->db->select($user.".full_name");
		$this->db->from($multimed);
		$this->db->join($mfile, $multimed.'.pm_id = '.$mfile.'.multimed_pm_id', 'left');
		$this->db->join($file, $mfile.'.files_id = '.$file.'.files_id', 'left');
	
		$this->db->join($user, $user.'.users_id = '.$multimed.'.pm_author', 'left');
		if (!$cat=="all"){
			$this->db->where($multimed.'.term_id',$cat);
		}
		$this->db->where('pm_status','publish');
		$this->db->where($mfile.'.files_order','1');
		$this->db->order_by("pm_date","desc");
		$this->db->limit(3);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
    }
	
	public function popular($cat="all")
    {
		$multimed = $this->tables['multimed'];
		$file = $this->tables['files'];
		$mfile = $this->tables['multimed_file'];
		$user = $this->tables['users'];
		$this->db->select($multimed.".pm_title,".
						  $multimed.".pm_author,".
						  $multimed.".pm_slug,".
						  $multimed.".pm_id");
		$this->db->select($file.".files_thumb_mini");
		$this->db->select($user.".full_name");
		$this->db->from($multimed);
		$this->db->join($mfile, $multimed.'.pm_id = '.$mfile.'.multimed_pm_id', 'left');
		$this->db->join($file, $mfile.'.files_id = '.$file.'.files_id', 'left');
	
		$this->db->join($user, $user.'.users_id = '.$multimed.'.pm_author', 'left');
		if (!$cat=="all"){
			$this->db->where($multimed.'.term_id',$cat);
		}
		$this->db->where('pm_status','publish');
		$this->db->where($mfile.'.files_order','1');
		$this->db->order_by("pm_hits desc,comment_count desc");
		$this->db->limit(3);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
    }
	
	public function view_list($limit=10, $order="pm_date desc", $cat="all"){
		$multimed = $this->tables['multimed'];
		$file = $this->tables['files'];
		$mfile = $this->tables['multimed_file'];
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$category = $this->tables['category'];
		$cat_id = ($cat!="all")?$this->category_model->get_id($cat):0;
		$this->db->select($multimed.".pm_title,".
						  $multimed.".pm_author,".
						  $multimed.".pm_slug,".
						  $multimed.".pm_id,".
						  $multimed.".pm_date"
						  );
		$this->db->select($file.".files_thumb");
		$this->db->select($user.".full_name");
		/*$this->db->select($category.".term_name,".
						  $category.".term_slug");*/
		//$this->db->select($usermeta.".meta_value");
		$this->db->from($multimed);
		$this->db->join($mfile, $multimed.'.pm_id = '.$mfile.'.multimed_pm_id', 'left');
		$this->db->join($file, $mfile.'.files_id = '.$file.'.files_id', 'left');
	
		$this->db->join($user, $user.'.users_id = '.$multimed.'.pm_author', 'left');
		$this->db->join($usermeta, $user.'.users_id = '.$usermeta.'.users_id', 'left');
		//$this->db->join($category,$category.'.term_id = '.$multimed.'.term_id','left');
		//if ($cat!="all"){
			//$this->db->where($category.'.term_slug',$cat);
			//$this->db->or_where($category.'.term_parent',$term_id); 
		//}
		//$this->db->where($usermeta.'.meta_keys','picture_tumb');
		$this->db->where('pm_status','publish');
		$this->db->where($mfile.'.files_order','1');
		$this->db->order_by($order);
		$this->db->limit($limit);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function view_single($id){
		$multimed = $this->tables['multimed'];
		$file = $this->tables['files'];
		$mfile = $this->tables['multimed_file'];
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$category = $this->tables['category'];
		$this->db->select($multimed.".pm_title,".
						  $multimed.".pm_author,".
						  $multimed.".pm_slug,".
						  $multimed.".pm_id,".
						  $multimed.".pm_date,".
						  $multimed.".pm_resume,".
						  $multimed.".comment_count"
						  );
		$this->db->select($file.".files_link,".
						  $file.".files_type");
		
		$this->db->select($user.".full_name");
		$this->db->select($category.".cat_name,".
						  $category.".cat_slug");
		$this->db->select($usermeta.".users_picture_thumb");
		$this->db->from($multimed);
		$this->db->join($mfile, $multimed.'.pm_id = '.$mfile.'.multimed_pm_id', 'left');
		$this->db->join($file, $mfile.'.files_id = '.$file.'.files_id', 'left');
	
		$this->db->join($user, $user.'.users_id = '.$multimed.'.pm_author', 'left');
		$this->db->join($usermeta, $user.'.users_id = '.$usermeta.'.users_id', 'left');
		$this->db->join($category,$category.'.term_id = '.$multimed.'.term_id','left');
		$this->db->where($multimed.'.pm_id',$id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->row() : array();
	}	
	
	public function view_comment($id)
	{
		$multimed = $this->tables['multimed'];
		$points = $this->tables['points'];
		$comment = $this->tables['comment'];
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$this->db->select($user.".full_name");
		$this->db->select($usermeta.".users_picture_thumb");
		$this->db->select($comment.".comment_date,".
						  $comment.".comment_text");
		$this->db->select($points.".points_level");
		$this->db->from($multimed);
		$this->db->join($comment,$multimed.".pm_id=".$comment.".related_id",'left');
		$this->db->join($user,$comment.".comment_sender=".$user.".users_id",'left');
		$this->db->join($usermeta,$user.".users_id=".$usermeta.".users_id",'left');
		$this->db->join($points,$user.".users_id=".$points.".users_id",'left');
		$this->db->where($multimed.'.pm_id',$id);
		$this->db->where($comment.".comment_object","multimed");
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function view_supported_files($id)
	{
		$mfile = $this->tables['multimed_file'];
		$file = $this->tables['files'];
		$this->db->select($file.".files_name,".
						  $file.".files_link,".
						  $file.".files_desc");
		$this->db->from($file);
		$this->db->join($mfile,$mfile.".files_id=".$file.".files_id");
		$this->db->where($mfile.'.multimed_pm_id',$id);
		$this->db->where($mfile.".files_order >",'1');
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	
	
}
?>