<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Tools_model extends Model {
    public function Tools_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');
    }
	
	public function addTools($tools_name,$tools_description,$status,$user_role)
	{
		$date=date('Y-m-d h:i:s');
		$data = array(	'tools_name'=>$tools_name,
						'status'=>$status,
						'participant'=>$user_role,
						'last_update '=>$date,
					  	'tools_description'=>$tools_description
					  );
		$this->db->insert('tools', $data);
	}
	
	public function deleteTools($tools_id)
	{
		$this->db->delete('tools', array('tools_id' => $tools_id)); 
	}
	
	public function editTools($tools_id,$tools_name,$tools_description)
	{
					$data = array('tools_name'=>$tools_name,
					  'tools_description'=>$tools_description
					  );
					  
					  $this->db->where('tools_id', $tools_id);
					  $this->db->update('tools', $data); 
	}
	
	public function getTools($page,$num=5)
	{
		$start=(($page-1)*$num);
		$end=$page*$num;
		$this->db->from("tools");
		$this->db->orderby('tools_id', "asc");
		$this->db->limit($end,$start);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getToolsDetail($tools_id)
	{
		$this->db->from("tools");
		$this->db->where("tools_id",$tools_id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTotalTools()
	{
		$this->db->from("tools");
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getFirstModule($tools_id)
	{
		$module_id=0;
		$this->db->select("module_id");
        $this->db->from("tools_module");
        $this->db->where("tools_id",$tools_id);
        $this->db->where("module_sequence",1);
		$i = $this->db->get();
		$tumbnail="";		
		if ($i->num_rows()>0)
		{
			foreach ($i->result() as $result)
			{
				$module_id=$result->module_id;
			} 
		}
		return $module_id;
	}
	
	public function getNextModule($module_id,$tools_id)
	{
		$mdl_id=0;
		$query=$this->db->query("SELECT module_id FROM tools_module WHERE tools_id=$tools_id and module_sequence=(select module_sequence+1 from tools_module WHERE module_id=$module_id)");
		//echo "SELECT module_id FROM tools_module WHERE tools_id=$tools_id and module_sequence=(select module_sequence+1 from tools_module WHERE module_id=$module_id)";
		if ($this->db->count_all_results() > 0)
		{
			//$i = $this->db->get();
			foreach ($query->result() as $result)
			{
				$mdl_id=$result->module_id;
			} 
			
		}
		return $mdl_id;
	}
	
	public function getSequence($tools_id)
	{
		$module_id=0;
		$this->db->select("max(module_sequence) maxsequence");
        $this->db->from("tools_module");
        $this->db->where("tools_id",$tools_id);
		$i = $this->db->get();
		$module_id=0;		
		if ($i->num_rows()>0)
		{
			foreach ($i->result() as $result)
			{
				$module_id=$result->maxsequence;
			} 
		}
		$module_id++;
		return $module_id;
	}
	
	public function up($tools_id,$module_id,$module_sequence)
	{
		if ($module_sequence>1)
		{
					  $module_before=$module_sequence-1;
					  $data = array('module_sequence'=>$module_sequence
					  );			  
					  $this->db->where('module_sequence', $module_before);
					  $this->db->update('tools_module', $data); 
					  
					  
					  $data = array('module_sequence'=>$module_before
					  );			  
					  $this->db->where('module_id', $module_id);
					  $this->db->update('tools_module', $data); 
		}
	}
	
	public function down($tools_id,$module_id,$module_sequence)
	{
		$last=$this->getSequence($tools_id);
		$last--;
		if ($module_sequence<$last)
		{
					$module_after=$module_sequence+1;
					$data = array('module_sequence'=>$module_sequence
					  );			  
					  $this->db->where('module_sequence', $module_after);
					  $this->db->update('tools_module', $data); 
					  
					  $data = array('module_sequence'=>$module_after
					  );			  
					  $this->db->where('module_id', $module_id);
					  $this->db->update('tools_module', $data); 
		}
	}
	
	public function getModules($tools_id,$role=null,$page=0,$num=5)
	{
		$this->db->from("tools_module");
		$this->db->where("tools_id",$tools_id);
		if($role!=null){
    $this->db->where("role_requirement",$role);
    }
		$this->db->orderby('module_sequence ', "asc");
		//$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTemplate($questions_template_type )
	{

		$this->db->from("questions_template");
		$this->db->where("questions_template_type ",$questions_template_type );
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTotalModule($tools_id)
	{
		$this->db->from("tools_module");
		$this->db->where("tools_id",$tools_id);
		$this->db->orderby('module_sequence ', "asc");
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function addModule($module_name,$module_description,$module_instruction,$module_sequence,$module_requirement,$tools_id)
	{
		$data = array(	'module_name'=>$module_name,
						'module_sequence'=>$module_sequence,
						'module_description'=>$module_description,
						'module_instruction'=>$module_instruction,
						'module_requirement'=>$module_requirement,
					  	'tools_id'=>$tools_id
					  );
		$this->db->insert('tools_module', $data);
	}
	
	public function deleteModule($module_id)
	{
		$this->db->delete('tools_module', array('module_id' => $module_id)); 
	}
	
	public function editModule($module_id,$module_name,$module_sequence,$module_requirement,$tools_id)
	{
					$data = array(	'module_name'=>$module_name,
						'module_sequence'=>$module_sequence,
						'module_requirement'=>$module_requirement,
					  	'tools_id'=>$tools_id
					  );
					  
					  $this->db->where('module_id', $module_id);
					  $this->db->update('tools_module', $data); 
	}
	
	public function getQuestions($module_id)
	{
		$this->db->from("questions ");
		$this->db->where("module_id",$module_id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getTemplateDetail($template_id)
	{
		$this->db->from("questions_template");
		$this->db->where("questions_template_id",$template_id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function addQuestion($questions,$questions_type,$questions_param,$questions_answer,$module_id,$questions_template_id=0)
	{
		$data = array(	'questions'=>$questions,
						'questions_type'=>$questions_type,
						'questions_param'=>$questions_param,
						'questions_answer'=>$questions_answer,
						'questions_template_id'=>$questions_template_id,
					  	'module_id'=>$module_id
					  );
		$this->db->insert('questions', $data);
	}
	
	public function editQuestion($questions_id,$questions,$questions_type,$questions_param,$questions_answer,$module_id)
	{
		$data = array(	'questions'=>$questions,
						'questions_type'=>$questions_type,
						'questions_param'=>$questions_param,
						'questions_answer'=>$questions_answer,
					  	'module_id'=>$module_id
					  );
						$this->db->where('questions_id', $questions_id);
					  	$this->db->update('questions', $data); 
	}
	
	public function deleteQuestion($questions_id)
	{
		$this->db->delete('questions', array('questionss_id' => $questions_id)); 
	}
	
	public function addAnswer($users_id,$question_id,$answer,$module_id)
	{
		$data = array(	'users_id'=>$users_id,
						'questions_id'=>$question_id,
						'answer'=>$answer,
						'module_id'=>$module_id
					  );
		$this->db->insert('answer', $data);
	}
	
	public function editAnswer($users_id,$question_id,$answer)
	{
		$data = array(	'users_id'=>$users_id,
						'question_id'=>$question,
						'answer'=>$answer,
					  );
		$this->db->insert('tools_module', $data);
	}
	
	public function startTools($tools_id,$users_id,$next=true)
	{
		if ($next)
		{
			$running_module=$this->getNextModule($this->getFirstModule($tools_id),$tools_id);
			if ($running_module==0)
				$status=3;
			else
				$status=1;
			
			$this->addRunning($tools_id,$users_id,$running_module,$status);
		} else
		{
			$running_module=$this->getFirstModule($tools_id);
			$status=2;
			$this->addRunning($tools_id,$users_id,$running_module,$status);
		}
	}
	
	public function runTools($tools_id,$module_id,$users_id)
	{
		$next_module=$this->getNextModule($module_id,$tools_id);
		if ($next_module>0)
		{
			$data = array(	'running_module'=>$next_module);
							$this->db->where('tools_id', $tools_id);
							$this->db->where('users_id', $users_id);
							$this->db->update('running_tools', $data); 
		}else
		{
			$data = array(	'status'=>3);
							$this->db->where('tools_id', $tools_id);
							$this->db->where('users_id', $users_id);
							$this->db->update('running_tools', $data); 
		}
	}
	
	public function addRunning($tools_id,$users_id,$running_module,$status)
	{
		$data = array('tools_id'=>$tools_id,
					  'users_id'=>$users_id,
					  'running_module'=>$running_module,
					  'status'=>$status
					  );
		$this->db->insert('running_tools', $data);
	}
	
	public function addTemplate($questions_template_type,$question,$questions_template_param,$item_number,$questions_template_name)
	{
		$data = array('questions_template_type'=>$questions_template_type,
					  'question'=>$question,
					  'questions_template_param'=>$questions_template_param,
					  'questions_template_name'=>$questions_template_name,
					  'item_number'=>$item_number
					  );
		$this->db->insert('questions_template ', $data);
	}
	
	public function getAvailableTools($users_id,$num=5,$page=0)
	{
		
		$query=$this->db->query("SELECT * FROM tools WHERE tools_id NOT IN (select tools_id from running_tools where status='2' and users_id=$users_id) LIMIT $page,$num");
		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	public function getTotalAvailable($users_id)
	{
		$query=$this->db->query("SELECT * FROM tools WHERE tools_id NOT IN (select tools_id from running_tools where status='2' and users_id=$users_id)");
		//echo "SELECT * FROM tools WHERE tools_id NOT IN (select tools_id from running_tools where status='2' and users_id=$users_id)";
		return ($query->num_rows > 0)? $query->num_rows() : 0;
		//return $output;
	}
	
	public function getFinishedTools($users_id,$num=5,$page=0)
	{
		
		$query=$this->db->query("SELECT * FROM tools WHERE tools_id IN (select tools_id from running_tools where status='2' and users_id=$users_id) Limit $page,$num");
		//$i = $this->db->get();
		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	public function getTotalFinished($users_id)
	{
		$query=$this->db->query("SELECT * FROM tools WHERE tools_id IN (select tools_id from running_tools where status='2' and users_id=$users_id)");
		//$output=$this->db->count_all_results();
		return ($query->num_rows > 0)? $query->num_rows() : 0;
	}
	
	public function getRunningTools($tools_id,$users_id)
	{
		$this->db->from("running_tools ");
		$this->db->where("tools_id",$tools_id);
		$this->db->where("users_id",$users_id);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getModuleDetail($module_id)
	{
		$this->db->from("tools_module");
		$this->db->where("module_id",$module_id);
		$this->db->limit(1);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->row() : array();
	}
	
	public function getRunningModule($tools_id,$users_id)
	{
		
		/*$query=$this->db->query("SELECT * FROM tools_module WHERE module_id IN (select running_module from running_tools where users_id=$users_id)");
		if ($this->db->count_all_results()>0)
			return $query->result();
		else*/

		$this->db->select("running_module");
		$this->db->from("running_tools ");
		$this->db->where("tools_id",$tools_id);
		$this->db->where("users_id",$users_id);
		$i = $this->db->get();
		$mdl=0;		
		if ($i->num_rows()>0)
		{
			foreach ($i->result() as $result)
			{
				$mdl=$result->running_module;
			} 
		}
		if ($mdl>0)
			return $this->getModuleDetail($mdl);
		else
			return 0;
	}
	
	public function countModule($tools_id)
	{
		$this->db->from("tools_module");
		$this->db->where("tools_id",$tools_id);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getAllTools()
	{

		$this->db->from("tools");
		$this->db->where("status",2);
		$this->db->orderby('tools_id', "asc");
		
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function getAllModules($tools_id)
	{

		$this->db->from("tools_module");
		$this->db->where("tools_id",$tools_id);
		$this->db->orderby('module_sequence ', "asc");
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	
	
}
?>