<?php
class Users extends Controller {

	
	function users()
	{
		parent::Controller();
		$this->load->model("news_model");
	}
	                         
	function index()
	{
		 $this->browse();
	}
  
	function browse($role="all",$activation="all",$num=25,$page=0)
	{
		if (is_super()){
			$data['title'] = 'Users';
			$data['page'] = 'users';
			
			$data["users"] = $this->user_model->get_user_list($role,$activation,"date_register",$num,$page);
			$config['uri_segment'] = 7;
			$config['full_tag_open'] = '';
			$config['full_tag_close'] = '';
			$config['base_url'] = base_url()."cms/users/browse/".$role."/".$activation."/".$num."/";
			$config['total_rows'] = $this->user_model->total_users($role,$activation);
			$data['total_users'] =  $config['total_rows'];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view('admin/users',$data);
		}else{
		  redirect("cms");
		}
	}
  


	function submit()
	{
		$this->form_validation->set_rules('news_title', 'Page Title', 'required');
		$this->form_validation->set_rules('news_content', 'Page Content', 'required');
		$this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	    
		if ($this->form_validation->run() == false)
		{ 
			$this->browse();
		}else{
			$title = $this->input->post('news_title');
			$slug = url_title($title);
			$content = $this->input->post('news_content');
			$category = $this->input->post('news_category');
			$excerpt =  $this->input->post('news_excerpt');
			$author = $this->session->userdata("users_id");
			$content_id = $this->news_model->submit($title,$slug,$author,$content,$excerpt);
			if($content_id!=0){
			       $this->category_model->term_relationship_submit(getTermID("news"),$content_id,$category);
			}
			header('Location: '.getenv('HTTP_REFERER'));
		}

	}
  
	function search($filter=null,$key=null,$num=5,$page=0){
		if ($this->redux_auth->logged_in()){
			$data["page"] = "news";
			$data["title"] = "Search Result | Users";
			$config['uri_segment'] = 6;
			$filter = $this->input->post("filter");
			if($key==null){
				$key = $this->input->post("key");
				if($key==false){
				$key = "";
				}
			}
			$data["filter"] = $filter;
			$data['key'] = $key;
			$config['base_url'] = base_url()."cms/news/search/".$filter."/".$key."/".$num."/";
			$data["users"] = $this->news_model->search($filter,$key,$num,$page);
			$config['total_rows'] = $this->news_model->total_search($filter,$key);
			$data['total_users'] =  $config['total_rows'];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view("admin/users_search",$data);
		}else{
			redirect("cms");
		}
	}
  
	function preview($news_id)
	{
		$news = $this->news_model->get_news($news_id);
		if(empty($news)){
			redirect('page404');
		}else{
			$data['title'] = $news->news_title;
			$data['permalink'] = $news->news_permalink;
			$data['id'] = $news->news_id;
			$data['excerpt'] = $news->news_excerpt;
			$data['content']= $news->news_body;
			$data['last_edit'] = $news->news_date;
			$this->load->view('admin/news_preview',$data);
		}
	}
  
	function edit($news_id)
	{
	      $this->form_validation->set_rules('news_title', 'News Title', 'required');
	      $this->form_validation->set_rules('news_excerpt', 'News Excerpt', 'required');
	      $this->form_validation->set_rules('news_body', 'News Content', 'required');
	      $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	      $data["page"] = "news";
	      $object_id = getTermID("news");
	      if ($this->form_validation->run() == false)
	      { 
		      $data["title"] = "Edit News";
		      $data["news"] = $this->news_model->get_news($news_id);
		      $terms = $this->category_model->get_category_list_by_content($object_id, $news_id);
		      $arr_term = array();
		      foreach($terms as $term):
			      $arr_term["term_id"] = $term->term_id;
			      $arr_term["term_name"] = $term->term_name;
		      endforeach;
		      $data["term"] = $arr_term;
		      $this->load->view("admin/news_edit",$data);
	      }else{
		      $title = $this->input->post('news_title');
		      $slug = url_title($title);
		      $content = $this->input->post('news_body');
		      $category = $this->input->post('news_category');
		      $excerpt =  $this->input->post('news_excerpt');
		      $author = $this->session->userdata("users_id");
		      
		      $edit_content_id = $this->news_model->edit($news_id,$slug,$title,$content,$excerpt);
		      $edit_category = $this->category_model->edit_term_relationship($object_id,$news_id,$category);
		      header('Location: '.getenv('HTTP_REFERER'));
	      }
	}
  
  
  function delete()
  {
	if (is_editor()){
		$news_id = $this->input->post("content_id");
		$delete_news = $this->news_model->delete($news_id);
		$object_id = getTermID("news");
		if($delete_news){
			$this->category_model->delete_term_relationship($object_id,$news_id);
		}
	}else{
		redirect("cms");
	}
  }	
	

}
?>