<?php
class Notes extends Controller {
	function index(){
		parent::Controller();
		$this->browse();
	}
	function browse($submenu="featured",$cat="all",$num=5,$page=0){
		if($this->redux_auth->logged_in()){
			$data["title"] = "Notes";
			$data["page"] = "notes";
			$data["submenu"] = $submenu;
			//getRecentNotes($user_id,$cat="all",$order="notes_date",$expert=false,$num=5,$page=1);
			$config['uri_segment'] = 6;
			$config['base_url'] = base_url()."notes/browse/".$submenu."/".$cat."/".$num."/";
			$users_id = $this->session->userdata("users_id");
      if ($submenu == "my"){
				$data["my_notes"] = $this->notes_model->getRecentNotes($users_id,$cat,"notes_date",false,$num,$page);
				$config['total_rows'] = $this->notes_model->total_recent_notes($users_id,$cat);
				$this->pagination->initialize($config);
				$data["my_pagination"] =  $this->pagination->create_links();
			}elseif ($submenu == "featured"){
				$data["latest_notes"] = $this->notes_model->getRecentNotes(null,$cat,"notes_date",false,$num,$page);
				$config['total_rows'] = $this->notes_model->total_recent_notes(null,$cat);
				//echo $config['total_rows'];
				$this->pagination->initialize($config);
				$data["featured_pagination"] =  $this->pagination->create_links();
			}elseif($submenu == "popular"){
				$data["popular_notes"] = $this->notes_model->getRecentNotes(null,$cat,"comment_count",false,$num,$page);
				$config['total_rows'] = $this->notes_model->total_recent_notes(null,$cat);
				$this->pagination->initialize($config);
				$data["popular_pagination"] =  $this->pagination->create_links();
			}elseif($submenu == "expert"){
				$data["expert_notes"] = $this->notes_model->getRecentNotes(null,$cat,"notes_date",true,$num,$page);
				$config['total_rows'] = $this->notes_model->total_recent_notes(null,$cat,true);
				$this->pagination->initialize($config);
				$data["expert_pagination"] =  $this->pagination->create_links();
			}else{
      	redirect("page404");
      }
			
			
			$this->load->view("notes/index",$data);
		}else{		
			redirect("auth/login");
		}
		
	}
	
	function archive($cat="all",$user_id=null,$page=0){
		if($this->redux_auth->logged_in()){
			if ($user_id==null){
        $user_id = $this->session->userdata("users_id");
      }
      $data["title"] = "Notes";
			$data["page"] = "notes";
			//getRecentNotes($user_id,$cat="all",$order="notes_date",$expert=false,$num=5,$page=1);
			$data["pagination"] =  $this->pagination->create_links();
			
			$data["notes"] = $this->notes_model->getNetworkNotes($user_id,5,$page);
			
			$config['uri_segment'] = 5;
			$config['base_url'] = base_url()."notes/archive/".$cat."/".$user_id."/";
			$config["total_rows"] = $this->notes_model->total_network_notes($user_id);
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view("notes/archive",$data);
		}else{		
			redirect("auth/login");
		}
		
	}

	function view($id,$title,$comment_page=0){
		if($this->redux_auth->logged_in()){
			$data["title"] = $title;
			$data["page"] = "notes";
			$data["term_id"]=getTermID('notes');
			$data["total_comments"]=$this->comment_model->countComment($data["term_id"],$id);
			$data["total_like"]=$this->like_model->countLike(getTermID("notes"),$id);
      $data["id"]=$id;
			$data["note"]= $this->notes_model->getDetailNote($id);
			$data["author_note"] = $this->notes_model->getRecentNotes($data["note"]->notes_author,"all","notes_date",false,3,1);

			
			/*comment pagination */
      $config['uri_segment'] = 5;
		  $config['base_url'] = base_url()."notes/view/".$id."/".$title."/";
		  $data["comments"] = $this->comment_model->getComments($data["term_id"],$id,5,$comment_page);
		  $config["total_rows"]=$data["total_comments"];
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
			$this->load->view("notes/single",$data);
		}else{		
			redirect("auth/login");
		}
	}
	
function write_form($groups_share=0){

		if ($this->redux_auth->logged_in()){

			//$data['profile'] = $this->redux_auth->profile();

			$data["page"] = "notes";
			
			$data["groups_share"] = $groups_share;

			$data["title"] = "Write New Notes"; 

			$this->load->view("notes/write",$data);

		}else{

			redirect("auth/login");

		}

	}
	
	function submit()
	{
		$this->form_validation->set_rules('notes_text', 'Notes', 'required');
		$this->form_validation->set_rules('title_text', 'Title', 'required');
	  $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
	    
	    if ($this->form_validation->run() == false)
	    {
	        
			$data["page"] = "notes";

			$data["title"] = "Write New Notes"; 

			$this->load->view("notes/write",$data);

	    }else{
		
			$notes = $this->input->post('notes_text');

			$author = $this->input->post('notes_author');

			$title = $this->input->post('title_text');

			$excerpt = $this->input->post('notes_excerpt');

			$content_id = $this->notes_model->add($author,$title,$notes,$excerpt);
			
			$link = "view/".$content_id."/".url_title($title);
			if($content_id!=0){
				//$comment_count = $this->comment_model->countComment(1,$content_id);
				//$this->notes_model->updateCommentCount($content_id,$comment_count+1);
				$groups_share=$this->input->post('groups_share');
				if ($groups_share>0)
				{
					$this->groups_model->groupsShare($groups_share,$content_id,1,$author);
				}
				feeding("notes",$content_id);
			}
			redirect('notes/'.$link);
		}

	}
		
	function delete($note_id){
		if ($this->redux_auth->logged_in()){
			$delete_note = $this->notes_model->deleteNote($note_id);
			$term_id = getTermID("notes");
			$delete_comment = $this->comment_model->deleteComment($note_id,$term_id);
			//if($delete){
			$delete_feed = $this->feeds_model->deleteFeeds($term_id,$note_id);
			//}
			redirect("notes");
		}else{
			redirect("auth/login");
		}

	}
	
	function search($key=null,$num=5,$page=0){
      if ($this->redux_auth->logged_in()){
      $data["page"] = "notes";
		  $data["title"] = "Search Result | Notes";
		  $config['uri_segment'] = 5;
		   if($key==null){
        $key = $this->input->post("key");
        if($key==false){
          $key = "";
        }
      }
		  $data['key'] = $key;
		  $config['base_url'] = base_url()."notes/search/".$key."/".$num."/";
		  $data["notes"] = $this->notes_model->search($key,$num,$page);
		  $config['total_rows'] = $this->notes_model->total_search($key);
			$this->pagination->initialize($config);
			$data["pagination"] =  $this->pagination->create_links();
		  $this->load->view("notes/search_result",$data);
		  }else{
      redirect("auth/login");
      }
  }
	
	function comment(){
    $comment_text = $this->input->post('comment_text');
		$content_id = $this->input->post('content_id');
		$comment_sender = $this->input->post('comment_sender');
		$term_id = $this->input->post('term_id');
		//$comment_date = $this->input->post('comment_date');
    $comment_date = mdate('%Y-%m-%d %H:%i:%s');
		$term_id=$this->comment_model->getTermID($term_id);
		$submit = $this->comment_model->addComment($content_id,$term_id,$comment_sender,$comment_text,$comment_date);
    if($submit){
      $this->comment_model->update_comment_count($term_id,$content_id);
		  
    }
		header('Location: '.getenv('HTTP_REFERER'));
  }
  
  function delete_comment($comment_id){
     $comment = $this->comment_model->get_comment($comment_id);
     
     $delete = $this->comment_model->delete($comment_id);
     if($delete){
      $this->comment_model->update_comment_count($comment->term_id,$comment->content_id);
     }
     header('Location: '.getenv('HTTP_REFERER'));
  }

	
	
	

	
}
?>