<?php
class Tools extends controller{
		function Tools(){
			parent::Controller();
		}
		
		function index($page=1){
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["tools_content"] = $this->getTools($page);
				$data["tools_content_all"] = $this->getToolsNew($page);
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$this->load->view("tools/index",$data);
			}else{
				header('Location: '.base_url());
			}

			
		}
		
		function starttools($available=1,$finished=1)
		{
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$data["available"]=$this->getAvailableTools($data['profile']->users_id,$available,$finished);
				$data["finished"]=$this->getFinishedTools($data['profile']->users_id,$available,$finished);
				$this->load->view("tools/starttools",$data);
			}else{
				header('Location: '.base_url());
			}	
		}
		
	 /**
	 * Function Browse Tools
	 * 
	 * Get Tools list
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param string, integer, integer
	 * @return view 
	 * 
	 */
    function browse_tools($submenu="available",$num=5,$page=0)
		{
			if ($this->redux_auth->logged_in()){
				//$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "tools";
				$data["title"] = "Life Skill Tools";
				$data["submenu"] = $submenu;
				$config['uri_segment'] = 4;
        if($submenu=="available"){
        	$data["tools"] = $this->tools_model->getAvailableTools($this->session->userdata("users_id"),$num,$page);
				  $config['base_url'] = base_url()."tools/browse_tools/".$submenu."/".$num."/";
				  $config['total_rows'] = $this->tools_model->getTotalAvailable($this->session->userdata("users_id"));
				  $this->pagination->initialize($config);
				  //$data["x"]=$config['total_rows'];
				  $data["pagination"] =  $this->pagination->create_links();
        }elseif($submenu=="finished"){
          $data["tools"] =$this->tools_model->getFinishedTools($this->session->userdata("users_id"),$num,$page);
				  $config['base_url'] = base_url()."tools/browse_tools/".$submenu."/".$num."/";
				  $config['total_rows'] = $this->tools_model->getTotalFinished($this->session->userdata("users_id"));
				  $this->pagination->initialize($config);
				  $data["pagination"] =  $this->pagination->create_links();
        }else{
          redirect("page404");
        }
 
				$this->load->view("tools/browse_tools",$data);
			}else{
				redirect("page404");
			}	
		}
		
		function getAvailableTools($users_id,$available=1,$finished=1)
		{
			
			$total_resources=$this->tools_model->getTotalAvailable($users_id);
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$result=$this->tools_model->getAvailableTools($users_id,$available);
			//echo $result;
			foreach ($result as $item):
			$output.="<div  class=\"tab-article span-16 last\">
					<h2><a href=\"".base_url()."tools/browse_module/".$item->tools_id."/".$item->tools_permalink."\">".$item->tools_name."</a></h2>
					<a href=\"".base_url()."tools/browse_module/".$item->tools_id."/".$item->tools_permalink."\"  class=\"more-link first\" >Start</a>
					<p>".$item->tools_description."</p>
				</div>";
			endforeach;
			//echo $total_resources;
			return $output;
		}
		
		/**
	 * Function Browse Module
	 * 
	 * Get module list
	 *
	 * @author Ratna Mutia http://ratna.posterous.com
	 * @param integer
	 * @return view 
	 * 
	 */
    function browse_module($tools_id,$tools_title="")
		{
			if ($this->redux_auth->logged_in()){
				//$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["title"] = $tools_title." | Tools";
				$data["tools_detail"]=$this->tools_model->getToolsDetail($tools_id);
				if($data['profile']->users_role=="member"){
          $role="member";
        }else{
          $role="participant";
        }
        //if($submenu=="all"){	
				  $data["all_modules"]=$this->tools_model->getModules($tools_id);
				//}else($submenu=="todo"){
				  $data["todo_modules"]=$this->getToDo($tools_id,$data['profile']->users_id);
        //}else($submenu=="available"){
          $data["available_modules"]=$this->tools_model->getModules($tools_id,$role);
        //}else{
          //redirect("page404");
        //}
				//$data["todo_modules"]=$this->getToDo($tools_id,$data['profile']->users_id);
				$this->load->view("tools/browse_modules",$data);
			}else{
				redirect("auth/login");
			}	
		}
		
		function getToDo($tools_id,$users_id)
		{
			$output="";
			$total_running=$this->tools_model->getRunningTools($tools_id,$users_id);
			if ($total_running>0)
			{
				$module_id=$this->tools_model->getRunningTools($tools_id,$users_id);
				
				
			}else
			{
				$module_id=$this->tools_model->getFirstModule($tools_id);
				
				if ($module_id>0)
				{
					$item=$this->tools_model->getModuleDetail($module_id);
					$output.="<div  class=\"tab-article span-16 last\">
						<h2>
							</a>					
							<a href=\"".base_url()."tools/running/$tools_id/$module_id\" >".$item->module_name."</a>
						</h2>
						<p>".$item->module_description."</p>
					</div>";
				}
			}
			return $output;
		}
		
		function getAllModules($tools_id,$role=null)
		{
			//$page=$all;
			/*$config['uri_segment'] = 4;
      $config['base_url'] = base_url()."tools/startmodule/".$tools_id."/";
			$config['total_rows'] = $this->tools_model->getTotalModule($tools_id);
			$this->pagination->initialize($config);
			$pagination =  $this->pagination->create_links();*/
			//echo $total_resources;
			//$total_page=$total_resources/5;
			//if ($total_resources%5>0)
				//$total_page++;
			//$output=array();
			//$output["pagination"] = $pagination;
			return $this->tools_model->getModules($tools_id,$role,$num,$page);
			//$output["modules"] = $result;
			//echo $result;
			/*foreach ($result as $item):
			$output.="<div  class=\"tab-article span-16 last\">
					<h2>
						</a>					
						<a href=\"#\" >".$item->module_name."</a>
					</h2>
					<p>".$item->module_description."</p>
				</div>"; 
			endforeach;*/
			
			/*$after=2;
			$before=2;
			
			$before_page="";
			$count=1;
			for ($i=$page-1;$i>0;$i--)
			{
				$before_page.="<a href=\"".base_url()."tools/startmodule/$tools_id/$i/$finished"."\"  class=\"previous\" >".$i."</a>";
				if ($count==2)
					break;
				else
					$count++;
			}
			$after_page="";
			$count=1;
			for ($i=$page+1;$i<$total_page;$i++)
			{
				$after_page.="<a href=\"".base_url()."tools/startmodule/$tools_id/$i/$finished"."\"    class=\"previous\" >".$i."</a>";
				if ($count==2)
					break;
				else
					$count++;
			}
			
			$output.="<div  class=\"tab-article-paging\">";
			$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
			$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
			$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
			$output.="</div>";	
			*/	 
			//return $output;
		}
		
		function getfinishedTools($users_id,$available=1,$finished=1)
		{
			
			$total_resources=$this->tools_model->getTotalFinished($users_id);
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$result=$this->tools_model->getFinishedTools($users_id,$finished);
			//echo $result;
			foreach ($result as $item):
			$output.="<div  class=\"tab-article span-16 last\">
					<h2><a href=\"".base_url()."tools/startmodule/".$item->tools_id."\" >".$item->tools_name."</a></h2>
					<a href=\"".base_url()."tools/single/".$item->tools_id."\"  class=\"more-link first\" >Review</a>
					<p>".$item->tools_description."</p>
				</div>";
			endforeach;
			//echo $total_resources;
			return $output;
		}
		
		function insertquestion()
		{
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				//$data["tools_content"] = $this->getTools($page);
				$data["question_type"]=$_POST['question_type'];
				$template_id=0;
				if ($data["question_type"]=="questionaire")
					$template_id=$_POST['questionaire_template'];
				else if ($data["question_type"]=="polar")
					$template_id=$_POST['polar_template'];
				$data["template_id"]=$template_id;
				$data["tools_id"]=$_POST['tools_id'];
				$data["module_id"]=$_POST['module_id'];
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$this->load->view("tools/insertsinglequestion",$data);
			}else{
				header('Location: '.base_url());
			}
			
			
		}
		
		function insertpolar($tools_id,$module_id){
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["tools_id"] = $tools_id;
				$data["module_id"] = $module_id;
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$this->load->view("tools/polar_template",$data);
			}else{
				header('Location: '.base_url());
			}

			
		}
		
		function insertquestionaire($tools_id,$module_id){
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["tools_id"] = $tools_id;
				$data["module_id"] = $module_id;
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$this->load->view("tools/questionaire_template",$data);
			}else{
				header('Location: '.base_url());
			}

			
		}
		
		function getTools($page=1)
		{
			$total_resources=$this->tools_model->getTotalTools();
			//echo $total_resources;
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$result=$this->tools_model->getTools($page);
			//echo $result;
			foreach ($result as $item):
			$output.="<div  class=\"tab-article span-16 last\">
					<h2><a href=\"".base_url()."tools/module/".$item->tools_id."\" >".$item->tools_name."</a></h2>
					<a href=\"".base_url()."tools/single/".$item->tools_id."\"  class=\"more-link first\" >View</a>
					<p>".$item->tools_description."</p>
				</div>";
			endforeach;
			
			$after=2;
			$before=2;
			
			$before_page="";
			$count=1;
			for ($i=$page-1;$i>0;$i--)
			{
				$before_page.="<a href=\"".base_url()."tools/index//$i"."\"  class=\"previous\" >".$i."</a>";
				if ($count==2)
					break;
				else
					$count++;
			}
			$after_page="";
			$count=1;
			for ($i=$page+1;$i<$total_page;$i++)
			{
				$after_page.="<a href=\"".base_url()."tools/index/$i"."\"    class=\"previous\" >".$i."</a>";
				if ($count==2)
					break;
				else
					$count++;
			}
			
			$output.="<div  class=\"tab-article-paging\">";
			$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
			$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
			$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
			$output.="</div>";	
				 
			return $output;
		}
		
		function module($tools_id,$page=1)
		{
			
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["tools_id"] = $tools_id;
				$data["modules"]=$this->getModules($tools_id,$page);
				//$data["tools_content"] = $this->getTools($page);
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$this->load->view("tools/module",$data);
			}else{
				header('Location: '.base_url());
			}

		}
		
		function getModules($tools_id,$page=1)
		{
			$total_resources=$this->tools_model->getTotalModule($tools_id);
			//echo $total_resources;
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$result=$this->tools_model->getModules($tools_id,$page);
			//echo $result;
			foreach ($result as $item):
			$output.="<div  class=\"tab-article span-16 last\">
					<h2>
						<a href=\"".base_url()."tools/down/$tools_id/".$item->module_id."/".$item->module_sequence."\"  >
							<img src=\"".themes_url()."images/down.gif\"/>
						</a>					
						<a href=\"".base_url()."tools/up/$tools_id/".$item->module_id."/".$item->module_sequence."\"  >
							<img src=\"".themes_url()."images/up.gif\"/>
						</a>
						<a href=\"".base_url()."tools/question/$tools_id/".$item->tools_id."\" >".$item->module_name."</a>
					</h2>
					
					<a href=\"".base_url()."tools/question/$tools_id/".$item->module_id."\"  class=\"more-link first\" >View</a>
					<p>".$item->module_description."</p>
					<p> <b>Instruction :</b> ".$item->module_instruction."</p>
				</div>";
			endforeach;
			
			$after=2;
			$before=2;
			
			$before_page="";
			$count=1;
			for ($i=$page-1;$i>0;$i--)
			{
				$before_page.="<a href=\"".base_url()."tools/module/$tools_id/$i"."\"  class=\"previous\" >".$i."</a>";
				if ($count==2)
					break;
				else
					$count++;
			}
			$after_page="";
			$count=1;
			for ($i=$page+1;$i<$total_page;$i++)
			{
				$after_page.="<a href=\"".base_url()."tools/module/$tools_id/$i"."\"    class=\"previous\" >".$i."</a>";
				if ($count==2)
					break;
				else
					$count++;
			}
			
			$output.="<div  class=\"tab-article-paging\">";
			$output.="<a href=\"#\"  class=\"previous\" >Previous</a>";
			$output.=$before_page."<a href=\"#\"  class=\"next\" >$page</a>".$after_page;
			$output.="<a href=\"#\"  class=\"previous\" >Next</a>";
				
			$output.="</div>";	 
			return $output;
		}
		
		function up($tools_id,$module_id,$module_sequence)
		{
			$this->tools_model->up($tools_id,$module_id,$module_sequence);
			header('Location: '.getenv('HTTP_REFERER'));
		}
		
		function down($tools_id,$module_id,$module_sequence)
		{
			$this->tools_model->down($tools_id,$module_id,$module_sequence);
			header('Location: '.getenv('HTTP_REFERER'));
		}
		
		function question($tools_id,$module_id,$page=1)
		{
			
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["tools_id"] = $tools_id;
				$data["module_id"] = $module_id;
				$data["all_question"] = $this->getQuestions($module_id);
				$data["generated_question"]=$this->generateForm($module_id);
				//$data["modules"]=$this->getModules($tools_id,$page);
				//$data["tools_content"] = $this->getTools($page);
				$data["polar"] = $this->getTemplate("POLAR");
				$data["questionaire"] = $this->getTemplate("QUESTIONAIRE");
				$data["polar_template"] = $this->getListTemplate("POLAR");
				$data["questionaire_template"] = $this->getListTemplate("QUESTIONAIRE");
				$data["title"] = $this->config->item('home_title')." | "."My Tools";	
				$this->load->view("tools/question",$data);
			}else{
				header('Location: '.base_url());
			}

		}
		
		function submittools()
		{
			$tools_name=$_POST['tools_name'];
			$tools_description=$_POST['tools_description'];
			$user_role=$_POST['user_role'];
			$status=$_POST['status'];
			if ($status=="Publish")
				$status=2;
			else
				$status=1;
			//echo $status."-".$user_role;
			//echo $tools_name."-".$tools_description;
			$this->tools_model->addTools($tools_name,$tools_description,$status,$user_role);
			header('Location: '.getenv('HTTP_REFERER'));
		}
		
		function submitpolar()
		{
			$tools_id=$_POST['tools_id'];
			$module_id=$_POST['module_id'];
			$question=$_POST['question'];
			//$left_polarity=$_POST['left_polarity'];
			//$right_polarity=$_POST['right_polarity'];
			$number_item=$_POST['number_item'];
			$template_name=$_POST['template_name'];
			//echo $tools_name."-".$tools_description;
			$this->tools_model->addTemplate("POLAR",$question,"",$number_item,$template_name);
			redirect("tools/question/$tools_id/$module_id");
		}
		
		function submitquestionaire()
		{
			$tools_id=$_POST['tools_id'];
			$module_id=$_POST['module_id'];
			$preface=$_POST['preface'];
			$answer=$_POST['answer'];
			$template_name=$_POST['template_name'];
			$param="";
			foreach ($answer as $item)
			{
				//echo $item;
				$param.=$item.";";
			}
			$this->tools_model->addTemplate("QUESTIONAIRE",$preface,$param,0,$template_name);
			redirect("tools/question/$tools_id/$module_id");
		}
		
		function submitquestion()
		{
			$tools_id=$_POST['tools_id'];
			$module_id=$_POST['module_id'];
			$question_type=$_POST['question_type'];
				if ($question_type=="questionaire")
				{
					//$this->load->view("tools/single_questionaire");
					$question=$_POST['question'];
					$template_id=$_POST['template_id'];
					if (is_array($question))
					{
						$all_question="";
						for ($i=0;$i<count($question);$i++)
						{
								if (trim($question[$i])!="")
									$all_question.=";".$question[$i];
						}
						$this->tools_model->addQuestion("","QUESTIONAIRE",$all_question,"",$module_id,$template_id);
					}else
						$this->tools_model->addQuestion($question,"QUESTIONAIRE",$question,"",$module_id,$template_id);
				}
				else if ($question_type=="polar")
				{
					//$this->load->view("tools/single_polar");
					$left_polar=$_POST['left_polar'];
					$right_polar=$_POST['right_polar'];
					$template_id=$_POST['template_id'];
					
					if (is_array($left_polar))
					{
						$all_question="";
						for ($i=0;$i<count($left_polar);$i++)
						{
							if (trim($left_polar[$i])!="")
							{
								$param=$left_polar[$i].";".$right_polar[$i];
								$all_question.=";;".$param;
							}
						}
						$this->tools_model->addQuestion("","POLAR",$all_question,"",$module_id,$template_id);
					}else
					{
						$param=$left_polar.";".$right_polar;
						$this->tools_model->addQuestion("","POLAR",$param,"",$module_id,$template_id);
					}
				}
				else if ($question_type=="multiple")
				{
					//$this->load->view("tools/single_multiple");
					$question=$_POST['question'];
					$answer=$_POST['answer'];
					$correct=$_POST['correct'];
					if (is_array($answer))
					{
						$all_answer="";
						$correct_answer="";
						if (trim($answer[$correct])!="")
							$correct_answer=$answer[$correct];
						
						for ($i=0;$i<count($answer);$i++)
						{
							$temp=$answer[$i];
							if (trim($temp)!="")
								$all_answer.=$temp.";";
						}
						
						$this->tools_model->addQuestion($question,"MULTIPLE",$all_answer,$correct_answer,$module_id);
					}
				}
				else if ($question_type=="essay")
				{	
					//$this->load->view("tools/single_essay");
					$question=$_POST['question'];
					$numberanwser=$_POST['numberanwser'];
					$this->tools_model->addQuestion($question,"ESSAY",$numberanwser,"",$module_id);
				}
			redirect("tools/question/$tools_id/$module_id");
		}
		
		function submitmodule()
		{
			$module_name=$_POST['module_name'];
			$module_description=$_POST['module_description'];
			$module_instruction=$_POST['module_instruction'];
			$module_requirement="1";
			$tools_id=$_POST['tools_id'];
			$module_sequence=$this->tools_model->getSequence($tools_id);
			//echo $tools_name."-".$tools_description;
			$this->tools_model->addModule($module_name,$module_description,$module_instruction,$module_sequence,$module_requirement,$tools_id);
			header('Location: '.getenv('HTTP_REFERER'));
		}
		
		function getListTemplate($template)
		{
			$output="";
			if ($template=="POLAR")
				$output="<select name=\"polar_template\" id=\"polar_template\">";
			else
				$output="<select name=\"questionaire_template\" id=\"questionaire_template\">";
			
			$result=$this->tools_model->getTemplate($template);
			//echo $result;
			foreach ($result as $item)
			{
				$output.="<option value=\"".$item->questions_template_id."\">".$item->questions_template_name."</option>";
			}
			
			$output.="</select>";
			return $output;
		}
		
		function getTemplate($template)
		{
			$output="";
			$result=$this->tools_model->getTemplate($template);
			if ($template=="POLAR")
			{
					foreach ($result as $item)
					{
						$output.="<div  class=\"tab-article span-16 last\">
							<h2>
								<a href=\"#\" >".$item->questions_template_name ."</a>
							</h2>
							<p>".$item->question."</p>";
							$temp="Left Polarity &nbsp;&nbsp;&nbsp;";
							for ($i=0;$i<$item->item_number;$i++)
							{
								$temp.='<input type="radio" name="radio" />&nbsp;&nbsp;&nbsp;';
							}
							$temp.="Right Polarity";
						$output.="	<p>".$temp."</p>
						</div>";
					}
			}
			else
			{
					
					foreach ($result as $item)
					{
						$output.="<div  class=\"tab-article span-16 last\">
							<h2>
								<a href=\"#\" >".$item->questions_template_name ."</a>
							</h2>";
							$temp="<table><tr><td>".$item->question."</td>";
							$split=explode(";",$item->questions_template_param);
							for ($i=0;$i<count($split);$i++)
							{
								$temp.='<td>'.$split[$i].'</td>';
							}
							$temp.="</tr></table>";
						$output.="	<p>".$temp."</p>
						</div>";
					}
			}
			
			//echo $result;

			return $output;
		}
		
		function getQuestions($module_id)
		{
			$output="";
			$result=$this->tools_model->getQuestions($module_id);
			//echo $result;
			$i=1;
			foreach ($result as $item):
			$output.="<div  class=\"tab-article span-16 last\">
					<h2>
						<a href=\"#\" >Question#".$i." ".$item->questions_type."</a>
					</h2>
					<p>".$item->questions ."</p>";
			if ($item->questions_type=="POLAR")
			{
				$param=explode(";",$item->questions_param);
				$output.="<p>Left Polarity : ".$param[0]."</p>";
				$output.="<p>Right Polarity : ".$param[1]."</p>";
			}
			$output.="</div>";
			$i++;
			endforeach;
 
			return $output;
		}
		
		function generateForm($module_id)
		{
			$output="";
			$result=$this->tools_model->getQuestions($module_id);
			//echo $result;
			
			$output.="<table>";
			foreach ($result as $item):
				if ($item->questions_type=="POLAR")
				{
					$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
					$param_all=explode(";;",$item->questions_param);
					$output.="<tr><td>";
					$output.=$template[0]->question;
					for ($h=0;$h<count($param_all);$h++)
					{
						//echo $param_all[$h]."<br>";
						if (trim($param_all[$h]!=""))
						{
							$param=explode(";",$param_all[$h]);
							$output.="<br/>".$param[0]."&nbsp;&nbsp;&nbsp;";
							for ($i=0;$i<$template[0]->item_number;$i++)
							{
								$output.='<input type="radio" name="module'.$item->questions_id.'" value="'.$i.'" />&nbsp;&nbsp;&nbsp;';
							}
							$output.=$param[1]."<br/>";
						}
					}
					$output.="</td></tr>";
				}else if ($item->questions_type=="QUESTIONAIRE")
				{
					$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
					$all_param=explode(";",$item->questions_param);
					$param=explode(";",$template[0]->questions_template_param);
					$output.="<tr><td>";
					for ($h=0;$h<count($all_param);$h++)
					{
						if (trim($all_param[$h]!=""))
						{
							$output.="<br/>".$template[0]->question;
							$output.="<br/>".$all_param[$h]."<br/>";
							for ($i=0;$i<count($param);$i++)
							{
								if (trim($param[$i])!="")
								$output.='<input type="radio" name="module'.$item->questions_id.'" value="'.$param[$i].'" />'.$param[$i].'<br/>';
							}
						}
					}
					
					$output.="</td></tr>";
				}else if ($item->questions_type=="MULTIPLE")
				{
					$output.="<tr><td>";
					$param=explode(";",$item->questions_param);
					$output.="<br/>".$item->questions."<br/>";
					for ($i=0;$i<count($param);$i++)
					{
						if (trim($param[$i])!="")
						$output.='<input type="radio" name="module'.$item->questions_id.'" value="'.$param[$i].'" />'.$param[$i].'<br/>';
					}
					$output.="</td></tr>";
				}else if ($item->questions_type=="ESSAY")
				{
					$output.="<tr><td>";
					$param=$item->questions_param;
					$output.="<br/>".$item->questions."<br/>";
					for ($i=0;$i<$param;$i++)
					{
						$output.='<input type="text" name="module'.$item->questions_id.'[]" /><br/>';
					}
					$output.="</td></tr>";
				}
				
				$output.="<tr>";
				$output.="<tr>";
				
			endforeach;
 			$output.="</table>";
			return $output;
		}
		
		function running($tools_id,$module_id)
		{
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "Tools";
				$data["tools_id"] = $tools_id;
				$data["title"] = "Life Skill Tools";
				$data["module_id"] = $module_id;
				$data["form"] = $this->generateFormRunning($module_id);
				$this->load->view("tools/running",$data);
			}else{
				header('Location: '.base_url());
			}
		}
		
		function generateFormRunning($module_id)
		{
			$output="";
			$result=$this->tools_model->getQuestions($module_id);
			//echo $result;
			$total_page=count($result)/5;
			if (count($result)%5>0)
				$total_page++;
			$output.="<div id=\"tabs\" class=\"tab-titles span-16 last\">
				<ul>";
			for ($i=1;$i<=$total_page;$i++)
			{
				$output.="<li><a href=\"#\" rel=\"rel$i\" class=\"active\" ><span>$i</span></a></li>";
			}
			$output.="</ul>
			</div>";
			$item_i=0;
			foreach ($result as $item):
				//echo $item_i."-";
				if ($item_i%5==0)
				{
					$page=($item_i/5)+1;
					$output.="<div id=\"rel$page\" class=\"archive tab-content span-16 last \" >
					<h3>Available</h3>
					<table>";
				}
				if ($item->questions_type=="POLAR")
				{
					/*
					$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
					$param=explode(";",$item->questions_param);
					$output.="<tr><td><div  class=\"tab-article module span-16 last\"><p class=\"large\"> ";
					$output.=$template[0]->question;
					$output.="</p><br/>".$param[0]."&nbsp;&nbsp;&nbsp;";
					for ($i=0;$i<$template[0]->item_number;$i++)
					{
						$output.='<input type="radio" name="module'.$item->questions_id.'" value="'.$i.'" />&nbsp;&nbsp;&nbsp;';
					}
					$output.=$param[1];
					$output.="</div></td></tr>";*/
					
					$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
					$param_all=explode(";;",$item->questions_param);
					$output.="<tr><td><div  class=\"tab-article module span-16 last\"><p class=\"large\"> ";
					$output.=$template[0]->question;
					for ($h=0;$h<count($param_all);$h++)
					{
						//echo $param_all[$h]."<br>";
						if (trim($param_all[$h]!=""))
						{
							$param=explode(";",$param_all[$h]);
							$output.="</p><br/>".$param[0]."&nbsp;&nbsp;&nbsp;";
							for ($i=0;$i<$template[0]->item_number;$i++)
							{
								$output.='<input type="radio" name="module'.$item->questions_id.$h.'" value="'.$i.'" />&nbsp;&nbsp;&nbsp;';
							}
							$output.=$param[1]."<br/>";
						}
					}
					$output.="</div></td></tr>";
					
				}else if ($item->questions_type=="QUESTIONAIRE")
				{
					/*
					$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
					$param=explode(";",$template[0]->questions_template_param);
					$output.="<tr><td><div  class=\"tab-article module span-16 last\">";
					$output.="<br/>".$template[0]->question;
					$output.="<br/><p class=\"large\">".$item->questions."</p><br/>";
					for ($i=0;$i<count($param);$i++)
					{
						if (trim($param[$i])!="")
						$output.='<input type="radio" name="module'.$item->questions_id.'" value="'.$param[$i].'" />'.$param[$i].'<br/>';
					}
					
					$output.="</div></td></tr>";*/
					
					
					$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
					$all_param=explode(";",$item->questions_param);
					$param=explode(";",$template[0]->questions_template_param);
					$output.="<tr><td><div  class=\"tab-article module span-16 last\">";
					$output.="<p class=\"large\">".$template[0]->question."</p>";
					$counter=0;
					for ($h=0;$h<count($all_param);$h++)
					{
						
						if (trim($all_param[$h]!=""))
						{
							
							$output.=$all_param[$h]."<br/>";							
							for ($i=0;$i<count($param);$i++)
							{
								if (trim($param[$i])!="")
								{
								$output.='<input type="radio" name="module'.$item->questions_id.$counter.'" value="'.$param[$i].'" />'.$param[$i].'<br/>';
								}
							}
							$counter++;
						}
					}
					
					$output.="</div></td></tr>";
					
					
					
					
				}else if ($item->questions_type=="MULTIPLE")
				{
					$output.="<tr><td><div  class=\"tab-article module span-16 last\">";
					$param=explode(";",$item->questions_param);
					$output.="<p class=\"large\">".$item->questions."</p>";
					for ($i=0;$i<count($param);$i++)
					{
						if (trim($param[$i])!="")
						$output.='<input type="radio" name="module'.$item->questions_id.'" value="'.$param[$i].'" />'.$param[$i].'<br/>';
					}
					$output.="</div></td></tr>";
				}else if ($item->questions_type=="ESSAY")
				{
					$output.="<tr><td><div  class=\"tab-article module span-16 last\">";
					$param=$item->questions_param;
					$output.="<p class=\"large\">".$item->questions."</p>";
					for ($i=0;$i<$param;$i++)
					{
						$output.='<input type="text" name="module'.$item->questions_id.'[]" /><br/>';
					}
					$output.="</div></td></tr>";
				}
				
				$item_i++;
				if ($item_i%5==0)
				{
					//$page=$i+1;
					$output.="</table></div>";
				}
			endforeach;
				if ($item_i%5!=0)
				{
					//$page=$i+1;
					$output.="</table></div>";
				}
 			$output.="";
			return $output;
		}
		
		function submit()
		{
			if ($this->redux_auth->logged_in()){
				$data['profile'] = $this->redux_auth->profile();
				$tools_id=$_POST['tools_id'];
				$module_id=$_POST['module_id'];
				$result=$this->tools_model->getQuestions($module_id);
				foreach ($result as $item):
					$qid=$item->questions_id;
					$postid="module".$qid;
					//$answer=$_POST[$postid];
					//echo " Question ID : ".$qid."-".$answer;
					if ($item->questions_type=="POLAR")
					{
						$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
						$param_all=explode(";;",$item->questions_param);
						$all_answer="";
						//echo count($param_all);
						for ($i=1;$i<count($param_all);$i++)
						{
							$answer=$postid.$i;
							$all_answer.=";".$this->input->post($answer);
						}
						$this->tools_model->addAnswer($data['profile']->users_id,$qid,$all_answer,$module_id);
					}else if ($item->questions_type=="QUESTIONAIRE")
					{
						$template=$this->tools_model->getTemplateDetail($item->questions_template_id);
						$all_param=explode(";",$item->questions_param);
						$param=explode(";",$template[0]->questions_template_param);
						$all_answer="";
						$counter=0;
						for ($i=1;$i<count($all_param);$i++)
						{
							if ($all_param!="")
							{
								$answer=$postid.$counter;
								$all_answer.=";".$this->input->post($answer);
								$counter++;
							}
						}
						$this->tools_model->addAnswer($data['profile']->users_id,$qid,$all_answer,$module_id);
					}else if ($item->questions_type=="MULTIPLE")
					{
						$answer=$_POST[$postid];
						$this->tools_model->addAnswer($data['profile']->users_id,$qid,$answer,$module_id);
						
					}else if ($item->questions_type=="ESSAY")
					{
						$answer=$_POST[$postid];
						$all_answer="";
						if (is_array($answer))
						{
							for ($i=0;$i<count($answer);$i++)
							{
								if (trim($answer[$i])!="")
								{
									$all_answer.=";".$answer[$i];
								}
							}
							$this->tools_model->addAnswer($data['profile']->users_id,$qid,$all_answer,$module_id);
						}else
						{
							$this->tools_model->addAnswer($data['profile']->users_id,$qid,$answer,$module_id);
						}
					}
				endforeach;
				$first_module=$this->tools_model->getFirstModule($tools_id);
				if ($first_module==$module_id)
					$this->tools_model->startTools($tools_id,$data['profile']->users_id);
				else
					$this->tools_model->runTools($tools_id,$module_id,$data['profile']->users_id);
				 
			}else{
				header('Location: '.base_url());
			}
			
		}
		
		
		function getToolsNew($page=1)
		{
			$total_resources=$this->tools_model->getTotalTools();
			//echo $total_resources;
			$total_page=$total_resources/5;
			if ($total_resources%5>0)
				$total_page++;
			$output="";
			$result=$this->tools_model->getTools($page);
			//echo $result;
			$i=1;
			foreach ($result as $item):
			$output.="<tr>
					<td>$i</td>
					<td>$item->tools_name</td>
					<td>$item->tools_id</td>
					<td>".$this->tools_model->countModule($item->tools_id)."</td>";
			if ($item->status==2)
					$output.="<td>Publish</td>";
			else
					$output.="<td>Draft</td>";
			$output.="<td>$item->last_update</td>
					<td><a href=\"".base_url()."tools/module/".$item->tools_id."\" >View</a></td>
					
				</tr>";
			$i++;
			endforeach;				 
			return $output;
		}
		
		public function view_module($module_id,$module_permalink){
      if ($this->redux_auth->logged_in()){
        //$this->load->module("tools_module");
				//$data['profile'] = $this->redux_auth->profile();
				$data["page"] = "tools";
				$data["title"] = $module_permalink;
				$data["message"] = "";
				$module = $this->tools_model->getModuleDetail($module_id);
				if(!empty($module)){
    				if($module->is_plugin==1){
             redirect("module".$module_id."/view");
            }else{
              $this->load->view("tools/view_module",$data);
            }
				
        }else{
        redirect("page404");
        }
				
				//$this->load->file("plugins/bintang-terang/module-1-menerapkan-bintang-terang.php",$data);
			}else{
				redirect("page404");
			}
    }
    
		


}
?>