<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" :
 * <thepixeldeveloper@googlemail.com> wrote this file. As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return Mathew Davies
 * ----------------------------------------------------------------------------
 */
 
/**
* Redux Authentication 2
*/
class redux_auth
{
	/**
	 * CodeIgniter global
	 *
	 * @var string
	 **/
	protected $ci;

	/**
	 * account status ('not_activated', etc ...)
	 *
	 * @var string
	 **/
	protected $status;

	/**
	 * __construct
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function __construct()
	{
		$this->ci =& get_instance();
		$email = $this->ci->config->item('email');
		$this->ci->load->library('email', $email);
	}
	
	/**
	 * Activate user.
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function activate($code,$email)
	{
		return $this->ci->redux_auth_model->activate($code,$email);
	}
	
	/**
	 * Deactivate user.
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function deactivate($identity)
	{
	    return $this->ci->redux_auth_model->deactivate($code);
	}
	
	/**
	 * Change password.
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function change_password($identity, $old, $new)
	{
        return $this->ci->redux_auth_model->change_password($identity, $old, $new);
	}

	/**
	 * forgotten password feature
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function forgotten_password($email)
	{
		$forgotten_password = $this->ci->redux_auth_model->forgotten_password($email);
		
		if ($forgotten_password)
		{
			// Get user information.
			$profile = $this->ci->redux_auth_model->profile($email);
			$code = $this->ci->redux_auth_model->forgotten_password_code;
			$link = site_url("auth/forgotten_password_complete/".$code);

			$data = array('identity'                => $profile->{$this->ci->config->item('identity')},
    			          'forgotten_password_code' => $this->ci->redux_auth_model->forgotten_password_code,
                    'username' => $profile->full_name,
                    'code'=>$code,
                    'link'=>$link);
                
			$message = $this->ci->load->view($this->ci->config->item('email_templates').'forgotten_password', $data, true);
				
			$this->ci->email->clear();
			$this->ci->email->set_newline("\r\n");
			$this->ci->email->from('', '');
			$this->ci->email->to($profile->email);
			$this->ci->email->subject('Email Verification (Forgotten Password)');
			$this->ci->email->message($message);
			return $this->ci->email->send();
			echo $this->ci->email->debugger;
		}
		else
		{
			//echo "tes";
      return false;
		}
	}
	
	/**
	 * undocumented function
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function forgotten_password_complete($code)
	{
	    $identity                 = $this->ci->config->item('identity');
	    $noreply                 = $this->ci->config->item('email_noreply');
	    $profile                  = $this->ci->redux_auth_model->profile($code);
		  $forgotten_password_complete = $this->ci->redux_auth_model->forgotten_password_complete($code);

		if ($forgotten_password_complete)
		{
			$data = array('username'    => $profile->full_name,
				         'new_password' => $this->ci->redux_auth_model->new_password);
            
			$message = $this->ci->load->view($this->ci->config->item('email_templates').'new_password', $data, true);
				
			$this->ci->email->clear(TRUE);
			$this->ci->email->set_newline("\r\n");
			$this->ci->email->from('ratna.mutia.suci@gmail.com', 'Suksesmulia.com');
			$this->ci->email->to($profile->email);
			$this->ci->email->subject('Suksesmulia.com New Password');
			$this->ci->email->message($message);
			return $this->ci->email->send();
			//echo $this->email->print_debugger();
		}
		else
		{
			return false;
		}
	}

	/**
	 * register
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function register($username, $password, $email)
	{
	    $email_activation = $this->ci->config->item('email_activation');
	    $email_folder     = $this->ci->config->item('email_templates');
	    $email_from    = $this->ci->config->item('email_noreply');
	    $email_sender    = $this->ci->config->item('email_sender');
	    $email_subject =   $this->ci->config->item('email_activation_subject');

		if (!$email_activation)
		{
			return $this->ci->redux_auth_model->register($username, $password, $email);
		}
		else
		{
			$register = $this->ci->redux_auth_model->register($username, $password, $email);
            
			if (!$register) { return false; }

			$deactivate = $this->ci->redux_auth_model->deactivate($email);

			if (!$deactivate) { return false; }

			$key = $this->ci->redux_auth_model->activation_code;
			$link = base_url().'auth/activate/'.$key.'/'.$email;

			$data = array('username' => $username,
        				'password'   => $password,
        				'email'      => $email,
        				'link'       => $link,
        				'code' => $key);
            
			$message = $this->ci->load->view($email_folder.'activation', $data, true);
            
			$this->ci->email->clear();
			$this->ci->email->set_newline("\r\n");
			$this->ci->email->from($email_from, $email_sender);
			$this->ci->email->to($email);
			$this->ci->email->subject($email_subject);
			$this->ci->email->message($message);
			
			$this->ci->email->send();
			return $register;
		}
	}
	
	/**
	 * login
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function login($identity, $password)
	{
		return $this->ci->redux_auth_model->login($identity, $password);
	}
	
	
	/**
	 * logout
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function logout()
	{
	    $identity = $this->ci->config->item('identity');
	    $this->ci->session->unset_userdata($identity);
		$this->ci->session->sess_destroy();
	}
	
	/**
	 * logged_in
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function logged_in()
	{
	    $identity = $this->ci->config->item('identity');
		return ($this->ci->session->userdata($identity)) ? true : false;
	}
	
	/**
	 * Profile
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function profile()
	{
	    $session  = $this->ci->config->item('identity');
	    $identity = $this->ci->session->userdata($session);
	    return $this->ci->redux_auth_model->profile($identity);
	}
	
	public function is_activate()
	{
      $session  = $this->ci->config->item('identity');
	    $identity = $this->ci->session->userdata($session);
      return $this->ci->redux_auth_model->is_activate($identity);
  }
  
  public function friends_network()
  {
	$identity = $this->ci->session->userdata("users_id");
	return $this->ci->redux_auth_model->friends_network($identity);
  }
  public function groups_network()
  {
	$identity = $this->ci->session->userdata("users_id");
	return $this->ci->redux_auth_model->groups_network($identity);
  }
  public function experts_network()
  {
	$identity = $this->ci->session->userdata("users_id");
	return $this->ci->redux_auth_model->experts_network($identity);
  }
	
	
}
