<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class discussions_model extends Model {

  public function discussions_model()
    {
        parent::Model();
        $this->tables  = $this->config->item('tables');
        $this->columns = $this->config->item('columns');
    }

	public function get_list($users_id=null,$is_groups,$order="discussion_start desc",$num=5,$page=0)
  {
     if($users_id==null){
          $filter_user="";
        }else{
          $filter_user="(d.discussion_host=".$users_id." OR r.reply_sender=".$users_id.") AND ";
          
        }
				$query= "SELECT d.*, count(r.reply_id) total_reply
									FROM discussion d LEFT JOIN discussion_reply r
									ON d.discussion_id = r.discussion_id 
                  WHERE ".$filter_user."
                  d.is_group=".$is_groups." 
									GROUP BY r.discussion_id  
                  ORDER BY ".$order." 
									LIMIT ".$page.",".$num;
        $i = $this->db->query($query);		
		return ($i->num_rows > 0)? $i->result() : array();
  }
  
  public function total($users_id=null,$is_groups)
  {
     if($users_id==null){
          $filter_user="";
        }else{
          $filter_user="(d.discussion_host=".$users_id." OR r.reply_sender=".$users_id.") AND ";
          
        }
				$query= "SELECT d.*
									FROM discussion d LEFT JOIN discussion_reply r
									ON d.discussion_id = r.discussion_id 
                  WHERE ".$filter_user."
                  d.is_group=".$is_groups." 
									GROUP BY r.discussion_id";
        $i = $this->db->query($query);		
		return ($i->num_rows > 0)? $i->num_rows() : 0;
  }

	public function createDiscussion($discussion_subject,$discussion_topic,$discussion_host,$discussion_creator,$is_group)
	{
		$input = array(	'discussion_subject' => $discussion_subject,
						'discussion_topic' => $discussion_topic, 
						'discussion_host' => $discussion_host, 
						'discussion_creator'=>$discussion_creator,
						'is_group'=>$is_group);
		$this->db->insert('discussion',$input);
	  if($this->db->affected_rows()){
       return $this->db->insert_id();
    }else{
       return false;
    }
	}
	
	public function submitReply($discussion_id,$reply_sender,$reply_text,$parent=0)
	{
		$reply_date=date('Y-m-d H:i:s');
		$input = array(	'discussion_id' => $discussion_id,
						'reply_sender' => $reply_sender, 
						'reply_text' => $reply_text, 
						'parent' => $parent, 
						'reply_date'=>$reply_date);
		$this->db->insert('discussion_reply',$input);
	}
	
	public function get_detail($discussion_id)
	{
		

    $this->db->from("discussion");
		$this->db->where("discussion_id",$discussion_id);
		$this->db->limit(1);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->row() : array();
	}
	
	public function get_reply($discussion_id,$num,$page=0)
	{
		$query=$this->db->query("SELECT a.reply_text, a.reply_sender, a.reply_date, b.users_picture ,a.reply_id,a.promote, c.full_name
									FROM discussion_reply a, users_meta b, users c
									WHERE a.reply_sender = b.users_id and a.reply_sender=c.users_id and a.discussion_id=$discussion_id and a.parent=0 order by a.reply_date desc limit $page,$num
									");
		

		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	public function get_reply_newer($discussion_id,$num,$page=0)
	{
		$query=$this->db->query("SELECT a.reply_text, a.reply_sender, a.reply_date, b.users_picture ,a.reply_id,a.promote, c.full_name
									FROM discussion_reply a, users_meta b, users c
									WHERE a.reply_sender = b.users_id and a.reply_sender=c.users_id and a.discussion_id=$discussion_id and a.parent=0 order by a.reply_date asc limit $page,$num
									");
		

		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	
	public function get_reply_most($discussion_id,$num,$page=0)
	{
		$query=$this->db->query("SELECT a.reply_text, a.reply_sender, a.reply_date, b.users_picture ,a.reply_id,a.promote, c.full_name
									FROM discussion_reply a, users_meta b, users c
									WHERE a.reply_sender = b.users_id and a.reply_sender=c.users_id and a.discussion_id=$discussion_id and a.parent=0 order by a.promote desc limit $page,$num
									");
		

		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	public function total_reply($discussion_id)
	{
		$query=$this->db->query("SELECT reply_id
									FROM discussion_reply
									WHERE discussion_id=$discussion_id and parent=0");
		

		return ($query->num_rows > 0)? $query->num_rows : 0;
	}
	
	public function total_all_reply($discussion_id)
	{
		$this->db->from("discussion_reply");
		$this->db->where("discussion_id",$discussion_id);
		$output=$this->db->count_all_results();

		return $output;
	}
	
	public function getDiscussionGroup($group_id,$page,$num=5)
	{
		$end=$page*$num;
		$start=(($page-1)*$num);
		$query=$this->db->query("SELECT a.discussion_id,a.discussion_subject,a.discussion_topic,a.discussion_creator, 		b.users_picture
									FROM discussion a, users_meta b
									WHERE a.discussion_creator = b.users_id and a.discussion_host=$group_id and a.is_group=1 limit $start,$num");
		
		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	public function get_reply_children($discussion_id,$parent)
	{
        $query=$this->db->query("SELECT a.reply_text, a.reply_sender, a.reply_date, b.users_picture,a.reply_id
									FROM discussion_reply a, users_meta b
									WHERE a.reply_sender = b.users_id and a.discussion_id=$discussion_id and a.parent=$parent order by a.reply_date desc ");
		

		return ($query->num_rows > 0)? $query->result() : array();
	}
	
	public function get_total_promote($reply_id)
	{
		$this->db->from("like");
		$this->db->where("content_id",$reply_id);			
		$this->db->where("is_like",'2');
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function updatePromote($reply_id,$total)
	{
		$data = array(
               'promote' => $total
            );

		$this->db->where('reply_id', $reply_id);
		$this->db->update('discussion_reply', $data); 
	}
	
	public function getMyDiscussion($users_id,$page,$isgroup=1,$num=5)
	{
		$start=(($page-1)*$num);
		$end=$page*$num;
		$this->db->from("discussion");
		$this->db->where("discussion_creator ",$users_id);
		$this->db->limit($end,$start);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function countMyDiscussion($users_id,$isgroup=1)
	{
		$this->db->from("discussion");
		$this->db->where("discussion_creator ",$users_id);
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getPopular($page,$isgroup=1,$num=5)
	{
		
		$end=$page*$num;
		$start=(($page-1)*$num);
		$query=$this->db->query("select a.*,count(b.discussion_id) total_reply from discussion a, discussion_reply b where a.discussion_id=b.discussion_id group by b.discussion_id order by total_reply desc limit $start,$num");
		return $query->result();
	}
	
	public function countPopular($isgroup=1)
	{
		$query=$this->db->query("select a.*,count(b.discussion_id) total_reply from discussion a, discussion_reply b where a.discussion_id=b.discussion_id group by b.discussion_id order by total_reply desc");
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getAll($page,$isgroup=1,$num=5)
	{
		$start=(($page-1)*$num);
		$end=$page*$num;
		$this->db->from("discussion");
		$this->db->orderby('discussion_start ', "desc");
		$this->db->limit($end,$start);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function countAll($isgroup=1)
	{
		$this->db->from("discussion");
		$this->db->orderby('discussion_start ', "desc");
		$output=$this->db->count_all_results();
		return $output;
	}
	
	public function getMyGroupDiscussion($users_id,$page,$isgroup=1,$num=5)
	{
		$start=(($page-1)*$num);
		$end=$page*$num;
		$this->db->from("discussion");
		$this->db->where("discussion_host  ",$users_id);
		$this->db->where("is_group",1);
		$this->db->order_by("discussion_start desc");
		$this->db->limit($end,$start);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	
}

?>
