<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class experts_model extends Model {

	/**
	 * Holds an array of tables used in
	 * experts_model.
	 *
	 * @var string
	 **/
	public $tables = array();
	public $total;
	public $request;
	public $set;
    public function experts_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');

    }
    
	/**
	 * Function View Expert
	 * 
	 * Get expert list
	 * Take user id to view my expert or somebody expert
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer, integer
	 * @return array
	 * 
	 */
	public function view_experts($user_id,$num=5,$page=0){
		//$end=$page*$num;
		//$start=(($page-1)*$num);
		//$offset = $page-1;
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$expert = $this->tables['friend'];
		$query = "select ".$meta.".*,".$user.".*,users_id_approve from ".$expert." join  ".$user." on users_id = users_id_approve join ".$meta." on ".$meta.".users_id = ".$user.".users_id";
		$query .= " where status='follow' and users_id_request=".$user_id;
		$query .= " order by friends_id desc ";
		$query .= " limit ".$page.",".$num;
		//$query2= "select users_id_request as friend, friends_id, full_name from friendship join users on users_id_request = users_id where users_id_approve =".$user_id;
		//$sql = "(".$query1.") UNION (".$query2.") order by full_name ASC limit ".$page.",".$num;
		//echo $sql;
		$i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->result();
		}else{
			//$this->num = 0;
			return array();
		}
	}
	
	/**
	 * Function Total Experts
	 * 
	 * Take user with user_id and get total experts the user 
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer
	 * @return integer
	 * 
	 */
	public function total_experts($user_id){
		$expert    = $this->tables['friend'];
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$query = "select * from ".$expert;
		$query .= " where status='follow' and users_id_request=".$user_id;
		//echo $sql;
		$i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->num_rows();
		}else{
			//$this->num = 0;
			return 0;
		}
	}
	
	/**
	 * Function View All Experts List
	 * 
	 * Get all experts list 
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param string, integer, integer
	 * @return array
	 * 
	 */
	public function view_all_experts($order="users.users_id",$num=5,$page=0){
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$this->db->select($user.".*");
		$this->db->select($meta.".*");
		$this->db->from($user);
		$this->db->join($meta, $user.'.users_id = '.$meta.'.users_id', 'left');
		$this->db->where($user.".activation_code",'0');
		$this->db->where($meta.".users_role",'expert');
		$this->db->order_by($order,'desc');
		$this->db->limit($num,$page);
		$i = $this->db->get();
		if ($i->num_rows > 0){
		
			return $i->result();
		}else{
			return array();
		}
	}
	
	/**
	 * Function Total All Experts
	 * 
	 * Get total all experts activated
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @return integer
	 * 
	 */
	 public function total_all_experts(){
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$this->db->where($user.".activation_code",'0');
		$this->db->where($meta.".users_role",'expert');
		$this->db->from($user);
		$this->db->join($meta,$user.".users_id=".$meta.".users_id","left");
		return $this->db->count_all_results();
	}
	
	/**
	 * Function Follow Experts
	 * 
	 * Add follow request from $user_request to $user_approve
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer
	 * @return integer
	 * 
	 */
	public function follow_expert($user_approve,$user_request){
		$expert = $this->tables['friend'];
		$now = time();
		$date = unix_to_human($now,true);
		//echo $date;
		$data = array('users_id_request'=>$user_request,
					  'users_id_approve'=>$user_approve,
					  'request_date'=>$date,
					  'approve_date'=>$date,
					  'status'=>'follow'
					  );

		$this->db->insert($expert, $data);
		if($this->db->affected_rows() > 0){
			$id = $this->db->insert_id();	
			return $id;
		}else{
			return 0;
		}
	}
	
	/**
	 * Function Unfollow Experts
	 * 
	 * Function to unfollow $expert by a $follower
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer
	 * @return integer
	 * 
	 */
	public function unfollow($follower,$expert){
		$experts = $this->tables['friend'];
		$query = "users_id_approve = ".$expert." and users_id_request =".$follower."";
		$this->db->where($query);
		$this->db->where("status","follow");

		$this->db->delete($experts);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * Function Is A Follow B
	 * 
	 * Check if A follow expert B
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param bigint, bigint
	 * @return boolean
	 * 
	 */
	public function is_follow($a,$b){
		$experts = $this->tables['friend'];
		$where = "(users_id_approve='".$b."' AND users_id_request='".$a."') AND status='follow'";
		$query = $this->db->where($where)
                	      ->limit(1)
                	      ->get($experts);
                	      
		$result = $query->row();
        
		if ($query->num_rows() !== 1)
		{
		    return false;
		}else{
			//$result = $query->row();
			return true;
		}
	}
	
	public function register($users_id,$proposal,$status){
    $data = array('users_id' => $users_id, 
					  'proposal' => $proposal, 
					  'status'    => $status);
		  
		$this->db->insert("experts_request", $data);
		return ($this->db->affected_rows() > 0) ? true : false;
  }
  
  public function view_follower($expert_id,$num=7,$page=0){
     $user = $this->tables['users'];
		 $meta = $this->tables['users_meta'];
		
     $this->db->select("users_id_request");
     $this->db->select("full_name");
     $this->db->select("users_picture");
     $this->db->from("friendship");
     $this->db->join($user, 'friendship.users_id_request = '.$user.'.users_id', 'left');
     $this->db->join($meta, 'friendship.users_id_request = '.$meta.'.users_id', 'left');
     $this->db->where("users_id_approve",$expert_id);
     $this->db->where("status","follow");
     $this->db->order_by("approve_date",'desc');
		 $this->db->limit($num,$page);
		 $i = $this->db->get();
		 if ($i->num_rows > 0){
			 return $i->result();
  	 }else{
  		 return array();
  	 }
  } 
  
  public function total_follower($expert_id){
     $user = $this->tables['users'];
		 $meta = $this->tables['users_meta'];
		
     $this->db->select("users_id_request");
     $this->db->from("friendship");
     $this->db->where("users_id_approve",$expert_id);
     $this->db->where("status","follow");
		 $i = $this->db->get();
		 if ($i->num_rows > 0){
			 return $i->num_rows;
  	 }else{
  		 return 0;
  	 }
  }
  
  public function view_all_my_experts($user_id){
		//$end=$page*$num;
		//$start=(($page-1)*$num);
		//$offset = $page-1;

		$expert = $this->tables['friend'];
		$query = "select users_id_approve from ".$expert;
		$query .= " where status='follow' and users_id_request=".$user_id;
		//$query2= "select users_id_request as friend, friends_id, full_name from friendship join users on users_id_request = users_id where users_id_approve =".$user_id;
		//$sql = "(".$query1.") UNION (".$query2.") order by full_name ASC limit ".$page.",".$num;
		//echo $sql;
		$i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->result();
		}else{
			//$this->num = 0;
			return array();
		}
	}
}
?>