<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
* friend_model
*/
class friend_model extends Model {

	/**
	 * Holds an array of tables used in
	 * friend_model.
	 *
	 * @var string
	 **/
	public $tables = array();

    public function friend_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');
    }
    
	/**
	 * Function View Friend
	 * 
	 * Take user with user_id, number of limit, and page then get friend list
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer, integer
	 * @return array
	 * 
	 */
	public function view_friend($user_id,$num=5,$page=0){
		//$end=$page*$num;
		//$start=(($page-1)*$num);
		//$offset = $page-1;
		$friend     = $this->tables['friend'];
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$query1 = "select users_id_approve as friend, friends_id, full_name from friendship join users on users_id_approve = users_id where users_id_request =".$user_id." and status='friend'"; 
		$query2= "select users_id_request as friend, friends_id, full_name from friendship join users on users_id_request = users_id where users_id_approve =".$user_id." and status='friend'";
		$sql = "(".$query1.") UNION (".$query2.") order by full_name ASC limit ".$page.",".$num;
		//echo $sql;
		$i = $this->db->query($sql);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->result();
		}else{
			//$this->num = 0;
			return array();
		}
	}
	
	/**
	 * Function Total Friends
	 * 
	 * Take user with user_id and get total friends the user 
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer
	 * @return integer
	 * 
	 */
	public function total_friends($user_id){
		$friend     = $this->tables['friend'];
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$query1 = "select users_id_approve as friend, friends_id, full_name from friendship join users on users_id_approve = users_id where users_id_request =".$user_id." and status='friend'"; 
		$query2= "select users_id_request as friend, friends_id, full_name from friendship join users on users_id_request = users_id where users_id_approve =".$user_id." and status='friend'";
		$sql = "(".$query1.") UNION (".$query2.") order by friends_id";
		//echo $sql;
		$i = $this->db->query($sql);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->num_rows();
		}else{
			//$this->num = 0;
			return 0;
		}
	}
	
	/**
	 * Function View Member List
	 * 
	 * Get member list 
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param string, integer, integer
	 * @return array
	 * 
	 */
	public function view_member($order="users.users_id",$num=5,$page=0){
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$this->db->select($user.".*");
		$this->db->select($meta.".*");
		$this->db->from($user);
		$this->db->join($meta, $user.'.users_id = '.$meta.'.users_id', 'left');
		$this->db->where($user.".activation_code",'0');
		$this->db->where($meta.".users_role",'member');
		$this->db->or_where($meta.".users_role",'participant');
		if($order=="users.users_id"){
			$this->db->where($user.".users_id !=",$this->session->userdata("users_id"));
		}
		$this->db->order_by($order,'desc');
		$this->db->limit($num,$page);
		$i = $this->db->get();
		if ($i->num_rows > 0){
		
			return $i->result();
		}else{
			return array();
		}
	}
	
	/**
	 * Function Total Member
	 * 
	 * Get total member activated
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @return integer
	 * 
	 */
	 public function total_member(){
		$user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$this->db->where($user.".activation_code",'0');
		$this->db->where($meta.".users_role",'member');
		$this->db->or_where($meta.".users_role",'participant');
		$this->db->from($user);
		$this->db->join($meta,$user.".users_id=".$meta.".users_id","left");
		return $this->db->count_all_results();
	}
	
	/**
	 * Function Request Friend
	 * 
	 * Add request from $user_request to $user_approve
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer
	 * @return integer
	 * 
	 */
	public function request_friend($user_approve,$user_request){
		$friend = $this->tables['friend'];
		$now = time();
		$date = unix_to_human($now,true);
		//echo $date;
		$data = array('users_id_request'=>$user_request,
					  'users_id_approve'=>$user_approve,
					  'request_date'=>$date,
					  'status'=>'pending'
					  );

		$this->db->insert($friend, $data);
		if($this->db->affected_rows() > 0){
			$id = $this->db->insert_id();	
			return $id;
		}else{
			return 0;
		}
	}
	
	/**
	 * Function Approve Friend
	 * 
	 * Approve friend from $user_request to $user_approve
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer
	 * @return boolean
	 * 
	 */
	public function approve_friend($user_approve,$user_request){
		$friend = $this->tables['friend'];
		$now = time();
		$date = unix_to_human($now,true);
		//echo $date;
		$data = array('approve_date'=>$date,
					  'status'=>'friend'
					  );
		$this->db->where("users_id_approve",$user_approve);
		$this->db->where("users_id_request",$user_request);
		$this->db->where("status","pending");

		$this->db->update($friend, $data);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * Function Is A Friend B
	 * 
	 * Check if A friend of B
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param bigint, bigint
	 * @return boolean
	 * 
	 */
	public function is_friend($a,$b){
		$friend = $this->tables['friend'];
		$where = "(users_id_approve='".$a."' AND users_id_request='".$b."') OR (users_id_request='".$a."' AND users_id_approve='".$b."')";
		$query = $this->db->where($where)
                	      ->limit(1)
                	      ->get($friend);

        
		if ($query->num_rows() !== 1)
		{
		    return false;
		}else{
			$result = $query->row();
			return $result;
		}
	}
	
	/**
	 * Function Is A Friend B
	 * 
	 * Check if A friend of B
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param bigint, bigint
	 * @return boolean
	 * 
	 */
	public function is_connected($a,$b){
		$friend = $this->tables['friend'];
		$where = "(users_id_approve='".$a."' AND users_id_request='".$b."') OR (users_id_request='".$a."' AND users_id_approve='".$b."')";
		$this->db->where($where);
		$this->db->where("status","follow");
		$this->db->or_where("status","friend");
    $this->db->limit(1);
    $this->db->get($friend);
		if ($query->num_rows() !== 1)
		{
		    return false;
		}else{
			
			return true;
		}
	}
	
	/**
	 * Function Pending List
	 * 
	 * Used for notification, get list of pending friend list, friend need to be approved
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer
	 * @return array
	 * 
	 */
	public function pending_list($user_id,$num=5,$page=0){
		//$end=$page*$num;
		//$start=(($page-1)*$num);
		//$offset = $page-1;
		$friend     = $this->tables['friend'];
		$query = "select users_id_request from friendship where users_id_approve=".$user_id." and status='pending'";
		$query .= " order by request_date limit ".$page.",".$num;
		//echo $query;
		//echo $sql;
		$i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->result();
		}else{
			//$this->num = 0;
			return array();
		}
	}
	
	/**
	 * Function Total Pending List
	 * 
	 * Used for notification, return total friend request
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer
	 * @return integer
	 * 
	 */
	public function total_pending_list($user_id){
		//$end=$page*$num;
		//$start=(($page-1)*$num);
		//$offset = $page-1;
		$friend     = $this->tables['friend'];
		$query = "select users_id_request from friendship where users_id_approve=".$user_id." and status='pending'";
		//echo $query;
		//echo $sql;
		$i = $this->db->query($query);
		return $i->num_rows;
	}
	
	/**
	 * Function Deny Friend
	 * 
	 * $user_approve deny $user_request to be friend
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer
	 * @return boolean
	 * 
	 */
	public function deny($user_request,$user_approve){
		$friend = $this->tables['friend'];

		$this->db->where("users_id_approve",$user_approve);
		$this->db->where("users_id_request",$user_request);
		$this->db->where("status","pending");

		$this->db->delete($friend);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * Function Remove Friend
	 * 
	 * $me remove $friend in friend list
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param integer, integer
	 * @return boolean
	 * 
	 */
	public function remove($me,$friend){
		$friends = $this->tables['friend'];

		$query = "(users_id_approve = ".$me." and users_id_request =".$friend.") or (users_id_request = ".$me." and users_id_approve = ".$friend.")";
		$this->db->where($query);
		$this->db->where("status","friend");

		$this->db->delete($friends);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			return true;
		}else{
			return false;
		}
	}
	
	public function search($key,$num,$page){
	  $user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$this->db->select($user.".*");
		$this->db->select($meta.".*");
		$this->db->from($user);
		$this->db->join($meta, $user.'.users_id = '.$meta.'.users_id', 'left');
		$this->db->where($user.".activation_code",'0');
		$where = "(".$meta.".users_role = 'member' OR ".$meta.".users_role = 'participant' )";
		$this->db->where($where);
    $this->db->like($user.".full_name",$key);
		
		$this->db->limit($num,$page);
		$i = $this->db->get();
		if ($i->num_rows > 0){
		
			return $i->result();
		}else{
			return array();
		}
  
  }
  
  public function total_search($key){
	  $user = $this->tables['users'];
		$meta = $this->tables['users_meta'];
		$this->db->select($user.".*");
		$this->db->select($meta.".*");
		$this->db->from($user);
		$this->db->join($meta, $user.'.users_id = '.$meta.'.users_id', 'left');
		$this->db->where($user.".activation_code",'0');
		$this->db->where($meta.".users_role",'member');
		$this->db->or_where($meta.".users_role",'participant');
    $this->db->like($user.".full_name",$key);

		$i = $this->db->get();
		if ($i->num_rows > 0){
		
			return $i->num_rows();
		}else{
			return 0;
		}
  
  }
	

	
}