<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
* friend_model
*/
class page_model extends Model {

	/**
	 * Holds an array of tables used in
	 * friend_model.
	 *
	 * @var string
	 **/

    public function page_model()
    {
        // Call the Model constructor
        parent::Model();
    }
    
	/**
	 * Function Get Page
	 * 
	 * Select page with a slug
	 *
	 * @author Ratna Mutia http://ratnamutia.com
	 * @param slug
	 * @return array
	 * 
	 */
	public function get_page($slug){
		//$end=$page*$num;
		//$start=(($page-1)*$num);
		//$offset = $page-1;
		$query = "select * from page where page_slug='".$slug."' limit 1";
		//echo $sql;
		$i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->row();
		}else{
			//$this->num = 0;
			return array();
		}
	}
	
	public function get_child($parent){

		$query = "select * from page where parent_page=".$parent;

		$i = $this->db->query($query);
		if($i->num_rows > 0){

			return $i->result();
		}else{

			return array();
		}
	}
	
	/**
	 * Function Add Page
	 * 
	 * Add new page
	 *
	 * @author Ratna Mutia http://whenaldimetratna.com
	 * @param page_name,content
	 * @return boolean
	 * 
	 */
	public function add_page($title,$slug,$content){
		$friend = $this->tables['friend'];
		$now = time();
		$date = unix_to_human($now,true);
		//echo $date;
		$data = array('page_title'=>$title,
					  'page_slug'=>$slug,
					  'page_content'=>$content,
					  'date'=>$date
					  );

		$this->db->insert("page", $data);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * Function Edit Page
	 * 
	 * Edit page
	 *
	 * @author Ratna Mutia http://whenaldimetratna.com
	 * @param slug
	 * @return boolean
	 * 
	 */
	public function edit($id,$slug,$title,$content,$parent){

		//echo $date;
		$data = array('page_slug'=>$slug,
					  'page_title'=>$title,
					  'page_content' =>$content,
					  'parent_page'=>$parent
					  );
		$this->db->where("page_id",$id);

		$this->db->update("page", $data);
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			
			return true;
		}else{
			return false;
		}
	}

	/**
	 * Function Remove Page
	 * 
	 * delete a page
	 *
	 * @author Ratna Mutia http://whenaldimetratna.com
	 * @param integer
	 * @return boolean
	 * 
	 */
	public function delete($id){
		$this->db->where("page_id",$id);
		$this->db->delete("page");
		if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			return true;
		}else{
			return false;
		}
	}
	
	public function update_parent($page_id){
    $data = array("parent_page","0");
    $this->db->update("page");
    $this->db->where("page_id",$page_id);
    if($this->db->affected_rows() > 0){
			//$id = $this->db->insert_id();	
			return true;
		}else{
			return false;
		}
  }
	
	public function get_page_by_id($page_id){
    $query = "select * from page where page_id='".$page_id."' limit 1";
		//echo $sql;
		$i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->row();
		}else{
			//$this->num = 0;
			return array();
		}
  }
  
  public function get_pages($parent=null,$num="all",$page=0){
    if ($parent==null){
      $where = "";
    }else{
       $where = "where parent_page=".$parent;
    }
    if($num=="all"){
        $query = "select * from page ".$where; 
    }else{
    $query = "select * from page ".$where." limit ".$page.",".$num;
    }
    
    $i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->result();
		}else{
			//$this->num = 0;
			return array();
		}
  }
  
  public function total_page($parent=null){
    if ($parent==null){
      $where = "";
    }else{
       $where = "where parent_page=".$parent;
    }
    $query = "select page_id from page ".$where;
    $i = $this->db->query($query);
		if($i->num_rows > 0){
			//$this->num = $i->num_rows;
			return $i->num_rows;
		}else{
			//$this->num = 0;
			return 0;
		}
  }
  
  public function submit($title,$slug,$content,$parent){
    $data = array('page_title'=>$title,
					  'page_slug'=>$slug,
					  'page_content'=>$content,
					  'parent_page' =>$parent
					  );

		$this->db->insert('page', $data);
		$id= 0;
		if($this->db->affected_rows() > 0){
			$id = $this->db->insert_id();
			
			return $id;
		}else{
			return $id;
		}
	}
	
	public function search($key,$num=5,$page=0)
	{

    $this->db->from("page");
		$this->db->like("page_title",$key);
		$this->db->limit($num,$page);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}

  public function total_search($key)
	{
		$this->db->from("page");
		$this->db->like("page_title",$key);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->num_rows() : 0;
	}
  
  
	

	
}