<?php
class user_model extends Model {

    public $tables = array();
	
	public function user_model()
	{
        // Call the Model constructor
		parent::Model();
		$this->tables  = $this->config->item('tables');
	}
    
	public function profile($id)
	{
		$this->db->select('users.users_id, '.
						  'users.full_name, ' .
						  'username,'.
						  'users.email');
		
		$this->columns = $this->config->item('columns');
		if (!empty($this->columns))
		{
		    foreach ($this->columns as $value)
    		{
    			$this->db->select('users_meta.'.$value);
    		}
		}
		$this->db->from("users");
		$this->db->join("users_meta", 'users.users_id = users_meta.users_id', 'left');
	  $this->db->where("users.users_id",$id);
		$i = $this->db->get();	
		if ($i->num_rows > 0){
			return $i->row();	
		}else{
			array();
		}
	}
	public function company_list($id,$is_featured=null,$limit=null)
	{
		$this->db->from("user_company");
	  $this->db->where("users_id",$id);
	  if($is_featured!=null){
	   $this->db->where("is_featured",$is_featured);
	  }
	  //$where = "end_month=present AND end_year=present";
	  //$this->db->or_where($where);
	  if($is_featured!=1){
	   $this->db->order_by("start_month desc","start_year desc");
	  }
	  if($limit!=null){
		$this->db->limit(null);
	    }
		$i = $this->db->get();	
		if ($i->num_rows > 0){
			return $i->result();	
		}else{
			return array();
		}
	}
	public function is_get_current($company_id){
	  $this->db->from("user_company");
	  $this->db->where("users_id",$id);
	  $this->db->where("is_featured",1);
	  //$where = "end_month=present AND end_year=present";
	  //$this->db->or_where($where);
	  $this->db->order_by("start_month desc","end_month desc");
	  $this->db->limit(1);
		$i = $this->db->get();	
		if ($i->num_rows > 0){
			return true;	
		}else{
			return false;
		}
  }
	
	function update_photo($users_id=false,$photo_old=false,$photo_new=false){
		$meta       = $this->tables['users_meta'];
	    if ($users_id === false || $photo_old === false || $photo_new === false)
	    {
	        return false;
	    }
		$data = array('users_picture'=>$photo_new);
		$this->db->where("users_picture",$photo_old);
		$this->db->where("users_id",$users_id);
		$this->db->update($meta, $data);
		if($this->db->affected_rows() > 0){
			return true;
		}else{
			return false;
		}
	}
	
	function update_required($users_id=false,$full_name=false,$interest=false,$company=false){
		$meta = $this->tables['users_meta'];
		$user = $this->tables["users"];
	    if ($users_id === false || $full_name === false || $interest === false || $company === false)
	    {
	        return false;
	    }
		$data = array('full_name'=>$full_name);
		$this->db->where("users_id",$users_id);
		$this->db->update($user, $data);
		$data = array('users_interest'=>$interest, 'users_company'=>$company);
		$this->db->where("users_id",$users_id);
		$this->db->update($meta, $data);
		if($this->db->affected_rows() > 0){
			return true;
		}else{
			return false;
		}
	}
	
	function update_full_name($users_id=false,$full_name=false){
		$user = $this->tables["users"];
	    if (($users_id === false) || ($full_name === false))
	    {
	        return false;
	    }
		$data = array('full_name'=>$full_name);
		$this->db->where("users_id",$users_id);
		$this->db->update($user, $data);
		if($this->db->affected_rows() > 0){
			return true;
		}else{
			return false;
		}
	}
	
	function update_interest($users_id=false,$interest=false){
		$meta = $this->tables['users_meta'];
	  if (($users_id === false) || ($interest === false))
	  {
	    return false;
	  }
	  $data = array('users_interest'=>$interest);
		$this->db->where("users_id",$users_id);
		$this->db->update($meta, $data);
	  if($this->db->affected_rows() > 0){
			return true;
		}else{
			return false;
		}
	}
	
  function update_company($users_id=false,$company_id=false,$company_name=false,$title=false,$start_month=false,$start_year=false,$end_month=false,$end_year=false,$desc=false){
		//$ = $this->tables['users_meta'];
	  if (($users_id==false)||($company_id==false)||($company_name==false)||($title==false)||($start_month==false)||($start_year==false) || ($end_month==false)||($end_year==false)||($desc==false))
	  {
	    //echo $users_id.$company_id.$company_name.$title.$start_month.$start_year.$end_month.$end_year.$desc;
      return false;
	  }
    $data = array('company_name'=>$company_name,'title'=>$title,'start_month'=>$start_month,'start_year'=>$start_year,'end_month'=>$end_month,'end_year'=>$end_year,'description'=>$desc);
		$this->db->where('company_id',$company_id);
		$this->db->where('users_id',$users_id);
		$this->db->update('user_company', $data);
	  if($this->db->affected_rows() > 0){
			//echo "sukses";
      return true;
		}else{
		  //echo "gagal";
			return false;
		}
	}
	
    function update_experience($users_id,$training,$books,$awards,$contributions,$organizations,$edu){
	$data = array('suksesmulia_training'=>$training,'suksesmulia_books'=>$books,'users_award'=>$awards,'users_contribution'=>$contributions,'users_organization'=>$organizations,'users_edu'=>$edu);
	$this->db->where('users_id',$users_id);
	$this->db->update('users_meta', $data);
	if($this->db->affected_rows() > 0){
	    return true;
	}else{
		  //echo "gagal";
	    return false;
	}
  }
  
    function update_expert($users_id,$expert){
	$data = array('expert_title'=>$expert);
	$this->db->where('users_id',$users_id);
	$this->db->update('users_meta', $data);
	if($this->db->affected_rows() > 0){
			//echo "sukses";
	    return true;
	}else{
		  //echo "gagal";
	    return false;
	}
    }  
	
    function insert_company($users_id=false,$company_name=false,$title=false,$start_month=false,$start_year=false,$end_month=false,$end_year=false,$desc=false,$is_featured){
	if (($users_id==false)||($company_name==false)||($title==false)||($start_month==false)||($start_year==false) || ($end_month==false)||($end_year==false))
	{
	    return false;
	}
	$data = array('users_id'=>$users_id,'company_name'=>$company_name,'title'=>$title,'start_month'=>$start_month,'start_year'=>$start_year,'end_month'=>$end_month,'end_year'=>$end_year,'description'=>$desc,'is_featured'=>$is_featured);
	$this->db->insert('user_company', $data);
	if($this->db->affected_rows() > 0){
	    return $this->db->insert_id();
	}else{
	    return false;
	}
    }
	
    function update_personal($users_id=false,$about=false,$sex=false,$birthday=false,$hometown=false,$location=false,$website=false){
	$meta = $this->tables['users_meta'];
      /*if (($users_id === false) || ($about===false) || ($sex===false) || ($birthday===false) || ($hometown===false) || ($location===false) || ($website===false))
      {
	return false;
      } */
	$data = array('users_description'=>$about,'users_sex'=>$sex,'users_birthday'=>$birthday,'users_country'=>$hometown,'users_location'=>$location,'users_website'=>$website);
	$this->db->where("users_id",$users_id);
	$this->db->update($meta, $data);
	if($this->db->affected_rows() > 0){
	    return true;
	}else{
	    return false;
	}
    }
	
    function get_role($user_id){
	    $this->db->select('users_role');
	    $this->db->where("users_id",$user_id);
	    $this->db->from("users_meta");
	    $i = $this->db->get();
	    if ($i->num_rows > 0){
		    $row = $i->row();
		    return $row->users_role;
	    }else{
		    return "";
	    }
    }
	
    function get_current_company($user_id){
	$this->db->where('end_month','present');
	$this->db->where('end_year','present');
	$this->db->from('user_company');
	$get = $this->db->get();
	if ($get->num_rows > 0){
	    return $get->result();
	}else{
	    return array();
	}
    }
  
    function get_meta($meta=array(),$table,$uid){
  
      foreach($meta as $key2){
	$this->db->select($key2);
      }
      $this->db->where("users_id",$uid);
      $this->db->from($table);
      $get = $this->db->get();
      if ($get->num_rows > 0){
			  return $get->row();
		  }else{
			  return array();
		  }
    }
  
    function get_users_id_by_email($email){
	$this->db->select("users_id");
	$this->db->where("email",$email);
	$this->db->from("users");
	$get = $this->db->get();
	if ($get->num_rows > 0){
	    return $get->row();
	}else{
	    return array();
	}
    }
	
    public function get_user_list($role="all",$activation="all",$order="date_register",$num,$page){
	
	if($role!="all"){
	    $this->db->where("users_role",$role);
	}
	if($activation=="registered"){
	    $this->db->where("activation_code!=",0);
	}elseif($activation == "activated"){
	    $this->db->where("activation_code",0);
	}
	$this->db->from("users");
	$this->db->join("users_meta","users.users_id=users_meta.users_id");
	$this->db->limit($num,$page);
	$get = $this->db->get();
	if ($get->num_rows > 0){
	    return $get->result();
	}else{
	    return array();
	}
    }
    
    public function total_users($role="all",$activation="all")
    {
	
	$this->db->select("users_meta.users_id");
	$this->db->from("users");
	$this->db->join("users_meta", "users.users_id = users_meta.users_id", 'left');
	if($role!="all"){
	    $this->db->where("users_role",$role);
	}
	if($activation=="registered"){
	    $this->db->where("activation_code!=",0);
	}elseif($activation == "activated"){
	    $this->db->where("activation_code",0);
	}


	$i = $this->db->get();

	return ($i->num_rows > 0)? $i->num_rows : 0;

    }


}
?>
