<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class wikimed_model extends Model {
    public function wikimed_model()
    {
        // Call the Model constructor
        parent::Model();
		$this->tables  = $this->config->item('tables');
    }
    
    public function recent($cat="all")
    {
		$wikimed = $this->tables['wikimed'];
		$editor = $this->tables['wikimed_editor'];
		$user = $this->tables['users'];
		$this->db->select($wikimed.".wm_title,".
						  $wikimed.".wm_slug,".
						  $wikimed.".wm_id");
		$this->db->select($user.".username");
		$this->db->from($wikimed);
		$this->db->join($editor, $wikimed.'.wm_id = '.$editor.'.wikimed_wm_id', 'left');
		$this->db->join($user, $user.'.users_id = '.$editor.'.editor_id', 'left');
		if (!$cat=="all"){
			$this->db->where($wikimed.'.wm_category',$cat);
		}
		$this->db->where('wm_status','publish');
		$this->db->where('version_number','1.0');
		$this->db->order_by("date_revision","desc");
		$this->db->limit(3);
		
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
    }
	
	public function popular($cat="all")
    {
		$wikimed = $this->tables['wikimed'];
		$editor = $this->tables['wikimed_editor'];
		$user = $this->tables['users'];
		$this->db->select($wikimed.".wm_title,".
						  $wikimed.".wm_slug,".
						  $wikimed.".wm_id");
		$this->db->select($user.".username");
		$this->db->from($wikimed);
		$this->db->join($editor, $wikimed.'.wm_id = '.$editor.'.wikimed_wm_id', 'left');
		$this->db->join($user, $user.'.users_id = '.$editor.'.editor_id', 'left');
		if (!$cat=="all"){
			$this->db->where($wikimed.'.wm_category',$cat);
		}
		$this->db->where('wm_status','publish');
		$this->db->where('version_number','1.0');
		$this->db->order_by("wm_hits desc,comment_count desc");
		$this->db->limit(3);
		
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
    }
	
	public function view_list($limit=10, $order="date_revision desc", $cat="all"){
		$wikimed = $this->tables['wikimed'];
		$editor = $this->tables['wikimed_editor'];
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$category = $this->tables['category'];
		$term_id = ($cat!="all")?$this->category_model->get_id($cat):0;
		$this->db->select_max("date_revision");
		$this->db->group_by("wikimed_wm_id");
		$query = $this->db->get($editor);
		foreach ($query->result_array() as $row)
		{
			$arr[]=$row["date_revision"];
			//echo $row['title'];
			//echo $row['name'];
			//echo $row['email'];
		}
		//select id,name,dat from test1 where dat in (select max(dat) from test1 group by id,name);
		$this->db->select($wikimed.".wm_title,".
						  $wikimed.".wm_slug,".
						  $wikimed.".wm_id");
		$this->db->select($editor.".date_revision,".
						  $editor.".we_id");
		$this->db->select($category.".term_name,".
						  $category.".term_slug");
		//$this->db->select($usermeta.".users_picture");
		$this->db->select($user.".full_name");
		$this->db->from($editor);
		$this->db->join($wikimed, $wikimed.'.wm_id = '.$editor.'.wikimed_wm_id', 'left');
		$this->db->join($user, $user.'.users_id = '.$editor.'.editor_id', 'left');
		//$this->db->join($usermeta, $user.'.users_id = '.$usermeta.'.users_id', 'left');
		$this->db->join($category,$category.'.term_id = '.$wikimed.'.wm_category','left');
		if ($cat!="all"){
			$this->db->where($category.'.term_slug',$cat);
			$this->db->or_where($category.'.cat_parent',$term_id); 
		}
		$this->db->where('wm_status','publish');
		$this->db->where_in($editor.".date_revision",$arr);



		//$this->db->where('version_number','1.0');
		$this->db->order_by($order);
		$this->db->limit($limit);
		
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function view_list2($limit=10, $order="date_revision desc", $cat="all"){
		$wikimed = $this->tables['wikimed'];
		$editor = $this->tables['wikimed_editor'];
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$category = $this->tables['category'];
		$this->db->select($wikimed.".wm_title,".
						  $wikimed.".wm_slug,".
						  $wikimed.".wm_id");
		$this->db->select($editor.".date_revision,".
						  $editor.".we_id");
		$this->db->select($category.".term_name,".
						  $category.".term_slug");
		$this->db->select($usermeta.".users_picture_thumb");
		$this->db->select($user.".username");
		$this->db->from($wikimed);
		$this->db->join($editor, $wikimed.'.wm_id = '.$editor.'.wikimed_wm_id', 'left');
		$this->db->join($user, $user.'.users_id = '.$editor.'.editor_id', 'left');
		$this->db->join($usermeta, $user.'.users_id = '.$usermeta.'.users_id', 'left');
		$this->db->join($category,$category.'.term_id = '.$wikimed.'.wm_category','left');
		$this->db->select($usermeta.".users_picture_thumb");
		if (!$cat=="all"){
			$this->db->where($wikimed.'.wm_category',$cat);
		}
		$this->db->where('wm_status','publish');
		//$this->db->where('version_number','1.0');
		$this->db->order_by("date_revision","desc");
		$this->db->limit($limit);
		
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->result() : array();
	}
	
	public function view_single($id){
		$wikimed = $this->tables['wikimed'];
		$editor  = $this->tables['wikimed_editor'];
		
		$user = $this->tables['users'];
		$usermeta = $this->tables['meta'];
		$category = $this->tables['category'];
		$this->db->select($wikimed.".wm_title,".
						  $wikimed.".wm_slug,".
						  
						  $wikimed.".wm_id,".
						  $wikimed.".wm_abstract,".
						  
						  $wikimed.".comment_count"
						  );
		$this->db->select($editor.".post_revision,".
						  $editor.".date_revision,".
						  $editor.".we_id");
		
		$this->db->select($user.".username");
		$this->db->select($category.".term_name,".
						  $category.".term_slug");
		$this->db->select($usermeta.".users_picture_thumb");
		$this->db->from($editor);
		//$this->db->join($mfile, $multimed.'.pm_id = '.$mfile.'.multimed_pm_id', 'left');
		$this->db->join($wikimed, $wikimed.'.wm_id = '.$editor.'.wikimed_wm_id', 'left');
	
		$this->db->join($user, $user.'.users_id = '.$editor.'.editor_id', 'left');
		$this->db->join($usermeta, $user.'.users_id = '.$usermeta.'.users_id', 'left');
		$this->db->join($category,$category.'.term_id = '.$wikimed.'.wm_category','left');
		$this->db->where($editor.'.we_id',$id);
		$i = $this->db->get();
		return ($i->num_rows > 0)? $i->row() : array();
	}	
	
	public function add($title,$abstract,$content,$category,$publish,$sender)
	{
		$data = array('wm_title'=>$title,
					  'wm_slug' => url_title($title),
					  'wm_abstract'=>$abstract,
					  'wm_category'=>$category,
					  'wm_status'=>$publish
					  );
		$this->db->insert($this->tables['wikimed'], $data);
		$new_wikimed = ($this->db->affected_rows() > 0) ? true : false;
		if ($new_wikimed){
			$data = array('wm_title'=>$title,
						  'wm_slug' => url_title($title),
						  'wm_abstract'=>$abstract,
						  'wm_category'=>$category,
						  'wm_status'=>$publish
			);
		}else{
			return false;
		}
	}
	
	
}
?>